/* $Id: authorized.h,v 1.2 2000/04/06 07:26:52 jm Exp $
 * Routines to handle authorized networks (IP addresses)
 *
 * Dynamic hierarchial IP tunnel
 * Copyright (C) 1998-2000, Dynamics group
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation. See README and COPYING for
 * more details.
 */

#ifndef AUTHORIZED_H
#define AUTHORIZED_H

#include <netinet/in.h>

#include "list.h"

/* structures */

struct authorized_entry {
	struct node node;
	struct in_addr network;
	struct in_addr netmask;
};

/* prototypes */

struct list *authorized_init(void);
int authorized_add(struct list *list, struct in_addr network,
		   struct in_addr netmask);
int authorized_check(struct list *list, struct in_addr addr);
void authorized_destroy(struct list *list);

#endif /* AUTHORIZED_H */
