/* $Id: debug.h,v 1.9 2001/08/05 17:32:51 jm Exp $
 * Header files for debugging functions
 *
 * Dynamic hierarchial IP tunnel
 * Copyright (C) 1998-2001, Dynamics group
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation. See README and COPYING for
 * more details.
 */

#ifndef DEBUG_H
#define DEBUG_H

#include <stdio.h>
#include <stdarg.h>

#ifndef WITH_ARUBALOG
/* DEBUG */

#ifdef NODEBUGMODE
#define DEBUG nodebug
#define DEBUG_HEXDUMP(...)
#else
#define DEBUG debug
#define DEBUG_HEXDUMP debug_hexdump
#endif

#define LOG2(lev, fmt, args...) { DEBUG(DEBUG_INFO, fmt, ## args); \
  syslog(lev, fmt, ## args); }

/* prototypes */
#define CHECK_FORMAT __attribute__ ((format (printf, 2, 3)))
void debug(char flag, char *format, ...) CHECK_FORMAT;
void nodebug(char flag, char *format, ...) CHECK_FORMAT;
void debug_hexdump(char flag, const char *title, const unsigned char *buf,
		   int len);
#else
#include "proxy_debug.h"
#include <syslog.h>
#undef DEBUG_FLAG
#include "syslog/syslogutil.h"
#include "syslog/arubalog.h"

extern int opt_debug;

#define DEBUG_HEXDUMP debug_hexdump
#define LOG2(lev, fmt, args...) { arubaLog(lev, fmt, ## args); }
#define DEBUG(dblvl, fmt, args...) { \
       if(opt_debug) { \
         arubaDebugLog(dblvl, LOG_INFO, fmt, ## args); \
       } \
     } 

#endif

#endif /* DEBUG_H */
