/* $Id: fixed_fd_zero.h,v 1.4 2000/04/06 07:26:53 jm Exp $
 * Fix __FD_ZERO macro that causes problems with gcc-bc
 *
 * Dynamic hierarchial IP tunnel
 * Copyright (C) 1998-2000, Dynamics group
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation. See README and COPYING for
 * more details.
 */

#ifndef FIXED_FD_ZERO_H
#define FIXED_FD_ZERO_H

#ifdef FD_ZERO_FOR_GCC_BC

#if (__GLIBC__ == 2 && __GLIBC_MINOR__ >= 1) || __GLIBC__ > 2
#include <bits/select.h>
#else
#include <selectbits.h>
#endif

#undef __FD_ZERO
#define __FD_ZERO(set)  \
do {                                                                  \
  unsigned int __i;                                                   \
  for (__i = 0; __i < sizeof (__fd_set) / sizeof (__fd_mask); ++__i)  \
    ((__fd_mask *) set)[__i] = 0;                                     \
} while (0)

#endif

#endif /* FIXED_FD_ZERO_H */
