#ifndef MESSAGES_H
#define MESSAGES_H

#include "proxy_types.h"

#define MAX_MESG_SIZE 2048
#define AUTH_PROTO_LEN 10 
#define MOB_RECLEN 20

/* message type common to mm, master and auth */
#define MM_AUT_REQ 0
#define MM_AUT_UPD 1

/* auth message types */
#define MM_AUTH_DONE   2
#define MM_INTER_MOVE  3
#define MM_VLAN_MOVE   4
#define MM_PORT_MOVE   5

/* messages common to mm and master */
#define MM_HAT_REQ     6
#define MM_UPD_TAB     7
#define MM_MOVE_USER   8

typedef struct {
  u_int16_t seq;
  u_int16_t flags;
  u_int16_t opcode;
  u_int16_t iport;
  u_int16_t ivlan;
  char device[INTF_NAME_LEN];
} MMGR_ArubaHeader;


/* authentication message */
typedef struct {
  u_int8_t mtype;
  char mac[ETH_ALEN];
  u_int32_t ip;
  /* ingress vlan and port information */
  u_int16_t vlan;
  u_int16_t port;
  /* tunnel information */
  char tunid[INTF_NAME_LEN];
  /* auth information */
  char user[USER_NAME_LEN];
  char auth_proto[AUTH_PROTO_LEN];
  char mob_record[MOB_RECLEN];
} MMGR_AuthMesg;


/* master message */ 
typedef struct {
  __u8   mtype;  /* message type */
  __u32  switch_ip;
  __u16  vlan;
  __u16  slot;
  __u16  port;
  __u8   mac[MAC_ALEN];
  __u32  ip;
  __u8   resv;
  char   old_user[64];
  __u32  len;
  __u32  cookie_version;
  char   user[USER_NAME_LEN];
} MMGR_MasterMesgHdr;


#endif
