/* $Id: sha1.h,v 1.1 2001/07/12 14:38:09 jm Exp $
 * SHA-1 implementation and interface functions
 *
 * Dynamic hierarchial IP tunnel
 * Copyright (C) 2001, Dynamics group
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation. See README and COPYING for
 * more details.
 */

#ifndef SHA1_H
#define SHA1_H

#include "owntypes.h"

#define SHA1_MAC_LEN 20

typedef struct {
	u32 state[5];
	u32 count[2];
    unsigned char buffer[64];
} SHA1_CTX;

void SHA1Init(SHA1_CTX *context);
void SHA1Update(SHA1_CTX *context, unsigned char *data, u32 len);
void SHA1Final(unsigned char digest[20], SHA1_CTX* context);
void SHA1Transform(u32 state[5], unsigned char buffer[64]);

void sha1_mac(unsigned char *key, unsigned int key_len,
	      unsigned char *data, unsigned int data_len,
	      unsigned char *mac);
void hmac_sha1(unsigned char *key, unsigned int key_len,
	       unsigned char *data, unsigned int data_len,
	       unsigned char *mac);

#endif /* SHA1_H */
