/*
 * include/asm-ppc/malbec_serial.h
 * 
 * Definitions for Motorola SPS Mswitch Test Platform
 *
 * Author: Mark A. Greer
 *         mgreer@mvista.com
 *
 *         Sameer M. Dekate (Malbec Mods)
 *         sdekate@arubanetworks.com 
 *
 * Copyright 2001 MontaVista Software Inc.
 *
 * This program is free software; you can redistribute  it and/or modify it
 * under  the terms of  the GNU General  Public License as published by the
 * Free Software Foundation;  either version 2 of the  License, or (at your
 * option) any later version.
 */

#ifndef __ASMPPC_MALBEC_SERIAL_H
#define __ASMPPC_MALBEC_SERIAL_H

#include <linux/config.h>

#define MALBEC_SERIAL_0		0xFC004500
#define MALBEC_SERIAL_1		0xFC004600

#ifdef CONFIG_SERIAL_MANY_PORTS
#define RS_TABLE_SIZE  64
#else
#define RS_TABLE_SIZE  2
#endif

/* Baud rate for the internal DUART on 8241/8245 processors */
#define BASE_BAUD (100000000 / 16) 

#define STD_COM_FLAGS (ASYNC_SKIP_TEST)

#define STD_SERIAL_PORT_DFNS \
        { 0, BASE_BAUD, MALBEC_SERIAL_0,137,STD_COM_FLAGS,/* ttyS0 */  \
                type: PORT_16550A,                                      \
                xmit_fifo_size: 16,                                     \
		iomem_base: (u8 *)MALBEC_SERIAL_0,			\
		io_type: SERIAL_IO_MEM },                               \
        { 0, BASE_BAUD, MALBEC_SERIAL_1,138,STD_COM_FLAGS,/* ttyS1 */  \
                type: PORT_16550A,                                      \
                xmit_fifo_size: 16,                                     \
		iomem_base: (u8 *)MALBEC_SERIAL_1,			\
		io_type: SERIAL_IO_MEM },

#define SERIAL_PORT_DFNS \
        STD_SERIAL_PORT_DFNS

#endif /* __ASMPPC_MALBEC_SERIAL_H */
