/*
 * arch/ppc/platforms/sap.h
 * 
 * Definitions for Accton SAP Test Platform
 *
 * Author: Mark A. Greer
 *         mgreer@mvista.com
 *
 * Copyright 2000, 2001 MontaVista Software Inc.
 *
 * This program is free software; you can redistribute  it and/or modify it
 * under  the terms of  the GNU General  Public License as published by the
 * Free Software Foundation;  either version 2 of the  License, or (at your
 * option) any later version.
 */

/*
 * Mswitch/SAP uses the CHRP map (Map B).
 */

#ifndef __PPC_PLATFORMS_SAP_H
#define __PPC_PLATFORMS_SAP_H

#define SAP_EUMB_BASE     0xfc000000

/*
 * The mswitch boards have processor modules that either have an 8240 or
 * an MPC107 host bridge on them.  These bridges have an IDSEL line that allows
 * them to respond to PCI transactions as if they were a normal PCI devices.
 * However, the processor on the processor side of the bridge can not reach
 * out onto the PCI bus and then select the bridge or bad things will happen
 * (documented in the 8240 and 107 manuals).
 * Because of this, we always skip the bridge PCI device when accessing the
 * PCI bus.  The PCI slot that the bridge occupies is defined by the macro
 * below.
 */
#define MSWITCH_HOST_BRIDGE_IDSEL     12

void sap_find_bridges(void);

#include <linux/aruba_sap.h>


#endif /* __PPC_PLATFORMS_SAP_H */
