/*
 * include/asm-ppc/sap_serial.h
 * 
 * Definitions for Accton SAP Test Platform
 *
 * Author: Mark A. Greer
 *         mgreer@mvista.com
 *
 * Copyright 2001 MontaVista Software Inc.
 *
 * This program is free software; you can redistribute  it and/or modify it
 * under  the terms of  the GNU General  Public License as published by the
 * Free Software Foundation;  either version 2 of the  License, or (at your
 * option) any later version.
 */

#ifndef __ASMPPC_SAP_SERIAL_H
#define __ASMPPC_SAP_SERIAL_H

#include <linux/config.h>

#define SAP_SERIAL_0		0xfc004500
#define SAP_SERIAL_1		0xfc004600

#ifdef CONFIG_SERIAL_MANY_PORTS
#define RS_TABLE_SIZE  64
#else
#define RS_TABLE_SIZE  2
#endif

/* Baud rate for the internal DUART on 8241/8245 processors */
#define BASE_BAUD (100000000 / 16)  //used to be 133Mhz, fadi

#define STD_COM_FLAGS (ASYNC_SKIP_TEST)

// struct used by serial driver in common/ns16550.c 
#define STD_SERIAL_PORT_DFNS \
        { 0, BASE_BAUD, SAP_SERIAL_0,137,STD_COM_FLAGS,/* ttyS0 */  \
                type: PORT_16550A,                                        \
                xmit_fifo_size: 16,                                       \
		iomem_base: (u8 *)SAP_SERIAL_0,			  \
		io_type: SERIAL_IO_MEM },                                 \
        { 0, BASE_BAUD, SAP_SERIAL_1,138,STD_COM_FLAGS,/* ttyS1 */  \
                type: PORT_16550A,                                        \
                xmit_fifo_size: 16,                                       \
		iomem_base: (u8 *)SAP_SERIAL_1,			  \
		io_type: SERIAL_IO_MEM },

#define SERIAL_PORT_DFNS \
        STD_SERIAL_PORT_DFNS

/*
This is how the serial_state structure (values defined above plug in)
looks like....
struct serial_state {
	int	magic; int	baud_base; unsigned long port; int	irq;
	int	flags; int	hub6;      int	type;          int	line;
	int	revision;   int	xmit_fifo_size; int	custom_divisor;
	int	count; u8	*iomem_base; u16	iomem_reg_shift;
	unsigned short	close_delay; unsigned short	closing_wait; 
	struct async_icount	icount;  struct termios		normal_termios;
	struct termios		callout_termios; int	io_type;
	struct async_struct *info; struct pci_dev	*dev;
};
*/                         
                         
#endif /* __ASMPPC_SAP_SERIAL_H */
