/*
 *  Copyright (c) 2002 Atheros Communications, Inc., All Rights Reserved
 */

/* apcfg.h Access Point specific declarations */

#ifndef __APCFGh
#define __APCFGh

#define keyValid(pKey)  (((pKey)->keyLength == (40/8)) || \
        ((pKey)->keyLength == (104/8)) || \
        ((pKey)->keyLength == (128/8)))

A_BOOL isValidTurboRate(char *pToken);
A_BOOL isBestRate(void);

struct parse_token_s;

char *ftpVenDefCfgFileGet(char *);
int   vendefCliCmdSet(char *, struct parse_token_s *);
int   vendefCliCmdGet(char *, struct parse_token_s *);
int   ftpLoadCfgFileSet(char *, struct parse_token_s *);
char *ftpLoadCfgFileGet(char *);
int   ftpScriptCfgFileSet(char *, struct parse_token_s *);
char *ftpScriptCfgFileGet(char *);
int   ftpVenDefCfgFileSet(char *, struct parse_token_s *);

void flashUpdateInit(void);

int      apCfgInit(void);
int      apCfgSecurityInit(void);
int      apCfgBridgeInit(void);
void     apCfgUpdate(void);
int      apCfgFileWrite(A_BOOL);
A_UINT32 apCfgAclModeGet(void);
A_UINT32 apCfgAclGet(int, int *, char *);
A_UINT32 apCfgAifsGet(void);
A_UINT32 apCfgAuthTypeGet(void);
A_UINT32 apCfgAutoChanSelectGet(void);
A_UINT32 apCfgBeaconIntervalGet(void);
A_UINT32 apCfgCalibrationTimeGet(void);
A_UINT32 apCfgCipherGet(void);
A_UINT16 apCfgCountryCodeGet(void);
A_UINT32 apCfgCwminGet(void);
A_UINT32 apCfgDataRateGet(char *);
A_UINT32 apCfgDataRateIdxGet(void);
A_UINT32 apCfgDataRateValGet(void);
A_UINT32 apCfgDefKeyGet(void);
A_UINT32 apCfgAesDefKeyGet(void);
A_UINT32 apCfgDot1xModeGet(void);
A_BOOL   apCfgDot1xEnabled(void);
A_UINT32 apCfgDtimGet(void);
A_UINT32 apCfgFragThresholdGet(void);
A_UINT32 apCfgFreqSpecGet(void);
A_UINT32 apCfgHostAddrGet(void);
A_UINT32 apCfgGatewayAddrGet(void);
A_UINT32 apCfgIpAddrGet(void);
A_UINT32 apCfgIpMaskGet(void);
A_UINT32 apCfgKeyGet(int, char *);
A_UINT32 apCfgLimitTxRetriesGet(void);
A_UINT32 apCfgLoginGet(char *);
A_UINT32 apCfgOutdoorChanEnabledGet(void);
A_UINT32 apCfgQosGet(void);
A_UINT32 apCfgPasswordGet(char *);
A_UINT32 apCfgPowerGet(void);
A_UINT32 apCfgRadioChannelGet(void);
char *apCfgRadiusSecretGet(void);
char *apCfgRadiusServerGet(void);
A_UINT16 apCfgRadiusPortGet(void);
char *apCfgNameServerAddrGet(void);
char * apCfgNameDomainGet(void);
A_UINT32 apCfgRateCtrlGet(void);
A_UINT32 apCfgRtsThresholdGet(void);
A_UINT32 apCfgSetSnmpCmntyGet(char *);
A_UINT32 apCfgSnmpCmntyGet(char *);
A_UINT32 apCfgSsidGet(char *);
A_UINT32 apCfgSysNameGet(char *);
A_UINT32 apCfgSwRetryModeGet(void);
A_BOOL   apCfgTelnetEnabledGet(void);
A_UINT32 apCfgTurboModeGet(void);
A_UINT32 apCfgWepModeGet(void);
A_BOOL   apCfgWdgCheckGet(void);

int apCfgKeyDel(int);
A_UINT32 apCfgAclDel(int *, char *);
A_UINT32 apCfgAclFind(int *, char *);
A_UINT32 apCfgAclSet(char *, int, char *);
A_UINT32 apCfgAclModify(int slot, int flag, int key);
void apCfgAclModeSet(int);
void apCfgAuthTypeSet(int);
void apCfgAutoChanSelectSet(int);
void apCfgBeaconIntervalSet(int);
void apCfgCountryCodeSet(int v);
void apCfgDataRateSet(char *p);
void apCfgDefKeySet(int);
void apCfgDefAesKeySet(int);
void apCfgDtimSet(int);
void apCfgDot1xModeSet(int);
void apCfgFragThresholdSet(int);
void apCfgFreqSpecSet(int);
void apCfgFtpScriptGet(char *pHostname, char *pUsername, char *pPassword,
                       char *pImagepath,char *pImagename, char *pLocalfile,
                       short *pFlag);
void apCfgFtpLoadSet(char *pHostname, char *pUsername, char *pPassword,
                     char *pImagepath, char *pImagename, char *pLocalfile,
                     short *pFlag);
void apCfgFtpLoadGet(char *pHostname, char *pUsername, char *pPassword,
                     char *pImagepath, char *pImagename, char *pLocalfile,
                     short *pFlag);
void apCfgFtpScriptSet(char *,char *,char *,char *,char *,char *,short *);
void apCfgFtpVenDefGet(char *,char *,char *,char *,char *);
void apCfgHostAddrSet(A_UINT32);
void apCfgGatewayAddrSet(A_UINT32);
void apCfgIpAddrSet(A_UINT32);
void apCfgIpMaskSet(A_UINT32);
int  apCfgKeySet(int, int, char *);
void apCfgLoginSet(char *);
void apCfgNameServerSet(char *);
void apCfgNameDomainSet(char *);
void apCfgPasswordSet(char *);
void apCfgPowerSet(int);
void apCfgOutdoorChanEnabledSet(int);
void apCfgQosSet(int);
void apCfgRadioChannelSet(int);
void apCfgRadioChannelSetNow(int);
void apCfgRadiusPortSet(int);
void apCfgRadiusSecretSet(char *);
void apCfgRadiusServerSet(char *);
void apCfgRegDomSet(char *);
void apCfgRtsThresholdSet(int);
void apCfgSsidSet(char *);
void apCfgSysNameSet(char *p);
void apCfgTelnetModeSet(int);
void apCfgTurboModeSet(int);
void apCfgVlanDelSet(int);
void apCfgVlanSet(int, unsigned short);
void vlanSetCipher(void);
void apCfgWepModeSet(int);
void apCfgCipherSet(int v);
int vlanConfigCipher(void);
int keyDelete (int, int);

void cliChanListGet(int *pChanList, int *chanNum, int maxListSize);
int apCfgRateListGet(char *pRate, int idx);
A_UINT32 cliAgingPeriodGet(void);

void verHttpPrint(char *);
int runFtpScriptRestore(void);
int runFtpScriptHandler(int, int);

void RateCtrlRtsCtsEnable(int v);
int  RateCtrlIsRtsCtsEnabled(void);
A_BOOL apCfgRtsCtsEnable(void);

#endif /* __APCFGh */
