/*
 * Copyright  2000-2002 Atheros Communications, Inc.,  All Rights Reserved.
 *
 * Defines exported routines from ar5211Misc.c
 *
 * $Id: //depot/sw/releases/2.0.1/src/hal/ar5211/ar5211Misc.h#4 $
 */

#ifndef _AR5211_MISC_H_
#define _AR5211_MISC_H_

#include "linuxdrv.h"

#ifdef _cplusplus
extern "C" {
#endif

A_STATUS
ar5211SetRetries(WLAN_DEV_INFO *pDev, A_UINT32 limitTxRetries);

A_STATUS
ar5211SetQos(WLAN_DEV_INFO *pDev, A_UINT32 cwminQos, A_UINT32 aifs);

A_STATUS
ar5211EepromRead(WLAN_DEV_INFO *pDev, A_UINT32 offset, A_UINT16 *data);

A_STATUS
ar5211SetRegulatoryDomain(WLAN_DEV_INFO *pDev, A_UINT16 regDomain);

A_STATUS
ar5211GetMacAddr(WLAN_DEV_INFO *pDev, WLAN_MACADDR *mac);

void
ar5211SetLedState(WLAN_DEV_INFO	*pDev, A_BOOL bConnected);

void
ar5211EnableRfKill(WLAN_DEV_INFO *pDev);

A_UINT32
ar5211GpioGet(WLAN_DEV_INFO *pDev, A_UINT32 gpio);

void
ar5211Gpio0SetIntr(WLAN_DEV_INFO *pDev, A_UINT32 ilevel);

int
ar5211AntennaGet(WLAN_DEV_INFO *pDev);

void
ar5211WriteAssocid(WLAN_DEV_INFO *pDev, WLAN_MACADDR *bssid, A_UINT16 assocId, A_UINT16 timOffset);

void
ar5211SetStaBeaconTimers(WLAN_DEV_INFO *pDev, A_UINT32 tsf, A_UINT32 dtim_count, A_UINT32 cfp_count);

void
ar5211GetTsf(WLAN_DEV_INFO *pDev, WLAN_TIMESTAMP *tsf);

void
ar5211ResetTsf(WLAN_DEV_INFO *pDev);

void
ar5211SetAdhocMode(WLAN_DEV_INFO *pDev);

A_UINT16
ar5211GetRegDmn(WLAN_DEV_INFO *pDev);

A_BOOL
ar5211GetRfKill(WLAN_DEV_INFO *pDev);

A_BOOL
ar5211GetTurboDisable(WLAN_DEV_INFO *pDev);

A_BOOL
ar5211GetChannelEdges(WLAN_DEV_INFO *pDev, A_UINT16 channelFlags, A_UINT16 *pLowChannel, A_UINT16 *pHighChannel);

A_UINT32
ar5211GetMaxTurboRate(void);

A_UINT32
ar5211GetRandomSeed(WLAN_DEV_INFO *pDev);

A_BOOL
ar5211DetectCardPresent(WLAN_DEV_INFO *pDev);

void
ar5211UpdateMibCounters(WLAN_DEV_INFO *pDev, A_BOOL bUpdateAll);

A_BOOL
ar5211IsHwAesSupported(WLAN_DEV_INFO *pDev);

A_BOOL
ar5211IsSwAesSupported(WLAN_DEV_INFO *pDev);

void
ar5211EnableHwEncryption(WLAN_DEV_INFO *pDev);

void
ar5211DisableHwEncryption(WLAN_DEV_INFO *pDev);

void
ar5211EnableRadarDetection(WLAN_DEV_INFO *pDev);

void
ar5211DumpRegisters(WLAN_DEV_INFO *pDev);

A_UINT32
ar5211GetCurRssi(WLAN_DEV_INFO *pDev);

A_UINT32
ar5211GetDefAntenna(WLAN_DEV_INFO *pDev);

void
ar5211SetDefAntenna(WLAN_DEV_INFO *pDev, A_UINT32 antenna);

#ifdef _cplusplus
}
#endif

#endif /* _AR5211_MISC_H_ */
