/*
 * Copyright  2000-2002 Atheros Communications, Inc.,  All Rights Reserved.
 *
 * Defines exported routines from ar5211Transmit.c
 *
 * $Id: //depot/sw/releases/2.0.1/src/hal/ar5211/ar5211Transmit.h#1 $
 */

#ifndef _AR5211_Transmit_H_
#define _AR5211_Transmit_H_

#include "linuxdrv.h"

#ifdef _cplusplus
extern "C" {
#endif

A_UINT32
ar5211GetTxDP(WLAN_DEV_INFO *pDev);

void
ar5211SetTxDP(WLAN_DEV_INFO *pDev, A_UINT32 txdp);

A_BOOL
ar5211UpdateTxTrigLevel(WLAN_DEV_INFO *pDev, A_BOOL bIncTrigLevel);

void
ar5211StartDmaTransmit(WLAN_DEV_INFO *pDev, A_UINT16 queueTypeMask);

A_BOOL
ar5211IsTxQueueStopped(WLAN_DEV_INFO *pDev, A_UINT16 queueTypeMask);

void
ar5211ClearTransmitFilter(WLAN_DEV_INFO *pDev);

A_BOOL
ar5211GetTransmitFilterIndex(WLAN_DEV_INFO *pDev, A_UINT32 index);

A_UINT32
ar5211GetShortRetryLimit(WLAN_DEV_INFO *pDev);

A_UINT32
ar5211GetLongRetryLimit(WLAN_DEV_INFO *pDev);

/* Descriptor Acess Functions */

void
ar5211SetTxDescHdrLen(ATHEROS_DESC *pDesc, A_UINT16 value);

void
ar5211SetTxDescLongPkt(ATHEROS_DESC *pDesc, A_UINT16 value);

void
ar5211SetTxDescAntModeXmit(ATHEROS_DESC *pDesc, A_UINT16 value);

void
ar5211SetTxDescPktType(ATHEROS_DESC *pDesc, HAL_DESC_PKT_TYPE value);

A_UINT16
ar5211GetTxDescEncryptKeyIndex(ATHEROS_DESC *pDesc);

void
ar5211SetTxDescEncryptKeyIndex(ATHEROS_DESC *pDesc, A_UINT16 value);

void
ar5211SetTxDescRtsDuration(WLAN_DEV_INFO *pDev, ATHEROS_DESC *pDesc, A_UINT16 rateIndex, A_UINT16 controlRate);

void
ar5211SetTxDescNoAck(ATHEROS_DESC *pDesc, A_UINT16 value);

void
ar5211SetTxDescVeol(ATHEROS_DESC *pDesc, A_UINT16 value);

void
ar5211DebugPrintTxDesc(ATHEROS_DESC *pDesc);

#ifdef _cplusplus
}
#endif

#endif /* _AR5211_Transmit_H_ */
