/*
 *  Copyright  2000-2002 Atheros Communications, Inc.,  All Rights Reserved.
 *
 * bufconv.h - Conversion between ATHEROS_DESCs and linux skbs.
 *
 * $Id: //depot/sw/releases/2.0.1/src/include/bufconv.h#1 $
 */

#ifndef __INClinuxbufconvh
#define __INClinuxbufconvh

#include <linux/skbuff.h>
#include "wlandrv.h"

#ifdef __cplusplus
extern "C" {
#endif

/*
 * vxDesc2mBlk - Converts an Atheros descriptor/cluster chain to a linux
 *               skb structure.  
 *
 * RETURNS: NULL if unsuccesful, skb if successful.
 */
struct sk_buff *
vxDescToSkb(WLAN_DEV_INFO *pdevInfo,
             ATHEROS_DESC  *pDesc,      /* 802.3/Ethernet frame */
             A_BOOL	   dup);        /* duplicate the data payload */

/*
 * vxmSkb2Desc - converts linux skb structures to an Atheros Descriptor
 *               chain in 802.3/Ethernet format.  This is done when
 *               accepting frames from the mux.
 *
 *
 * RETURNS: NULL if unsuccesful, pointer to Atheros Descriptor chain on success
 */
ATHEROS_DESC *
vxSkbkToDesc(WLAN_DEV_INFO *pdevInfo, struct sk_buff *skb);

#ifdef __cplusplus
}
#endif

#endif /* __INClinuxbufconvh */
