/*
 *  Copyright (c) 2000-2002 Atheros Communications, Inc., All Rights Reserved
 *
 *  Connects reset Reg Vectors, EEPROM Data, and device Functions to pDev
 *  TODO: check comment for accuracy
 */

#ident "$Id: //depot/sw/releases/2.0.1/src/hal/halUtil.c#2 $"

#include "wlantype.h"
#include "wlandrv.h"  // ONLY needed for PLCP time
#include "halUtil.h"

/**************************************************************
 * reverseBits
 *
 * reverse the bits starting at the low bit for a value of
 * bit_count in size
 * TODO: Someone could optimize this pretty easily
 */
A_UINT32
reverseBits(A_UINT32 val, A_UINT32 bitCount)
{
    A_UINT32    retval = 0;
    A_UINT32    bit;
    A_UINT32    i;

    for (i = 0; i < bitCount; i++) {
        bit = (val >> i) & 1;
        retval = (retval << 1) | bit;
    }

    return retval;
}

A_UINT16
halComputeTxTime(A_UINT32 bitNum, RATE_TABLE_STRUCT *pRateTable, A_UINT16 rateIndex, A_BOOL shortPreamble)
{
    A_UINT32 bitSymbol = pRateTable->info[rateIndex].symBits;
    A_UINT32 txFrameTime;

    if (pRateTable->phyType == PHY_CCK) {
        // CCK 11b frame.
        if (pRateTable->info[rateIndex].rateKbps == 1000) {
            shortPreamble = FALSE;
        }
        // CCK time in microseconds is time for data bits + (preamble+plcp) divided by 2 if short preamble
        txFrameTime = (bitNum * 1000) / pRateTable->info[rateIndex].rateKbps +
                      ((pRateTable->preambleBits + pRateTable->plcpBits) >> (shortPreamble & 1));
    } else {
        txFrameTime = (((bitNum + bitSymbol - 1) / bitSymbol) * 4) + PLCP_TIME;
    }
    return (A_UINT16)txFrameTime;
}
