/*
 * Copyright (c) 2001-2002 Atheros Communications, Inc., All Rights Reserved
 */

/* radardefs.h - DFS and radar detection data structures and definitions */

#ifndef		__INCradarexth
#define		__INCradarexth

#ident  "ACI $Header: //depot/sw/releases/2.0.1/src/include/radarext.h#1 $"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include "wlansme.h"
#include "wlandrv.h"
#include "radardefs.h"

extern A_UINT32	newDuration;
extern A_UINT32	longDuration;
extern A_UINT16 longDurationVal;
extern A_UINT32	modDurNum;
extern A_UINT32 modPifsNum;
extern WLAN_MACADDR	beaconBroadcastAddr;
extern A_BOOL radarReboot;
extern A_UINT32	radarScanTime;
extern A_BOOL	radarDur;
extern A_BOOL	radarPifs;
extern A_UINT32	durCount;
extern A_UINT32	pifsCount;
extern A_SEM_TYPE	radarDataSemId;
extern A_BOOL	newPhyError;
extern EVENT_ARRAY	eArray;
extern A_UINT32    phyErrorCounts[];

void
txDescThrottle(WLAN_DEV_INFO *pdevInfo, A_UINT32 curTxdp);

void
apStopWlan(WLAN_DEV_INFO *pdevInfo);

// radar detection function and data structure declarations.
void
recordRadarEvent(A_UINT32 tStampLow, A_UINT32 tStampHigh);

void
wakeupRadarEventHandler(void);

void
wakeupRadarTxThrottleHandler(void);

void
initRadarDetect(WLAN_DEV_INFO *pDevInfo);

void
hwRadarInit(WLAN_DEV_INFO *pDevInfo);

void
etsiFeaturesEnable(void);

#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif // __INCradarexth
