/*
 *  Copyright 2001-2002 (c) Atheros Communications Inc.
 */

#ident "ACI: $Id: //depot/sw/releases/2.0.1/src/common/swretry.c#1 $"

#ifdef BUILD_AP
#include "vxWorks.h"
#include "wlanext.h"
#include "apmem.h"
#else
#include "hwext.h"
#endif

/*
 * swretry key cache interaction stubs.
 *
 * swretryDestMaskVictimized(pSib) - pSib has had its slot stolen
 * swretryDestMaskFault(pSib, pTxDesc) - pSib has a new slot
 */
void
swretryDestMaskVictimized(SIB_ENTRY *pVictimSib)
{
    ASSERT(pVictimSib->numTxPending == 0);
    pVictimSib->swRetry.needClearDest = TRUE;
}

void
swretryDestMaskFault(SIB_ENTRY *pSib, ATHEROS_DESC *pTxDesc)
{
    if (pTxDesc == NULL) {
        pSib->swRetry.needClearDest = TRUE;             /* async */
    } else {
        pSib->swRetry.needClearDest = FALSE;
        pTxDesc->hwControl.tx.clearDestMask = 1;        /* sync */
    }
}

void
swretryQueueFlush(WLAN_DEV_INFO *pdevInfo, SIB_ENTRY *pSib)
{
    ASSERT(pSib != NULL);

    /* swretry queue is always accessed in context of the txQueue lock */
    A_SEM_LOCK(pdevInfo->txQueue.qSem, WAIT_FOREVER);
    if (pSib->swRetry.qFrames != 0) {
        freeBuffandDescChain(pdevInfo, pSib->swRetry.retryQueue.pDescQueueHead);
        pSib->swRetry.retryQueue.pDescQueueHead =
            pSib->swRetry.retryQueue.pDescQueueTail = NULL;
        pSib->swRetry.qFrames = 0;
    }
    A_SEM_UNLOCK(pdevInfo->txQueue.qSem);

    return;
}
