#include <linux/ptrace.h>


#define MAGIC_VAL 		0xFACE
#define NVRAM_PANIC_ADDRESS 	0xFF001000
#define NUM_OF_PANICS		4
#define PANIC_INFO_SIZE		0x400
#define PANIC_INFO_VER		0

typedef struct _PanicHeader {
	unsigned short Magic;
	unsigned short PanicInfoVer;
	unsigned int CurrentTime;
	unsigned int IsPanic;
	unsigned int LastSyscall;
	unsigned char taskCommand[16];
	unsigned char KernelVersion[64];
} PanicHeader;

typedef struct _regstack {
	struct pt_regs regs;
	unsigned int Stack[(PANIC_INFO_SIZE/4)-(sizeof(struct pt_regs)/4)-(sizeof(PanicHeader)/4)];
}regstack;

typedef struct _PanicInfo {
	char PanicString[32];
	unsigned int sp;
	unsigned int Stack[(PANIC_INFO_SIZE/4)-(32/4)-1-(sizeof(PanicHeader)/4)];
} PanicInfo;

typedef struct _PanicRecord {
	PanicHeader panicHeader;
	union {
		PanicInfo panicInfo;
		regstack regAndStack;
	}u;
} PanicRecord;


