/*
**  s365led.h - This header file contains common definitions
*/

/*
*******************************************************************************
**  Copyright 2003 Integrated Device Technology, Inc.
**  All Rights Reserved
*******************************************************************************
*/

#ifndef __S365LED__
#define __S365LED__

/*
** following few lines define a macro DISPLAY
** which is used to write a set of 4 characters
** onto the EB365 LED.
*/

#define GPIO_BASE     PHYS_TO_K1(0x18048000)

#define LED_BASE      PHYS_TO_K1(0x0C000000)
#define LED_DIGIT0    0x3
#define LED_DIGIT1    0x2
#define LED_DIGIT2    0x1
#define LED_DIGIT3    0x0

#define DISPLAY(d0, d1, d2, d3)     \
        li    t6, LED_BASE                    ;\
        li    t7, (d0) & 0xff                 ;\
        sb    t7, LED_DIGIT0(t6)              ;\
        li    t7, (d1) & 0xff                 ;\
        sb    t7, LED_DIGIT1(t6)              ;\
        li    t7, (d2) & 0xff                 ;\
        sb    t7, LED_DIGIT2(t6)              ;\
        li    t7, (d3) & 0xff                 ;\
        sb    t7, LED_DIGIT3(t6)

#endif
