/*
 * reset.c 
 *
 *             Who                                      When                  What
 *
 * P. Sadik (Pallathu.Sadik@idt.com)                  July2803            Original form
 */
#include <linux/init.h>
#include <linux/mm.h>
#include <linux/sched.h>
#include <linux/irq.h>
#include <asm/bootinfo.h>
#include <asm/io.h>
#include <linux/ioport.h>
#include <asm/mipsregs.h>
#include <asm/pgtable.h>
#include <linux/mc146818rtc.h>	/* for rtc_ops, we fake the RTC */
#include <asm/reboot.h>
#include <asm/addrspace.h>     /* for KSEG1ADDR() */
#include <asm/rc32438/rc32438.h>
#include <asm/rc32438/pci.h> 
#include <asm/rc32438/pciacacia.h> 
#include <asm/rc32438/eth.h> 

void idt_reset(void)
{

  set_cp0_status((ST0_BEV | ST0_ERL));
  set_cp0_config(CONF_CM_UNCACHED);
  flush_cache_all();
  write_32bit_cp0_register(CP0_WIRED, 0);

  /* Errata item #13 */

  *((volatile u32 *)KSEG1ADDR(0x18080000)) = 0x0;
  *((volatile u32 *)KSEG1ADDR(0x18080018)) = 0x0;
  *((volatile u32 *)KSEG1ADDR(0x18080024)) = 0x0;
  *((volatile u32 *)KSEG1ADDR(0x18080030)) = 0x0;
  *((volatile u32 *)KSEG1ADDR(0x1808003c)) = 0x0;

  /* Reset*/
  *((volatile u32 *)KSEG1ADDR(0x18008000)) = 0x80000001;
}
