/* #include "stdafx.h" */
#include "./h/api.h"

#define   TRUE        1
#define   FALSE       0
#define   NULL        0

extern unsigned int rsctrle( char *, unsigned int, unsigned int ) ;


/*
 * 
 */
unsigned int ADSL_getVersion(struct T_swVersion* p_swVersion)
{
    char status[1];
    char versions[2];
    bool inshowtime = 0;
    bool readstatusok;
    bool readversionsok;
    unsigned int returnvalue;
   
    /* check whether modem in showtime */
    if((readstatusok = rdctrle(status,CTEAD_MODEM_STATUS,1)))
	{
	    inshowtime = (status[0]==MODEM_STATUS_UP);
	}

   /* read far end and near end versions */
   if( (readversionsok = rdctrle(versions,CTEAD_RVERSION_NEAR_END,2) )) {
      p_swVersion->near_end = (unsigned char)versions[0];
      p_swVersion->far_end = inshowtime?(unsigned char)versions[1]:-1;
   }

   /* return C_CONF_DATA_ACK if all ok, C_CONF_DATA_REJ if comms */
   /* ok but modem not in showtime, C_CONF_DATA_COMMPROBLEM if   */
   /* comms not ok */
   if( !readstatusok || !readversionsok ) 
      returnvalue = C_CONF_DATA_COMMPROBLEM;
   else {
      if( !inshowtime ) 
         returnvalue = C_CONF_DATA_REJ;
      else 
         returnvalue = C_CONF_DATA_ACK;
   }

   return returnvalue;
}



/*
 * 
 */
unsigned int ADSL_getVendorId(struct T_VendorId * p_VendorId)
{
   char status[1];
   char vendorids[4];
   bool readstatusok = 0;
   bool inshowtime =0;
   bool readvendoridsok =0;
   unsigned int returnvalue;
   
   /* check whether modem in showtime */
   if( (readstatusok = rdctrle(status,CTEAD_MODEM_STATUS,1))) {
      inshowtime = (status[0]==MODEM_STATUS_UP);
   }

   /* read far end and near end vendor ids */
   if ( (readvendoridsok = rdctrle(vendorids,CTEAD_RVENDOR_NEAR_END_LSB,4))) {
      unsigned short lsb, msb;
      /* first cast necessary */
      lsb = (unsigned short)((unsigned char)vendorids[0]);
      msb = (unsigned short)((unsigned char)vendorids[1]);
      p_VendorId->near_end = msb<<8 | lsb;
      /* first cast necessary; */
      lsb = (unsigned short)((unsigned char)vendorids[2]);
      msb = (unsigned short)((unsigned char)vendorids[3]);
      p_VendorId->far_end = inshowtime? msb<<8 | lsb :-1;
   }

   /* return C_CONF_DATA_ACK if all ok, C_CONF_DATA_REJ if comms */
   /* ok but modem not in showtime, C_CONF_DATA_COMMPROBLEM if   */
   /* comms not ok */
   if(!readstatusok || !readvendoridsok) 
      returnvalue = C_CONF_DATA_COMMPROBLEM;
   else {
      if( !inshowtime ) 
         returnvalue = C_CONF_DATA_REJ;
      else 
         returnvalue = C_CONF_DATA_ACK;
   }
   return returnvalue;
}



/*
 * read controller SW version bytes
 */
unsigned int ADSL_get_controller_SWVersion(struct T_Controller_SW_version* p_CtrlrSWVersion)
{ 
   char swversionbytes[2];
   bool readok;
   unsigned int returnvalue;

   if(( readok = rdctrle(swversionbytes,CTEAD_CONTROLLER_SW_VERSION,2)) ){
      unsigned char maskuppernibble = 0x0F;
      p_CtrlrSWVersion->number3 = (unsigned char)swversionbytes[0] & 
                                  maskuppernibble;
      p_CtrlrSWVersion->number2 = (unsigned char)swversionbytes[1] &    
                                  maskuppernibble;
      p_CtrlrSWVersion->number1 = (unsigned char)swversionbytes[1]>>4 & 
                                  maskuppernibble;
   }
   /* return C_CONF_DATA_ACK if all ok, C_CONF_DATA_REJ if comms */
   /* ok but modem not in showtime, C_CONF_DATA_COMMPROBLEM if   */
   /* comms not ok */
   if(!readok) 
      returnvalue = C_CONF_DATA_COMMPROBLEM;
   else 
      returnvalue = C_CONF_DATA_ACK;

   return returnvalue;
}



/*
 *
 */
unsigned int ADSL_sendDMTEngineInfoCommand()
{
   bool commerror = FALSE;
   unsigned int returnvalue;

   /* write address and length of memory to be read */
   {
      unsigned int tempint = SACHEM_VERSION_ADDRESS;
      char putdata[6];

      putdata[0] = (char)(tempint%256); 
      tempint = tempint/256;
      putdata[1] = (char)(tempint%256); 
      tempint = tempint/256;
      putdata[2] = (char)(tempint%256); 
      tempint = tempint/256;
      putdata[3] = (char)(tempint%256);
      putdata[4] = (char)SACHEM_VERSION_LENGTH;
      putdata[5] = (char)0;
      if(!wrctrle(putdata,BLCKBADDRREG,6))
         commerror = TRUE;
   }

   /* write opcode for Modem_Load_Block */
   if( !commerror ) {
      char putdata[1];
      putdata[0] = (char)MODEM_LOAD_BLOCK;
      if( !wrctrle(putdata,TXCOMMANDREG,1) )
         commerror = TRUE;
   }

   /* return C_CONF_DATA_ACK if all ok, C_CONF_DATA_COMMPROBLEM */
   /* if comms not ok unsigned int returnvalue;                 */
   if( commerror ) 
      returnvalue  =  C_CONF_DATA_COMMPROBLEM;
   else 
      returnvalue = C_CONF_DATA_ACK;

   return returnvalue;
}



/*
 *
 */
unsigned int ADSL_getDMTEngineInfo(struct T_DMTEngineInfo* pinfo)
{
   bool commerror = FALSE;
   char getdata[2];
   unsigned int returnvalue;

   if( rdctrle(getdata,BLCKDATAREG,2) ) {
      unsigned short lsb, msb;
      lsb = (unsigned short)((unsigned char)getdata[0]);
      msb = (unsigned short)((unsigned char)getdata[1]);
      pinfo->version = msb<<8 | lsb;
   }
   else 
      commerror=TRUE;

   /* return C_CONF_DATA_ACK if all ok, C_CONF_DATA_COMMPROBLEM if */
   /* comms not ok */
   if (commerror) 
      returnvalue = C_CONF_DATA_COMMPROBLEM;
   else 
      returnvalue = C_CONF_DATA_ACK;

   return returnvalue;
}



/*
 * write opcode for Modem_Load_Block
 */
unsigned int ADSL_sendITUVendorIDInfoCommand(bool nearnotfar)
{
   bool commerror = FALSE;
   unsigned int returnvalue;

   if( !commerror ) {
      char putdata[1];
      putdata[0] = (char)(nearnotfar ? GET_NEAR_ITU_VENDOR_ID 
                                     : GET_FAR_ITU_VENDOR_ID);
      if( !wrctrle(putdata,TXCOMMANDREG,1) )
         commerror = TRUE;
   }

   /* return C_CONF_DATA_ACK if all ok, C_CONF_DATA_COMMPROBLEM if */
   /* comms not ok */
   if( commerror ) 
      returnvalue = C_CONF_DATA_COMMPROBLEM;
   else 
      returnvalue = C_CONF_DATA_ACK;

   return returnvalue;
}



/*
 *
 */
unsigned int ADSL_getITUVendorIDInfo(struct T_ADSL_Requested_Info* pinfo)
{
   bool commerror = FALSE;
   char getdata[9];
   unsigned int returnvalue;

   if(rdctrle(getdata,CTEAD_ADSL_REQUESTED_INFO_0,9)) {
      pinfo->adsl_requested_info_0 = (unsigned char)getdata[0];
      pinfo->adsl_requested_info_1 = (unsigned char)getdata[1];
      pinfo->adsl_requested_info_2 = (unsigned char)getdata[2];
      pinfo->adsl_requested_info_3 = (unsigned char)getdata[3];
      pinfo->adsl_requested_info_4 = (unsigned char)getdata[4];
      pinfo->adsl_requested_info_5 = (unsigned char)getdata[5];
      pinfo->adsl_requested_info_6 = (unsigned char)getdata[6];
      pinfo->adsl_requested_info_7 = (unsigned char)getdata[7];
      pinfo->adsl_requested_info_8 = (unsigned char)getdata[8];
   }
   else 
      commerror = TRUE;

   /* return C_CONF_DATA_ACK if all ok, C_CONF_DATA_COMMPROBLEM if */
   /* comms not ok */
   if (commerror) 
      returnvalue = C_CONF_DATA_COMMPROBLEM;
   else 
      returnvalue = C_CONF_DATA_ACK;

   return returnvalue;
}



/*
 * write opcode for Modem_Load_Block
 */
unsigned int ADSL_send_getoperationalmode_InfoCommand(void)
{
   bool commerror = FALSE;
   unsigned int returnvalue;

   if( !commerror ) {
      char putdata[1];
      putdata[0] = (char)(GET_OPERATIONAL_MODE);
      if( !wrctrle(putdata,TXCOMMANDREG,1) )
         commerror = TRUE;
   }

   /* return C_CONF_DATA_ACK if all ok, C_CONF_DATA_COMMPROBLEM if */
   /* comms not ok */
   if( commerror ) 
      returnvalue = C_CONF_DATA_COMMPROBLEM;
   else 
      returnvalue = C_CONF_DATA_ACK;

   return returnvalue;
}



/*
 *
 */
unsigned int ADSL_getoperationalmode_Info(struct T_ADSL_Requested_Info*pinfo)
{
   bool commerror = FALSE;
   char getdata[1];
   unsigned int returnvalue;

   if (rdctrle(getdata,CTEAD_ADSL_REQUESTED_INFO_0,1)) {
      pinfo->adsl_requested_info_0 = (unsigned char)getdata[0];
   }
   else 
      commerror=TRUE;

   /* return C_CONF_DATA_ACK if all ok, C_CONF_DATA_COMMPROBLEM if */
   /* comms not ok */
   if( commerror )
      returnvalue = C_CONF_DATA_COMMPROBLEM;
   else 
      returnvalue = C_CONF_DATA_ACK;

   return returnvalue;
}



/*
 * offset in words
 */
unsigned int ADSL_sendGabaritInfoCommand(unsigned int offset)
{
   bool commerror = FALSE;
   unsigned int returnvalue;

   /* write address and length of memory to be read */
   {
      unsigned int tempint = GABARIT_BASE_ADDRESS+(offset*4);
      char putdata[6];
      putdata[0] = (char)(tempint%256); 
      tempint = tempint/256;
      putdata[1] = (char)(tempint%256); 
      tempint = tempint/256;
      putdata[2] = (char)(tempint%256); 
      tempint = tempint/256;
      putdata[3] = (char)(tempint%256);
      /* GABARIT_BLOCK_LENGTH in words */
      putdata[4] = (char)(GABARIT_BLOCK_LENGTH*4);
      putdata[5] = (char)0;
      if( !wrctrle(putdata,BLCKBADDRREG,6) )
         commerror = TRUE;
   }

   /* write opcode for Modem_Load_Block */
   if( !commerror ) {
      char putdata[1];
      putdata[0] = (char)MODEM_LOAD_BLOCK;
      if( !wrctrle(putdata,TXCOMMANDREG,1) )
         commerror = TRUE;
   }

   /* return C_CONF_DATA_ACK if all ok, C_CONF_DATA_COMMPROBLEM */
   /* if comms not ok */
   if (commerror) 
      returnvalue = C_CONF_DATA_COMMPROBLEM;
   else 
      returnvalue = C_CONF_DATA_ACK;

   return returnvalue;
}



/*
 * offset in words
 */
unsigned int ADSL_getGabaritInfo(struct T_GabaritInfo* pinfo, unsigned int offset) 
{
   bool commerror = FALSE;
   char getdata[D_GABARIT_BLOCK_LENGTH*4];
   unsigned int returnvalue;
   int i;

   /* GABARIT_BLOCK_LENGTH in words */
   if(rdctrle(getdata,BLCKDATAREG,(GABARIT_BLOCK_LENGTH*4))) {
      unsigned int lsb, l2b, m3b, msb;
      for (i = 0; i < GABARIT_BLOCK_LENGTH; i++) {
         lsb = (unsigned int)((unsigned char)getdata[i*4+0]);
         l2b = (unsigned int)((unsigned char)getdata[i*4+1]);
         m3b = (unsigned int)((unsigned char)getdata[i*4+2]);
         msb = (unsigned int)((unsigned char)getdata[i*4+3]);
         pinfo->data[offset+i] = (signed int)(msb<<24 | m3b<<16 | 
                                              l2b<<8 | lsb);
      }
   }
   else 
      commerror = TRUE;

   /* return C_CONF_DATA_ACK if all ok, C_CONF_DATA_COMMPROBLEM if */
   /* comms not ok */
   if( commerror )
      returnvalue = C_CONF_DATA_COMMPROBLEM;
   else 
      returnvalue = C_CONF_DATA_ACK;

   return returnvalue;
}



/*
 * offset in words
 */
unsigned int ADSL_sendLogInfoCommand(unsigned int offset) 
{
   bool commerror = FALSE;
   unsigned int returnvalue = 0;
   /* temporary get-around */
   struct {
      unsigned ltnotnt;
   }*pmaindlgglob = NULL;
   
   /* write address and length of memory to be read */
   {
      unsigned int tempint = (pmaindlgglob->ltnotnt ? LOG_BASE_ADDRESS_LT
                                             :LOG_BASE_ADDRESS_NT)+(offset*4);
      char putdata[6];
      putdata[0] = (char)(tempint%256); 
      tempint=tempint/256;
      putdata[1] = (char)(tempint%256); 
      tempint=tempint/256;
      putdata[2] = (char)(tempint%256); 
      tempint=tempint/256;
      putdata[3] = (char)(tempint%256);
      /* GABARIT_BLOCK_LENGTH in words */
      putdata[4] = (char)(LOG_BLOCK_LENGTH*4); 
      putdata[5]=(char)0;
      if( !wrctrle(putdata,BLCKBADDRREG,6) )
         commerror =TRUE;
   }

   /* write opcode for Modem_Load_Block */
   if( !commerror ) {
      char putdata[1];
      putdata[0] = (char)MODEM_LOAD_BLOCK;
      if( !wrctrle(putdata,TXCOMMANDREG,1) )
         commerror = TRUE;
   }

   /* return C_CONF_DATA_ACK if all ok, C_CONF_DATA_COMMPROBLEM if */
   /* comms not ok */
   if( commerror )
      returnvalue = C_CONF_DATA_COMMPROBLEM;
   else 
      returnvalue = C_CONF_DATA_ACK;

   return returnvalue;

}



/*
 * offset in words
 */
unsigned int ADSL_sendLogInfoCommand2(unsigned int offset, unsigned int baseaddress)
{
   bool commerror = FALSE;
   unsigned int returnvalue;

   /* write address and length of memory to be read */
   {
      unsigned int tempint = baseaddress+(offset*4);
      char putdata[6];
      putdata[0] = (char)(tempint%256); tempint = tempint/256;
      putdata[1] = (char)(tempint%256); tempint = tempint/256;
      putdata[2] = (char)(tempint%256); tempint = tempint/256;
      putdata[3] = (char)(tempint%256);
      /* GABARIT_BLOCK_LENGTH in words */
      putdata[4] = (char)(LOG_BLOCK_LENGTH*4); 
      putdata[5] = (char)0;
      if( !wrctrle(putdata,BLCKBADDRREG,6) )
         commerror =TRUE;
   }

   /* write opcode for Modem_Load_Block */
   if( !commerror ) {
      char putdata[1];
      putdata[0] = (char)MODEM_LOAD_BLOCK;
      if( !wrctrle(putdata,TXCOMMANDREG,1) )
         commerror = TRUE;
   }

   /* return C_CONF_DATA_ACK if all ok, C_CONF_DATA_COMMPROBLEM if */
   /* comms not ok */
   if (commerror) 
      returnvalue = C_CONF_DATA_COMMPROBLEM;
   else 
      returnvalue = C_CONF_DATA_ACK;

   return returnvalue;
}



/*
 * offset in words
 */
unsigned int ADSL_getLogInfo(struct T_LogInfo* pinfo,unsigned int offset) 
{
   bool commerror = FALSE;
   char getdata[D_LOG_BLOCK_LENGTH*4];
   unsigned int returnvalue;
   int i;

   /* GABARIT_BLOCK_LENGTH in words */
   if (rdctrle(getdata,BLCKDATAREG,(LOG_BLOCK_LENGTH*4))) {
      /* unsigned int lsb,l2b,m3b,msb; */
      for (i = 0; i < LOG_BLOCK_LENGTH; i++) {
         /*lsb = (unsigned int)((unsigned char)getdata[i*4+0]);
           l2b = (unsigned int)((unsigned char)getdata[i*4+1]);
           m3b = (unsigned int)((unsigned char)getdata[i*4+2]);
           msb = (unsigned int)((unsigned char)getdata[i*4+3]);
           pinfo->data[offset+i] = (signed int)(msb<<24 | m3b<<16 | 
                                                l2b<<8 | lsb);
          */
         pinfo->data[4*(offset+i)+0] = getdata[i*4+0];
         pinfo->data[4*(offset+i)+1] = getdata[i*4+1];
         pinfo->data[4*(offset+i)+2] = getdata[i*4+2];
         pinfo->data[4*(offset+i)+3] = getdata[i*4+3];
      }
   }
   else 
      commerror=TRUE;

   /* return C_CONF_DATA_ACK if all ok, C_CONF_DATA_COMMPROBLEM if */
   /* comms not ok */
   if (commerror) 
      returnvalue = C_CONF_DATA_COMMPROBLEM;
   else 
      returnvalue = C_CONF_DATA_ACK;

   return returnvalue;
}



/*
 *
 */
unsigned int LT_ADSL_get_NearEndLineOperData(struct T_LTadslNearEndLineOperData* p_OperData)
{
   char status[1];
   bool commerror = FALSE;
   bool inshowtime = FALSE;
   unsigned int returnvalue;
   int i;

   /* check whether modem in showtime */
   if (rdctrle(status,CTEAD_MODEM_STATUS,1)) {
      inshowtime = (status[0]==MODEM_STATUS_UP);
   }
   else 
      commerror=TRUE;

   /* read LT near end operational data */
   if (!commerror) {
      char getdata[2];

      /* relCapacityOccupation */
      if (rdctrle(getdata,CTEAD_LT_NEAR_RELCAPACITYOCC_UP_LSB,2)) {
         unsigned short lsb, msb;
         lsb = (unsigned short)((unsigned char)getdata[0]);
         msb = (unsigned short)((unsigned char)getdata[1]);
         p_OperData->relCapacityOccupationUpstr = msb<<8 | lsb;
      }
      else 
         commerror = TRUE;
   }

   if (!commerror) {
      char getdata[2];

      /* attainable bitrate */
      if (rdctrle(getdata,CTEAD_LT_NEAR_ATTAINABLE_BITRATE_LSB,2)) {
         unsigned short lsb, msb;
         lsb = (unsigned short)((unsigned char)getdata[0]);
         msb = (unsigned short)((unsigned char)getdata[1]);
         p_OperData->attainableBitrate = msb<<8 | lsb;
      }
      else commerror = TRUE;
   }

   if (!commerror) {
      char getdata[1];
      /* noiseMarginUpstr */
      if (rdctrle(getdata,CTEAD_LT_NEAR_NOISEMARGIN_UP,1)) {
         p_OperData->noiseMarginUpstr = (signed char)getdata[0];
      }
      else 
         commerror = TRUE;
   }

   if (!commerror) {
      char getdata[1];
      /* outputpowerdownstream */
      if (rdctrle(getdata,CTEAD_LT_NEAR_OUTPUTPOWER_DN,1)) {
         p_OperData->outputPowerDnstr = (signed char)getdata[0];
      }
      else 
         commerror = TRUE;
   }

   if (!commerror) {
      char getdata[1];
      /* attenuationupstr */
      if (rdctrle(getdata,CTEAD_LT_NEAR_ATTENUATION_UP,1)) {
         p_OperData->attenuationUpstr = (unsigned char)getdata[0];
      }
      else 
         commerror = TRUE;
}

/*   if (!commerror) {
      char* getdata=NULL;
      // carrierLoad
      if (rdctrle(&getdata,CTEAD_LT_NEAR_CARRIER_LOAD,128)) {
         for (int i=0;i<=127;i++)
            p_OperData->carrierLoad[i] = (unsigned char)getdata[i];
      }
      else 
         commerror =TRUE;
   }*/

   if (!commerror) {
      char getdata[64];
      /* carrierLoad */
      if (rdctrle(getdata,CTEAD_LT_NEAR_CARRIER_LOAD,64)) {
         for(i = 0; i <= 63; i++)
            p_OperData->carrierLoad[i] = (unsigned char)getdata[i];
      }
      else 
         commerror = TRUE;
   }
   if (!commerror) {
      char getdata[64];
      /* carrierLoad */
      if (rdctrle(getdata,CTEAD_LT_NEAR_CARRIER_LOAD+64,64)) {
         for(i = 0; i <= 63; i++)
            p_OperData->carrierLoad[i+64] = (unsigned char)getdata[i];
      }
      else 
         commerror = TRUE;
   }

   /* return C_CONF_DATA_ACK if all ok, C_CONF_DATA_REJ if comms */
   /* ok but modem not in showtime, C_CONF_DATA_COMMPROBLEM if   */
   /* comms not ok */
   if (commerror) 
      returnvalue = C_CONF_DATA_COMMPROBLEM;
   else {
      if (!inshowtime) 
         returnvalue = C_CONF_DATA_REJ;
      else 
         returnvalue = C_CONF_DATA_ACK;
   }

   return returnvalue;
}



/*
 *
 */
unsigned int LT_ADSL_get_FarEndLineOperData(struct T_LTadslFarEndLineOperData* p_OperData)
{
   char status[1];
   bool commerror = FALSE;
   bool inshowtime = FALSE;
   unsigned int returnvalue;

   /* check whether modem in showtime */
   if (rdctrle(status,CTEAD_MODEM_STATUS,1)) {
      inshowtime = (status[0]==MODEM_STATUS_UP);
   }
   else 
      commerror = TRUE;

   /* read LT far end operational data */
   if (!commerror) {
      char getdata[2];
      /* relCapacityOccupation */
      if (rdctrle(getdata,CTEAD_LT_FAR_RELCAPACITYOCC_DN_LSB,2)) {
         unsigned short lsb, msb;
         lsb = (unsigned short)((unsigned char)getdata[0]);
         msb = (unsigned short)((unsigned char)getdata[1]);
         p_OperData->relCapacityOccupationDnstr = inshowtime? msb<<8 | lsb:-1;
      }
      else 
         commerror = TRUE;
   }

   if (!commerror) {
      char getdata[2];
      /* attainable bitrate */
      if (rdctrle(getdata,CTEAD_LT_FAR_ATTAINABLE_BITRATE_LSB,2)) {
         unsigned short lsb, msb;
         lsb = (unsigned short)((unsigned char)getdata[0]);
         msb = (unsigned short)((unsigned char)getdata[1]);
         p_OperData->attainableBitrate = inshowtime? msb<<8 | lsb:-1;
      }
     else 
        commerror = TRUE;
   }

   if (!commerror) {
      char getdata[1];
      /* noiseMarginDnstr */
      if (rdctrle(getdata,CTEAD_LT_FAR_NOISEMARGIN_DN,1)) {
         p_OperData->noiseMarginDnstr = inshowtime? (signed char)getdata[0]:-1;
      }
      else 
         commerror = TRUE;
   }

   if (!commerror) {
      char getdata[1];
      /* outputpowerupstream */
      if (rdctrle(getdata,CTEAD_LT_FAR_OUTPUTPOWER_UP,1)) {
         p_OperData->outputPowerUpstr = inshowtime?(signed char)getdata[0]:-1;
      }
      else 
         commerror = TRUE;
   }

   if (!commerror) {
      char getdata[1];
      /* attenuationdnstr */
      if (rdctrle(getdata,CTEAD_LT_FAR_ATTENUATION_DN,1)) {
         p_OperData->attenuationDnstr = inshowtime ? (unsigned char)getdata[0]
                                                   : -1;
      }
      else 
         commerror = TRUE;
   }

   /* return C_CONF_DATA_ACK if all ok, C_CONF_DATA_REJ if comms */
   /* ok but modem not in showtime, C_CONF_DATA_COMMPROBLEM if   */
   /* comms not ok */
   if (commerror) 
      returnvalue = C_CONF_DATA_COMMPROBLEM;
   else {
      if (!inshowtime) 
         returnvalue = C_CONF_DATA_REJ;
      else 
         returnvalue = C_CONF_DATA_ACK;
   }

   return returnvalue;
}



/*
 *
 */
unsigned int NT_ADSL_get_NearEndLineOperData(struct T_NTadslNearEndLineOperData* p_OperData)
{
   bool commerror = FALSE;
   unsigned int returnvalue;

   /* check whether modem in showtime */
   char status[1];
   bool inshowtime = FALSE;

   if (rdctrle(status,CTEAD_MODEM_STATUS,1)) {
      inshowtime = (status[0]==MODEM_STATUS_UP);
   }
   else 
      commerror = TRUE;

   /* read NT near end operational data */
   if (!commerror) {
      char getdata[2];
      /* relCapacityOccupation */
      if (rdctrle(getdata,CTEAD_NT_NEAR_RELCAPACITYOCC_DN_LSB,2)) {
         unsigned short lsb, msb;
         lsb = (unsigned short)((unsigned char)getdata[0]);
         msb = (unsigned short)((unsigned char)getdata[1]);
         p_OperData->relCapacityOccupationDnstr = msb<<8 | lsb;
      }
      else 
         commerror = TRUE;
   }

   if (!commerror) {
      char getdata[1];
      /* noiseMargindnstr */
      if (rdctrle(getdata,CTEAD_NT_NEAR_NOISEMARGIN_DN,1)) {
         p_OperData->noiseMarginDnstr = (signed char)getdata[0];
      }
      else 
         commerror = TRUE;
   }

   if (!commerror) {
      char getdata[1];
      /* outputpowerupstream */
      if (rdctrle(getdata,CTEAD_NT_NEAR_OUTPUTPOWER_UP,1)) {
         p_OperData->outputPowerUpstr = (signed char)getdata[0];
      }
      else 
         commerror = TRUE;
   }

   if (!commerror) {
      char getdata[1];
      /* attenuationdownstr */
      if (rdctrle(getdata,CTEAD_NT_NEAR_ATTENUATION_DN,1)) {
         p_OperData->attenuationDnstr = (unsigned char)getdata[0];
      }
      else 
         commerror = TRUE;
   }

   /* return C_CONF_DATA_ACK if all ok, C_CONF_DATA_REJ if comms */
   /* ok but modem not in showtime, C_CONF_DATA_COMMPROBLEM if   */
   /* comms not ok */
   if (commerror) 
      returnvalue = C_CONF_DATA_COMMPROBLEM;
   else {
      if (!inshowtime) 
         returnvalue = C_CONF_DATA_REJ;
      else 
         returnvalue = C_CONF_DATA_ACK;
   }

   return returnvalue;
}



/*
 *
 */
unsigned int NT_ADSL_get_FarEndLineOperData(struct T_NTadslFarEndLineOperData* p_OperData)
{
   bool commerror = FALSE;
   unsigned int returnvalue;
   int i;

   /* check whether modem in showtime */
   char status[1];
   bool inshowtime = FALSE;
   if (rdctrle(status,CTEAD_MODEM_STATUS,1)) {
      inshowtime = (status[0]==MODEM_STATUS_UP);
   }
   else 
      commerror = TRUE;

   /* read NT far end operational data */
   if (!commerror) {
      char getdata[2];
      /* relCapacityOccupation */
      if (rdctrle(getdata,CTEAD_NT_FAR_RELCAPACITYOCC_UP_LSB,2)) {
         unsigned short lsb, msb;
         lsb = (unsigned short)((unsigned char)getdata[0]);
         msb = (unsigned short)((unsigned char)getdata[1]);
         p_OperData->relCapacityOccupationUpstr = inshowtime? msb<<8 | lsb:-1;
      }
      else 
         commerror = TRUE;
   }

   if (!commerror) {
      char getdata[1];
      /* noiseMarginUpstr */
      if (rdctrle(getdata,CTEAD_NT_FAR_NOISEMARGIN_UP,1)) {
         p_OperData->noiseMarginUpstr = inshowtime?(signed char)getdata[0]:-1;
      }
      else 
         commerror = TRUE;
   }

   if (!commerror) {
      char getdata[1];
      /* outputpowerdownstream */
      if (rdctrle(getdata,CTEAD_NT_FAR_OUTPUTPOWER_DN,1)) {
         p_OperData->outputPowerDnstr = inshowtime?(signed char)getdata[0]:-1;
      }
      else 
         commerror = TRUE;
   }

   if (!commerror) {
      char getdata[1];
      /* attenuationupstr */
      if (rdctrle(getdata,CTEAD_NT_FAR_ATTENUATION_UP,1)) {
         p_OperData->attenuationUpstr = inshowtime ? (unsigned char)getdata[0]
                                                   : -1;
      }
      else 
         commerror = TRUE;
   }

/*   if (!commerror) {
      char* getdata=NULL;
      /xxxx carrierLoad
      if (rdctrle(&getdata,CTEAD_NT_FAR_CARRIER_LOAD,128)) {
         for (i = 0; i <= 127; i++)
            p_OperData->carrierLoad[i] = inshowtime ? (unsigned char)getdata[i]
                                                    : -1;
      }
      else 
         commerror = TRUE;
   } */

   if (!commerror) {
      char getdata[64];
      /* carrierLoad */
      if (rdctrle(getdata,CTEAD_NT_FAR_CARRIER_LOAD,64)) {
         for (i = 0; i <= 63; i++)
            p_OperData->carrierLoad[i] = inshowtime ? (unsigned char)getdata[i]
                                                    : -1;
      }
      else 
         commerror = TRUE;
   }
   if (!commerror) {
      char getdata[64];
      /* carrierLoad */
      if (rdctrle(getdata,CTEAD_NT_FAR_CARRIER_LOAD+64,64)) {
         for (i = 0; i <= 63; i++)
            p_OperData->carrierLoad[i+64] = inshowtime 
                                            ? (unsigned char)getdata[i]
                                            : -1;
      }
      else 
         commerror =TRUE;
   }

   /* return C_CONF_DATA_ACK if all ok, C_CONF_DATA_REJ if comms */
   /* ok but modem not in showtime, C_CONF_DATA_COMMPROBLEM if   */
   /* comms not ok */
   if (commerror) 
      returnvalue = C_CONF_DATA_COMMPROBLEM;
   else {
      if (!inshowtime) 
         returnvalue = C_CONF_DATA_REJ;
      else 
         returnvalue = C_CONF_DATA_ACK;
   }

   return returnvalue;
}



/*
 *
 */
unsigned int ADSL_get_ChannelOperData(struct T_adslChannelOperData* p_OperData)
{
   bool commerror = FALSE;
   unsigned int returnvalue;

   /* check whether modem in showtime */
   char status[1];
   bool inshowtime = FALSE;
   if (rdctrle(status,CTEAD_MODEM_STATUS,1)) {
      inshowtime = (status[0]==MODEM_STATUS_UP);
   }
   else 
      commerror = TRUE;

   /* read channel data */
   if (!commerror) {
      char getdata[8];
      if (rdctrle(getdata,CTEAD_NEAR_INT_CHANNELDATA_LSB,8)) {
         unsigned short lsb, msb;
         lsb = (unsigned short)((unsigned char)getdata[0]);
         msb = (unsigned short)((unsigned char)getdata[1]);
         p_OperData->actualBitrateNearInt = msb<<8 | lsb;
         lsb = (unsigned short)((unsigned char)getdata[2]);
         msb = (unsigned short)((unsigned char)getdata[3]);
         p_OperData->actualBitrateNearFast = msb<<8 | lsb;
         lsb = (unsigned short)((unsigned char)getdata[4]);
         msb = (unsigned short)((unsigned char)getdata[5]);
         p_OperData->actualBitrateFarInt = inshowtime? msb<<8 | lsb:-1;
         lsb = (unsigned short)((unsigned char)getdata[6]);
         msb = (unsigned short)((unsigned char)getdata[7]);
         p_OperData->actualBitrateFarFast = inshowtime? msb<<8 | lsb:-1;
      }
      else 
         commerror = TRUE;
   }

   /* return C_CONF_DATA_ACK if all ok, C_CONF_DATA_REJ if comms */
   /* ok but modem not in showtime, C_CONF_DATA_COMMPROBLEM if   */
   /* comms not ok */
   if (commerror) 
      returnvalue = C_CONF_DATA_COMMPROBLEM;
   else {
      if (!inshowtime) 
         returnvalue = C_CONF_DATA_REJ;
      else 
         returnvalue = C_CONF_DATA_ACK;
   }

   return returnvalue;
}



/*
 *
 */
unsigned int ADSL_def_counter_poll(struct T_adsl_def_counter_set*p_counter_set)
{
   char status[1];
   bool commerror = FALSE;
   bool inshowtime = FALSE;
   unsigned int returnvalue;

   /* check whether modem in showtime */
   if (rdctrle(status,CTEAD_MODEM_STATUS,1)) {
      inshowtime = (status[0]==MODEM_STATUS_UP);
   }
   else 
      commerror=TRUE;

   /* read performance data (counters) */
   if (!commerror) {
      char getdata[24];
      if (rdctrle(getdata,CTEAD_NEAR_FEC_NI_LSB,24)) {
         unsigned short lsb, msb;
         lsb = (unsigned short)((unsigned char)getdata[0]);
         msb = (unsigned short)((unsigned char)getdata[1]);
         p_counter_set->near_end.FecNotInterleaved = msb<<8 | lsb;
         lsb = (unsigned short)((unsigned char)getdata[2]);
         msb = (unsigned short)((unsigned char)getdata[3]);
         p_counter_set->near_end.FecInterleaved = msb<<8 | lsb;
         lsb = (unsigned short)((unsigned char)getdata[4]);
         msb = (unsigned short)((unsigned char)getdata[5]);
         p_counter_set->near_end.CrcNotInterleaved = msb<<8 | lsb;
         lsb = (unsigned short)((unsigned char)getdata[6]);
         msb = (unsigned short)((unsigned char)getdata[7]);
         p_counter_set->near_end.CrcInterleaved = msb<<8 | lsb;
         lsb = (unsigned short)((unsigned char)getdata[8]);
         msb = (unsigned short)((unsigned char)getdata[9]);
         p_counter_set->near_end.HecNotInterleaved = msb<<8 | lsb;
         lsb = (unsigned short)((unsigned char)getdata[10]);
         msb = (unsigned short)((unsigned char)getdata[11]);
         p_counter_set->near_end.HecInterleaved = msb<<8 | lsb;

         lsb = (unsigned short)((unsigned char)getdata[12]);
         msb = (unsigned short)((unsigned char)getdata[13]);
         p_counter_set->far_end.FecNotInterleaved = inshowtime ? msb<<8 | lsb
                                                               : -1;
         lsb = (unsigned short)((unsigned char)getdata[14]);
         msb = (unsigned short)((unsigned char)getdata[15]);
         p_counter_set->far_end.FecInterleaved = inshowtime?msb<<8 | lsb: -1;
         lsb = (unsigned short)((unsigned char)getdata[16]);
         msb = (unsigned short)((unsigned char)getdata[17]);
         p_counter_set->far_end.CrcNotInterleaved = inshowtime ? msb<<8 | lsb
                                                               : -1;
         lsb = (unsigned short)((unsigned char)getdata[18]);
         msb = (unsigned short)((unsigned char)getdata[19]);
         p_counter_set->far_end.CrcInterleaved = inshowtime?msb<<8 | lsb:-1;
         lsb = (unsigned short)((unsigned char)getdata[20]);
         msb = (unsigned short)((unsigned char)getdata[21]);
         p_counter_set->far_end.HecNotInterleaved = inshowtime?msb<<8 | lsb:-1;
         lsb = (unsigned short)((unsigned char)getdata[22]);
         msb = (unsigned short)((unsigned char)getdata[23]);
         p_counter_set->far_end.HecInterleaved = inshowtime?msb<<8 | lsb: -1;
      }
      else 
         commerror = TRUE;
   }

   /* return C_CONF_DATA_ACK if all ok, C_CONF_DATA_REJ if comms */
   /* ok but modem not in showtime, C_CONF_DATA_COMMPROBLEM if   */
   /* comms not ok */
   if (commerror) 
      returnvalue = C_CONF_DATA_COMMPROBLEM;
   else {
      if (!inshowtime) 
         returnvalue = C_CONF_DATA_REJ;
      else 
         returnvalue = C_CONF_DATA_ACK;
   }

   return returnvalue;
}



/*
 *
 */
unsigned int ADSL_def_bitmap_poll(struct T_adsl_def_bitmap_set*p_bitmap_set)
{
   char status[1];
   bool commerror = FALSE;
   bool inshowtime = FALSE;
   unsigned int returnvalue;

   /* check whether modem in showtime */
   if (rdctrle(status,CTEAD_MODEM_STATUS,1)) {
      inshowtime = (status[0]==MODEM_STATUS_UP);
   }
   else 
      commerror = TRUE;

   /* read bitmaps */
   if (!commerror) {
      char getdata[4];
      if (rdctrle(getdata,CTEAD_NEAR_BITMAP_STATUS,4)) {
         p_bitmap_set->near_end.status = (unsigned char)getdata[0];
         p_bitmap_set->far_end.status = inshowtime ? (unsigned char)getdata[1]
                                                   : -1;
         p_bitmap_set->near_end.change = (unsigned char)getdata[2];
         p_bitmap_set->far_end.change = inshowtime ? (unsigned char)getdata[3]
                                                   : -1;
      }
      else 
         commerror = TRUE;
   }

   /* return C_CONF_DATA_ACK if all ok, C_CONF_DATA_REJ if comms */
   /* ok but modem not in showtime, C_CONF_DATA_COMMPROBLEM if   */
   /* comms not ok */
   if (commerror) 
      returnvalue = C_CONF_DATA_COMMPROBLEM;
   else {
      if (!inshowtime) 
         returnvalue = C_CONF_DATA_REJ;
      else 
         returnvalue = C_CONF_DATA_ACK;
   }

   return returnvalue;
}



/*
 *
 */
unsigned int ADSL_get_BER_data(struct T_BERdata_set *p_ber_set)
{
   bool commerror = FALSE;
   unsigned int returnvalue;

   /* read ber fast */
   if (!commerror) {
      char getdata[10];
      if (rdctrle(getdata,CTEAD_ACC_BER_FAST,10)) {
         unsigned int lsb, l2b, m3b, msb;
         lsb = (unsigned short)((unsigned char)getdata[0]);
         msb = (unsigned short)((unsigned char)getdata[1]);
         p_ber_set->berFast.AccumulatedBer = msb<<8 | lsb;
         lsb = (unsigned int)((unsigned char)getdata[2]);
         l2b = (unsigned int)((unsigned char)getdata[3]);
         m3b = (unsigned int)((unsigned char)getdata[4]);
         msb = (unsigned int)((unsigned char)getdata[5]);
         p_ber_set->berFast.NsecValidBer = msb<<24 | m3b<<16 | l2b<<8 | lsb;
         lsb = (unsigned int)((unsigned char)getdata[6]);
         l2b = (unsigned int)((unsigned char)getdata[7]);
         m3b = (unsigned int)((unsigned char)getdata[8]);
         msb = (unsigned int)((unsigned char)getdata[9]);
         p_ber_set->berFast.NsecInvalidBer = msb<<24 | m3b<<16 | l2b<<8 | lsb;
      }
      else 
         commerror = TRUE;
   }

   /* read ber interleaved */
   if (!commerror) {
      char getdata[10];
      if (rdctrle(getdata,CTEAD_ACC_BER_IL,10)) {
         unsigned int lsb, l2b, m3b, msb;
         lsb = (unsigned short)((unsigned char)getdata[0]);
         msb = (unsigned short)((unsigned char)getdata[1]);
         p_ber_set->berInterleaved.AccumulatedBer = msb<<8 | lsb;
         lsb = (unsigned int)((unsigned char)getdata[2]);
         l2b = (unsigned int)((unsigned char)getdata[3]);
         m3b = (unsigned int)((unsigned char)getdata[4]);
         msb = (unsigned int)((unsigned char)getdata[5]);
         p_ber_set->berInterleaved.NsecValidBer = msb<<24 | m3b<<16 | l2b<<8 
                                                          | lsb;
         lsb = (unsigned int)((unsigned char)getdata[6]);
         l2b = (unsigned int)((unsigned char)getdata[7]);
         m3b = (unsigned int)((unsigned char)getdata[8]);
         msb = (unsigned int)((unsigned char)getdata[9]);
         p_ber_set->berInterleaved.NsecInvalidBer = msb<<24 | m3b<<16 
                                                            | l2b<<8 | lsb;
      }
      else 
         commerror = TRUE;
   }

   /* return C_CONF_DATA_ACK if all ok, C_CONF_DATA_REJ if comms */
   /* ok but modem not in showtime, C_CONF_DATA_COMMPROBLEM if   */
   /* comms not ok */
   if (commerror) 
      returnvalue = C_CONF_DATA_COMMPROBLEM;
   else 
      returnvalue = C_CONF_DATA_ACK;

   return returnvalue;
}



/*
 *
 */
unsigned int LT_ADSL_enableModemLine(struct T_adsl_ConfigurationData* configData)
{
   char status[1];
   bool commerror = FALSE;
   bool isdown = FALSE;
   unsigned int returnvalue;
   int i;

   /* check whether modemstatus is down or up */
   if (rsctrle(status,CTEAD_MODEM_STATUS,1)) {
      isdown = (status[0]==MODEM_STATUS_DOWN || status[0]==MODEM_STATUS_UP);
   }
   else 
      commerror = TRUE;

   /* write config data if modem is down or up */
   if (isdown) {
      /* noisemargin */
      if (!commerror) {
         char putdata[6];
         putdata[0] = (char)configData->MinNoiseMarginDnstr;
         putdata[1] = (char)configData->MinNoiseMarginUpstr;
         putdata[2] = (char)configData->MaxAddNoiseMarginDnstr;
         putdata[3] = (char)configData->MaxAddNoiseMarginUpstr;
         putdata[4] = (char)configData->TargetNoiseMarginDnstr;
         putdata[5] = (char)configData->TargetNoiseMarginUpstr;
         if (!wrctrle(putdata,CTEAD_LT_MINNOISEMARGIN_DN,6))
            commerror =TRUE;
      }

      /* power spectral density */
      if (!commerror) {
         char putdata[1];
         putdata[0] = (char)configData->MaxPSDDnstr;
         if (!wrctrle(putdata,CTEAD_LT_MAXPSD_DN,1))
            commerror = TRUE;
      }

      /* aggregate power level */
      if (!commerror)  {
         char putdata[2];
         putdata[0] = (char)configData->MaxAggrPwrLvlDnstr;
         putdata[1] = (char)configData->MaxAggrPwrLvlUpstr;
         if (!wrctrle(putdata,CTEAD_LT_MAXAGGPOWERLEVEL_DN,2))
            commerror = TRUE;
      }

      /* carrier mask */
      if (!commerror) {
         char putdata[32];
         for (i = 0; i <= 31; i++)
            putdata[i] = (char)configData->CarrierMask[i];
         if (!wrctrle(putdata,CTEAD_LT_CARRIERMASK,32))
            commerror = TRUE;
      }

      /* rate adaptation mode */
      if (!commerror) {
         char putdata[2];
         putdata[0] = (char)configData->RAModeDnstr;
         putdata[1] = (char)configData->RAModeUpstr;
         if (!wrctrle(putdata,CTEAD_LT_RAMODE_DN,2))
            commerror =TRUE;
      }

      /* bitrate */
      if (!commerror) {
         char putdata[24];
         putdata[0] = (char)(configData->InterlPlannedBitrateDnstr % 256);
         putdata[1] = (char)(configData->InterlPlannedBitrateDnstr / 256);
         putdata[2] = (char)(configData->InterlPlannedBitrateUpstr % 256);
         putdata[3] = (char)(configData->InterlPlannedBitrateUpstr / 256);
         putdata[4] = (char)(configData->FastPlannedBitrateDnstr % 256);
         putdata[5] = (char)(configData->FastPlannedBitrateDnstr / 256);
         putdata[6] = (char)(configData->FastPlannedBitrateUpstr % 256);
         putdata[7] = (char)(configData->FastPlannedBitrateUpstr / 256);
         putdata[8] = (char)(configData->InterlMinBitrateDnstr % 256);
         putdata[9] = (char)(configData->InterlMinBitrateDnstr / 256);
         putdata[10] = (char)(configData->InterlMinBitrateUpstr % 256);
         putdata[11] = (char)(configData->InterlMinBitrateUpstr / 256);
         putdata[12] = (char)(configData->FastMinBitrateDnstr % 256);
         putdata[13] = (char)(configData->FastMinBitrateDnstr / 256);
         putdata[14] = (char)(configData->FastMinBitrateUpstr % 256);
         putdata[15] = (char)(configData->FastMinBitrateUpstr / 256);
         putdata[16] = (char)(configData->InterlMaxBitrateDnstr % 256);
         putdata[17] = (char)(configData->InterlMaxBitrateDnstr / 256);
         putdata[18] = (char)(configData->InterlMaxBitrateUpstr % 256);
         putdata[19] = (char)(configData->InterlMaxBitrateUpstr / 256);
         putdata[20] = (char)(configData->FastMaxBitrateDnstr % 256);
         putdata[21] = (char)(configData->FastMaxBitrateDnstr / 256);
         putdata[22] = (char)(configData->FastMaxBitrateUpstr % 256);
         putdata[23] = (char)(configData->FastMaxBitrateUpstr / 256);
         if (!wrctrle(putdata,CTEAD_LT_INTERL_PLANNED_BITRATE_DN,24))
            commerror = TRUE;
      }

      /* rate adaptation ratio */
      if (!commerror) {
         char putdata[2];
         putdata[0] = (char)configData->RARatioDnstr;
         putdata[1] = (char)configData->RARatioUpstr;
         if (!wrctrle(putdata,CTEAD_LT_RARATIO_DN,2))
            commerror = TRUE;
      }

      /* rate adaptation shift margin */
      if (!commerror) {
         char putdata[4];
         putdata[0] = (char)configData->RADownshiftMarginDnstr;
         putdata[1] = (char)configData->RADownshiftMarginUpstr;
         putdata[2] = (char)configData->RAUpshiftMarginDnstr;
         putdata[3] = (char)configData->RAUpshiftMarginUpstr;
         if (!wrctrle(putdata,CTEAD_LT_RADOWNSHIFTMARGIN_DN,4))
            commerror = TRUE;
      }

      /* rate adaptation shift interval */
      if (!commerror) {
         char putdata[8];
         putdata[0] = (char)configData->RADownshiftIntervalDnstr;
         putdata[1] = (char)configData->RADownshiftIntervalUpstr;
         /* dummy value */
         putdata[2] = (char)-1;
         /* dummy value */
         putdata[3] = (char)-1;
         putdata[4] = (char)(configData->RAUpshiftIntervalDnstr % 256);
         putdata[5] = (char)(configData->RAUpshiftIntervalDnstr / 256);
         putdata[6] = (char)(configData->RAUpshiftIntervalUpstr % 256);
         putdata[7] = (char)(configData->RAUpshiftIntervalUpstr / 256);
         if (!wrctrle(putdata,CTEAD_LT_RADOWNSHIFTINTERVAL_DN,8))
            commerror =TRUE;
      }

      /* max interleaved channel delay */
      if (!commerror) {
         char putdata[2];
         putdata[0] = (char)configData->InterlMaxDelayDnstr;
         putdata[1] = (char)configData->InterlMaxDelayUpstr;
         if (!wrctrle(putdata,CTEAD_LT_INTERL_MAXDELAY_DN,2))
            commerror =TRUE;
      }

      /* utopia parameters */
      if (!commerror) {
         char putdata[3];
         putdata[0] = (char)configData->UtopiaLevel;
         putdata[1] = (char)configData->UtopiaAddrFast;
         putdata[2] = (char)configData->UtopiaAddrInterl;
         if (!wrctrle(putdata,CTEAD_UTOPIA_LEVEL,3))
            commerror = TRUE;
      }

      /* functionality code */
      if (!commerror) {
         char putdata[1];
         putdata[0] = (char)configData->FunctionCode1FD;
         if (!wrctrle(putdata,CTEAD_FUNC_FIELD_1FD,1))
            commerror = TRUE;
      }

      /* vendorID */
      if (!commerror) {
         char putdata[8];
         putdata[0] = (char)configData->itu_vendorid_countrycode;
         putdata[1] = (char)configData->itu_vendorid_reserved;
         putdata[2] = (char)configData->itu_vendorid_vendorcode_1;
         putdata[3] = (char)configData->itu_vendorid_vendorcode_2;
         putdata[4] = (char)configData->itu_vendorid_vendorcode_3;
         putdata[5] = (char)configData->itu_vendorid_vendorcode_4;
         putdata[6] = (char)configData->itu_vendorid_vendorspecific_1;
         putdata[7] = (char)configData->itu_vendorid_vendorspecific_2;
         if (!wrctrle(putdata,CTEAD_ITU_VENDORID_COUNTRYCODE,8))
            commerror = TRUE;
      }

      /* the adsl open command */
      if (!commerror) {
         char putdata[1];
         putdata[0] = ADSL_OPEN;
         if (!wrctrle(putdata,(unsigned int)TXCOMMANDREG,1))
            commerror = TRUE;
      }
   } 

   /* return C_CONF_DATA_ACK if all ok, C_CONF_DATA_REJ if comms */
   /* ok but modem was not down or up, C_CONF_DATA_COMMPROBLEM   */
   /* if comms not ok */
   if (commerror) 
      returnvalue = C_CONF_DATA_COMMPROBLEM;
   else {
      if (!isdown) 
         returnvalue = C_CONF_DATA_REJ;
      else 
         returnvalue = C_CONF_DATA_ACK;
   }

   return returnvalue;
}



/*
 *
 */
unsigned int LT_ADSL_enableModemLine_glite(struct T_adsl_ConfigurationData* configData)
{
   char status[1];
   bool commerror = FALSE;
   bool isdown = FALSE;
   unsigned int returnvalue;
   int i;

   /* check whether modemstatus is down or up */
   if (rdctrle(status,CTEAD_MODEM_STATUS,1)) {
      isdown = (status[0]==MODEM_STATUS_DOWN || status[0]==MODEM_STATUS_UP);
   }
   else 
      commerror = TRUE;

   /* write config data if modem is down or up */
   if (isdown) {
      /* noisemargin */
      if (!commerror) {
         char putdata[6];
         putdata[0] = (char)configData->MinNoiseMarginDnstr;
         putdata[1] = (char)configData->MinNoiseMarginUpstr;
         putdata[2] = (char)configData->MaxAddNoiseMarginDnstr;
         putdata[3] = (char)configData->MaxAddNoiseMarginUpstr;
         putdata[4] = (char)configData->TargetNoiseMarginDnstr;
         putdata[5] = (char)configData->TargetNoiseMarginUpstr;
         if (!wrctrle(putdata,CTEAD_LT_MINNOISEMARGIN_DN,6))
            commerror = TRUE;
      }

      /* power spectral density */
      if (!commerror) {
         char putdata[1];
         putdata[0] = (char)configData->MaxPSDDnstr;
         if (!wrctrle(putdata,CTEAD_LT_MAXPSD_DN,1))
            commerror = TRUE;
      }

      /* aggregate power level */
      if (!commerror) {
         char putdata[2];
         putdata[0] = (char)configData->MaxAggrPwrLvlDnstr;
         putdata[1] = (char)configData->MaxAggrPwrLvlUpstr;
         if (!wrctrle(putdata,CTEAD_LT_MAXAGGPOWERLEVEL_DN,2))
            commerror = TRUE;
      }

      /* carrier mask */
      if (!commerror) {
         char putdata[32];
         for (i = 0; i <= 31; i++)
            putdata[i]=(char)configData->CarrierMask[i];
         if (!wrctrle(putdata,CTEAD_LT_CARRIERMASK,32))
            commerror = TRUE;
      }

      /* rate adaptation mode */
      if (!commerror) {
         char putdata[2];
         putdata[0] = (char)configData->RAModeDnstr;
         putdata[1] = (char)configData->RAModeUpstr;
         if (!wrctrle(putdata,CTEAD_LT_RAMODE_DN,2))
            commerror = TRUE;
      }

      /* bitrate */
      if (!commerror) {
         char putdata[24];
         putdata[0] = (char)(configData->InterlPlannedBitrateDnstr % 256);
         putdata[1] = (char)(configData->InterlPlannedBitrateDnstr / 256);
         putdata[2] = (char)(configData->InterlPlannedBitrateUpstr % 256);
         putdata[3] = (char)(configData->InterlPlannedBitrateUpstr / 256);
         putdata[4] = (char)(configData->FastPlannedBitrateDnstr % 256);
         putdata[5] = (char)(configData->FastPlannedBitrateDnstr / 256);
         putdata[6] = (char)(configData->FastPlannedBitrateUpstr % 256);
         putdata[7] = (char)(configData->FastPlannedBitrateUpstr / 256);
         putdata[8] = (char)(configData->InterlMinBitrateDnstr % 256);
         putdata[9] = (char)(configData->InterlMinBitrateDnstr / 256);
         putdata[10] = (char)(configData->InterlMinBitrateUpstr % 256);
         putdata[11] = (char)(configData->InterlMinBitrateUpstr / 256);
         putdata[12] = (char)(configData->FastMinBitrateDnstr % 256);
         putdata[13] = (char)(configData->FastMinBitrateDnstr / 256);
         putdata[14] = (char)(configData->FastMinBitrateUpstr % 256);
         putdata[15] = (char)(configData->FastMinBitrateUpstr / 256);
         putdata[16] = (char)(configData->InterlMaxBitrateDnstr % 256);
         putdata[17] = (char)(configData->InterlMaxBitrateDnstr / 256);
         putdata[18] = (char)(configData->InterlMaxBitrateUpstr % 256);
         putdata[19] = (char)(configData->InterlMaxBitrateUpstr / 256);
         putdata[20] = (char)(configData->FastMaxBitrateDnstr % 256);
         putdata[21] = (char)(configData->FastMaxBitrateDnstr / 256);
         putdata[22] = (char)(configData->FastMaxBitrateUpstr % 256);
         putdata[23] = (char)(configData->FastMaxBitrateUpstr / 256);
         if (!wrctrle(putdata,CTEAD_LT_INTERL_PLANNED_BITRATE_DN,24))
            commerror = TRUE;
      }

      /* rate adaptation ratio */
      if (!commerror) {
         char putdata[2];
         putdata[0] = (char)configData->RARatioDnstr;
         putdata[1] = (char)configData->RARatioUpstr;
         if (!wrctrle(putdata,CTEAD_LT_RARATIO_DN,2))
            commerror = TRUE;
      }

      /* rate adaptation shift margin */
      if (!commerror) {
         char putdata[4];
         putdata[0] = (char)configData->RADownshiftMarginDnstr;
         putdata[1] = (char)configData->RADownshiftMarginUpstr;
         putdata[2] = (char)configData->RAUpshiftMarginDnstr;
         putdata[3] = (char)configData->RAUpshiftMarginUpstr;
         if (!wrctrle(putdata,CTEAD_LT_RADOWNSHIFTMARGIN_DN,4))
            commerror = TRUE;
      }

      /* rate adaptation shift interval */
      if (!commerror) {
         char putdata[8];
         putdata[0] = (char)configData->RADownshiftIntervalDnstr;
         putdata[1] = (char)configData->RADownshiftIntervalUpstr;
         /* dummy value */
         putdata[2] = (char)-1;
         /* dummy value */
         putdata[3] = (char)-1;
         putdata[4] = (char)(configData->RAUpshiftIntervalDnstr % 256);
         putdata[5] = (char)(configData->RAUpshiftIntervalDnstr / 256);
         putdata[6] = (char)(configData->RAUpshiftIntervalUpstr % 256);
         putdata[7] = (char)(configData->RAUpshiftIntervalUpstr / 256);
         if (!wrctrle(putdata,CTEAD_LT_RADOWNSHIFTINTERVAL_DN,8))
            commerror =TRUE;
      }

      /* max interleaved channel delay */
      if (!commerror) {
         char putdata[2];
         putdata[0] = (char)configData->InterlMaxDelayDnstr;
         putdata[1] = (char)configData->InterlMaxDelayUpstr;
         if (!wrctrle(putdata,CTEAD_LT_INTERL_MAXDELAY_DN,2))
            commerror = TRUE;
      }

      /* utopia parameters */
      if (!commerror) {
         char putdata[3];
         putdata[0] = (char)configData->UtopiaLevel;
         putdata[1] = (char)configData->UtopiaAddrFast;
         putdata[2] = (char)configData->UtopiaAddrInterl;
         if (!wrctrle(putdata,CTEAD_UTOPIA_LEVEL,3))
            commerror = TRUE;
      }

      /* functionality code */
      if (!commerror) {
         char putdata[1];
         putdata[0] = (char)configData->FunctionCode1FD;
         if (!wrctrle(putdata,CTEAD_FUNC_FIELD_1FD,1))
            commerror = TRUE;
      }

      /* vendorID */
      if (!commerror) {
         char putdata[8];
         putdata[0] = (char)configData->itu_vendorid_countrycode;
         putdata[1] = (char)configData->itu_vendorid_reserved;
         putdata[2] = (char)configData->itu_vendorid_vendorcode_1;
         putdata[3] = (char)configData->itu_vendorid_vendorcode_2;
         putdata[4] = (char)configData->itu_vendorid_vendorcode_3;
         putdata[5] = (char)configData->itu_vendorid_vendorcode_4;
         putdata[6] = (char)configData->itu_vendorid_vendorspecific_1;
         putdata[7] = (char)configData->itu_vendorid_vendorspecific_2;
         if (!wrctrle(putdata,CTEAD_ITU_VENDORID_COUNTRYCODE,8))
            commerror = TRUE;
      }

      /* the adsl open command */
      if (!commerror) {
         char putdata[1];
         putdata[0] = ADSL_OPEN_GLITE;
         if (!wrctrle(putdata,(unsigned int)TXCOMMANDREG,1))
            commerror = TRUE;
      }
   } 

   /* return C_CONF_DATA_ACK if all ok, C_CONF_DATA_REJ if comms */
   /* ok but modem was not down or up, C_CONF_DATA_COMMPROBLEM   */
   /* if comms not ok */
   if (commerror) 
      returnvalue = C_CONF_DATA_COMMPROBLEM;
   else {
      if (!isdown) 
         returnvalue = C_CONF_DATA_REJ;
      else 
         returnvalue = C_CONF_DATA_ACK;
   }

   return returnvalue;
}



/*
 *
 */
unsigned int LT_ADSL_enableModemLine_gdmt(struct T_adsl_ConfigurationData* configData)
{
   char status[1];
   bool commerror = FALSE;
   bool isdown = FALSE;
   unsigned int returnvalue;
   int i;

   /* check whether modemstatus is down or up */
   if (rsctrle(status,CTEAD_MODEM_STATUS,1)) {
      isdown = (status[0]==MODEM_STATUS_DOWN || status[0]==MODEM_STATUS_UP);
   }
   else 
      commerror = TRUE;

   /* write config data if modem is down or up */
   if (isdown) {
      /* noisemargin */
      if (!commerror) {
         char putdata[6];
         putdata[0] = (char)configData->MinNoiseMarginDnstr;
         putdata[1] = (char)configData->MinNoiseMarginUpstr;
         putdata[2] = (char)configData->MaxAddNoiseMarginDnstr;
         putdata[3] = (char)configData->MaxAddNoiseMarginUpstr;
         putdata[4] = (char)configData->TargetNoiseMarginDnstr;
         putdata[5] = (char)configData->TargetNoiseMarginUpstr;
         if (!wrctrle(putdata,CTEAD_LT_MINNOISEMARGIN_DN,6))
            commerror = TRUE;
      }

      /* power spectral density */
      if (!commerror) {
         char putdata[1];
         putdata[0] = (char)configData->MaxPSDDnstr;
         if (!wrctrle(putdata,CTEAD_LT_MAXPSD_DN,1))
            commerror = TRUE;
      }

      /* aggregate power level */
      if (!commerror) {
         char putdata[2];
         putdata[0] = (char)configData->MaxAggrPwrLvlDnstr;
         putdata[1] = (char)configData->MaxAggrPwrLvlUpstr;
         if (!wrctrle(putdata,CTEAD_LT_MAXAGGPOWERLEVEL_DN,2))
            commerror =TRUE;
      }

      /* carrier mask */
      if (!commerror) {
         char putdata[32];
         for (i = 0; i <= 31; i++)
            putdata[i]=(char)configData->CarrierMask[i];
         if (!wrctrle(putdata,CTEAD_LT_CARRIERMASK,32))
            commerror = TRUE;
      }

      /* rate adaptation mode */
      if (!commerror) {
         char putdata[2];
         putdata[0] = (char)configData->RAModeDnstr;
         putdata[1] = (char)configData->RAModeUpstr;
         if (!wrctrle(putdata,CTEAD_LT_RAMODE_DN,2))
            commerror = TRUE;
      }

      /* bitrate */
      if (!commerror) {
         char putdata[24];
         putdata[0] = (char)(configData->InterlPlannedBitrateDnstr % 256);
         putdata[1] = (char)(configData->InterlPlannedBitrateDnstr / 256);
         putdata[2] = (char)(configData->InterlPlannedBitrateUpstr % 256);
         putdata[3] = (char)(configData->InterlPlannedBitrateUpstr / 256);
         putdata[4] = (char)(configData->FastPlannedBitrateDnstr % 256);
         putdata[5] = (char)(configData->FastPlannedBitrateDnstr / 256);
         putdata[6] = (char)(configData->FastPlannedBitrateUpstr % 256);
         putdata[7] = (char)(configData->FastPlannedBitrateUpstr / 256);
         putdata[8] = (char)(configData->InterlMinBitrateDnstr % 256);
         putdata[9] = (char)(configData->InterlMinBitrateDnstr / 256);
         putdata[10] = (char)(configData->InterlMinBitrateUpstr % 256);
         putdata[11] = (char)(configData->InterlMinBitrateUpstr / 256);
         putdata[12] = (char)(configData->FastMinBitrateDnstr % 256);
         putdata[13] = (char)(configData->FastMinBitrateDnstr / 256);
         putdata[14] = (char)(configData->FastMinBitrateUpstr % 256);
         putdata[15] = (char)(configData->FastMinBitrateUpstr / 256);
         putdata[16] = (char)(configData->InterlMaxBitrateDnstr % 256);
         putdata[17] = (char)(configData->InterlMaxBitrateDnstr / 256);
         putdata[18] = (char)(configData->InterlMaxBitrateUpstr % 256);
         putdata[19] = (char)(configData->InterlMaxBitrateUpstr / 256);
         putdata[20] = (char)(configData->FastMaxBitrateDnstr % 256);
         putdata[21] = (char)(configData->FastMaxBitrateDnstr / 256);
         putdata[22] = (char)(configData->FastMaxBitrateUpstr % 256);
         putdata[23] = (char)(configData->FastMaxBitrateUpstr / 256);
         if (!wrctrle(putdata,CTEAD_LT_INTERL_PLANNED_BITRATE_DN,24))
            commerror = TRUE;
      }

      /* rate adaptation ratio */
      if (!commerror) {
         char putdata[2];
         putdata[0] = (char)configData->RARatioDnstr;
         putdata[1] = (char)configData->RARatioUpstr;
         if (!wrctrle(putdata,CTEAD_LT_RARATIO_DN,2))
            commerror =TRUE;
         }

      /* rate adaptation shift margin */
      if (!commerror) {
         char putdata[4];
         putdata[0] = (char)configData->RADownshiftMarginDnstr;
         putdata[1] = (char)configData->RADownshiftMarginUpstr;
         putdata[2] = (char)configData->RAUpshiftMarginDnstr;
         putdata[3] = (char)configData->RAUpshiftMarginUpstr;
         if (!wrctrle(putdata,CTEAD_LT_RADOWNSHIFTMARGIN_DN,4))
            commerror =TRUE;
      }

      /* rate adaptation shift interval */
      if (!commerror) {
         char putdata[8];
         putdata[0]=(char)configData->RADownshiftIntervalDnstr;
         putdata[1]=(char)configData->RADownshiftIntervalUpstr;
         /* dummy value */
         putdata[2]=(char)-1;
         /* dummy value */
         putdata[3]=(char)-1;
         putdata[4]=(char)(configData->RAUpshiftIntervalDnstr % 256);
         putdata[5]=(char)(configData->RAUpshiftIntervalDnstr / 256);
         putdata[6]=(char)(configData->RAUpshiftIntervalUpstr % 256);
         putdata[7]=(char)(configData->RAUpshiftIntervalUpstr / 256);
         if (!wrctrle(putdata,CTEAD_LT_RADOWNSHIFTINTERVAL_DN,8))
            commerror =TRUE;
      }

      /* max interleaved channel delay */
      if (!commerror) {
         char putdata[2];
         putdata[0] = (char)configData->InterlMaxDelayDnstr;
         putdata[1] = (char)configData->InterlMaxDelayUpstr;
         if (!wrctrle(putdata,CTEAD_LT_INTERL_MAXDELAY_DN,2))
            commerror = TRUE;
      }

      /* utopia parameters */
      if (!commerror) {
         char putdata[3];
         putdata[0] = (char)configData->UtopiaLevel;
         putdata[1] = (char)configData->UtopiaAddrFast;
         putdata[2] = (char)configData->UtopiaAddrInterl;
         if (!wrctrle(putdata,CTEAD_UTOPIA_LEVEL,3))
            commerror = TRUE;
      }

      /* functionality code */
      if (!commerror) {
         char putdata[1];
         putdata[0] = (char)configData->FunctionCode1FD;
         if (!wrctrle(putdata,CTEAD_FUNC_FIELD_1FD,1))
            commerror = TRUE;
      }

      /* vendorID */
      if (!commerror) {
         char putdata[8];
         putdata[0] = (char)configData->itu_vendorid_countrycode;
         putdata[1] = (char)configData->itu_vendorid_reserved;
         putdata[2] = (char)configData->itu_vendorid_vendorcode_1;
         putdata[3] = (char)configData->itu_vendorid_vendorcode_2;
         putdata[4] = (char)configData->itu_vendorid_vendorcode_3;
         putdata[5] = (char)configData->itu_vendorid_vendorcode_4;
         putdata[6] = (char)configData->itu_vendorid_vendorspecific_1;
         putdata[7] = (char)configData->itu_vendorid_vendorspecific_2;
         if (!wrctrle(putdata,CTEAD_ITU_VENDORID_COUNTRYCODE,8))
            commerror =TRUE;
      }

      /* the adsl open command */
      if (!commerror) {
         char putdata[1];
         putdata[0] = ADSL_OPEN_GDMT;
         if (!wrctrle(putdata,(unsigned int)TXCOMMANDREG,1))
            commerror = TRUE;
      }
   } 

   /* return C_CONF_DATA_ACK if all ok, C_CONF_DATA_REJ if comms */
   /* ok but modem was not down or up, C_CONF_DATA_COMMPROBLEM   */
   /* if comms not ok */
   if (commerror) 
      returnvalue = C_CONF_DATA_COMMPROBLEM;
   else {
      if (!isdown) 
         returnvalue = C_CONF_DATA_REJ;
      else 
         returnvalue = C_CONF_DATA_ACK;
   }

   return returnvalue;
}



/*
 *
 */
unsigned int LT_ADSL_enableModemLine_ansi(struct T_adsl_ConfigurationData* configData)
{
   char status[1];
   bool commerror = FALSE;
   bool isdown = FALSE;
   unsigned int returnvalue;
   int i;

   /* check whether modemstatus is down or up */
   if (rsctrle(status,CTEAD_MODEM_STATUS,1)) {
      isdown = (status[0]==MODEM_STATUS_DOWN || status[0]==MODEM_STATUS_UP);
   }
   else 
      commerror = TRUE;

   /* write config data if modem is down or up */
   if (isdown) {
      /* noisemargin */
      if (!commerror) {
         char putdata[6];
         putdata[0] = (char)configData->MinNoiseMarginDnstr;
         putdata[1] = (char)configData->MinNoiseMarginUpstr;
         putdata[2] = (char)configData->MaxAddNoiseMarginDnstr;
         putdata[3] = (char)configData->MaxAddNoiseMarginUpstr;
         putdata[4] = (char)configData->TargetNoiseMarginDnstr;
         putdata[5] = (char)configData->TargetNoiseMarginUpstr;
         if (!wrctrle(putdata,CTEAD_LT_MINNOISEMARGIN_DN,6))
            commerror = TRUE;
      }

      /* power spectral density */
      if (!commerror) {
         char putdata[1];
         putdata[0] = (char)configData->MaxPSDDnstr;
         if (!wrctrle(putdata,CTEAD_LT_MAXPSD_DN,1))
            commerror = TRUE;
      }

      /* aggregate power level */
      if (!commerror) {
         char putdata[2];
         putdata[0]=(char)configData->MaxAggrPwrLvlDnstr;
         putdata[1]=(char)configData->MaxAggrPwrLvlUpstr;
         if (!wrctrle(putdata,CTEAD_LT_MAXAGGPOWERLEVEL_DN,2))
            commerror = TRUE;
      }

      /* carrier mask */
      if (!commerror) {
         char putdata[32];
         for (i = 0; i <= 31; i++)
            putdata[i]=(char)configData->CarrierMask[i];
         if (!wrctrle(putdata,CTEAD_LT_CARRIERMASK,32))
            commerror = TRUE;
      }

      /* rate adaptation mode */
      if (!commerror) {
         char putdata[2];
         putdata[0] = (char)configData->RAModeDnstr;
         putdata[1] = (char)configData->RAModeUpstr;
         if (!wrctrle(putdata,CTEAD_LT_RAMODE_DN,2))
            commerror = TRUE;
      }

      /* bitrate */
      if (!commerror) {
         char putdata[24];
         putdata[0] = (char)(configData->InterlPlannedBitrateDnstr % 256);
         putdata[1] = (char)(configData->InterlPlannedBitrateDnstr / 256);
         putdata[2] = (char)(configData->InterlPlannedBitrateUpstr % 256);
         putdata[3] = (char)(configData->InterlPlannedBitrateUpstr / 256);
         putdata[4] = (char)(configData->FastPlannedBitrateDnstr % 256);
         putdata[5] = (char)(configData->FastPlannedBitrateDnstr / 256);
         putdata[6] = (char)(configData->FastPlannedBitrateUpstr % 256);
         putdata[7] = (char)(configData->FastPlannedBitrateUpstr / 256);
         putdata[8] = (char)(configData->InterlMinBitrateDnstr % 256);
         putdata[9] = (char)(configData->InterlMinBitrateDnstr / 256);
         putdata[10] = (char)(configData->InterlMinBitrateUpstr % 256);
         putdata[11] = (char)(configData->InterlMinBitrateUpstr / 256);
         putdata[12] = (char)(configData->FastMinBitrateDnstr % 256);
         putdata[13] = (char)(configData->FastMinBitrateDnstr / 256);
         putdata[14] = (char)(configData->FastMinBitrateUpstr % 256);
         putdata[15] = (char)(configData->FastMinBitrateUpstr / 256);
         putdata[16] = (char)(configData->InterlMaxBitrateDnstr % 256);
         putdata[17] = (char)(configData->InterlMaxBitrateDnstr / 256);
         putdata[18] = (char)(configData->InterlMaxBitrateUpstr % 256);
         putdata[19] = (char)(configData->InterlMaxBitrateUpstr / 256);
         putdata[20] = (char)(configData->FastMaxBitrateDnstr % 256);
         putdata[21] = (char)(configData->FastMaxBitrateDnstr / 256);
         putdata[22] = (char)(configData->FastMaxBitrateUpstr % 256);
         putdata[23] = (char)(configData->FastMaxBitrateUpstr / 256);
         if (!wrctrle(putdata,CTEAD_LT_INTERL_PLANNED_BITRATE_DN,24))
            commerror = TRUE;
      }

      /* rate adaptation ratio */
      if (!commerror) {
         char putdata[2];
         putdata[0] = (char)configData->RARatioDnstr;
         putdata[1] = (char)configData->RARatioUpstr;
         if (!wrctrle(putdata,CTEAD_LT_RARATIO_DN,2))
            commerror = TRUE;
      }

      /* rate adaptation shift margin */
      if (!commerror) {
         char putdata[4];
         putdata[0] = (char)configData->RADownshiftMarginDnstr;
         putdata[1] = (char)configData->RADownshiftMarginUpstr;
         putdata[2] = (char)configData->RAUpshiftMarginDnstr;
         putdata[3] = (char)configData->RAUpshiftMarginUpstr;
         if (!wrctrle(putdata,CTEAD_LT_RADOWNSHIFTMARGIN_DN,4))
            commerror = TRUE;
      }

      /* rate adaptation shift interval */
      if (!commerror) {
         char putdata[8];
         putdata[0] = (char)configData->RADownshiftIntervalDnstr;
         putdata[1] = (char)configData->RADownshiftIntervalUpstr;
         /* dummy value */
         putdata[2] = (char)-1;
         /* dummy value */
         putdata[3] = (char)-1;
         putdata[4] = (char)(configData->RAUpshiftIntervalDnstr % 256);
         putdata[5] = (char)(configData->RAUpshiftIntervalDnstr / 256);
         putdata[6] = (char)(configData->RAUpshiftIntervalUpstr % 256);
         putdata[7] = (char)(configData->RAUpshiftIntervalUpstr / 256);
         if (!wrctrle(putdata,CTEAD_LT_RADOWNSHIFTINTERVAL_DN,8))
            commerror = TRUE;
      }

      /* max interleaved channel delay */
      if (!commerror) {
         char putdata[2];
         putdata[0] = (char)configData->InterlMaxDelayDnstr;
         putdata[1] = (char)configData->InterlMaxDelayUpstr;
         if (!wrctrle(putdata,CTEAD_LT_INTERL_MAXDELAY_DN,2))
            commerror =TRUE;
      }

      /* utopia parameters */
      if (!commerror) {
         char putdata[3];
         putdata[0] = (char)configData->UtopiaLevel;
         putdata[1] = (char)configData->UtopiaAddrFast;
         putdata[2] = (char)configData->UtopiaAddrInterl;
         if (!wrctrle(putdata,CTEAD_UTOPIA_LEVEL,3))
            commerror = TRUE;
      }

      /* functionality code */
      if (!commerror) {
         char putdata[1];
         putdata[0] = (char)configData->FunctionCode1FD;
         if (!wrctrle(putdata,CTEAD_FUNC_FIELD_1FD,1))
            commerror = TRUE;
      }

      /* vendorID */
      if (!commerror) {
         char putdata[8];
         putdata[0] = (char)configData->itu_vendorid_countrycode;
         putdata[1] = (char)configData->itu_vendorid_reserved;
         putdata[2] = (char)configData->itu_vendorid_vendorcode_1;
         putdata[3] = (char)configData->itu_vendorid_vendorcode_2;
         putdata[4] = (char)configData->itu_vendorid_vendorcode_3;
         putdata[5] = (char)configData->itu_vendorid_vendorcode_4;
         putdata[6] = (char)configData->itu_vendorid_vendorspecific_1;
         putdata[7] = (char)configData->itu_vendorid_vendorspecific_2;
         if (!wrctrle(putdata,CTEAD_ITU_VENDORID_COUNTRYCODE,8))
            commerror = TRUE;
      }

      /* the adsl open command */
      if (!commerror) {
         char putdata[1];
         putdata[0]=ADSL_OPEN_ANSI;
         if (!wrctrle(putdata,(unsigned int)TXCOMMANDREG,1))
            commerror = TRUE;
      }
   } 

   /* return C_CONF_DATA_ACK if all ok, C_CONF_DATA_REJ if comms */
   /* ok but modem was not down or up, C_CONF_DATA_COMMPROBLEM   */
   /* if comms not ok */
   if (commerror) 
      returnvalue = C_CONF_DATA_COMMPROBLEM;
   else {
      if (!isdown) 
         returnvalue = C_CONF_DATA_REJ;
      else 
         returnvalue = C_CONF_DATA_ACK;
   }

   return returnvalue;
}



/*
 *
 */
unsigned int LT_ADSL_enableModemLine_multimode(struct T_adsl_ConfigurationData* configData)
{
   char status[1];
   bool commerror = FALSE;
   bool isdown = FALSE;
   unsigned int returnvalue;
   int i;

   /* check whether modemstatus is down or up */
   if (rsctrle(status,CTEAD_MODEM_STATUS,1)) {
      isdown = (status[0]==MODEM_STATUS_DOWN || status[0]==MODEM_STATUS_UP);
   }
   else 
      commerror = TRUE;

   /* write config data if modem is down or up */
   if (isdown) {
      /* noisemargin */
      if (!commerror) {
         char putdata[6];
         putdata[0] = (char)configData->MinNoiseMarginDnstr;
         putdata[1] = (char)configData->MinNoiseMarginUpstr;
         putdata[2] = (char)configData->MaxAddNoiseMarginDnstr;
         putdata[3] = (char)configData->MaxAddNoiseMarginUpstr;
         putdata[4] = (char)configData->TargetNoiseMarginDnstr;
         putdata[5] = (char)configData->TargetNoiseMarginUpstr;
         if (!wrctrle(putdata,CTEAD_LT_MINNOISEMARGIN_DN,6))
            commerror = TRUE;
      }

      /* power spectral density */
      if (!commerror) {
         char putdata[1];
         putdata[0] = (char)configData->MaxPSDDnstr;
         if (!wrctrle(putdata,CTEAD_LT_MAXPSD_DN,1))
            commerror = TRUE;
      }

      /* aggregate power level */
      if (!commerror) {
         char putdata[2];
         putdata[0] = (char)configData->MaxAggrPwrLvlDnstr;
         putdata[1] = (char)configData->MaxAggrPwrLvlUpstr;
         if (!wrctrle(putdata,CTEAD_LT_MAXAGGPOWERLEVEL_DN,2))
            commerror = TRUE;
      }

      /* carrier mask */
      if (!commerror) {
         char putdata[32];
         for (i = 0; i <= 31; i++)
            putdata[i] = (char)configData->CarrierMask[i];
         if (!wrctrle(putdata,CTEAD_LT_CARRIERMASK,32))
            commerror = TRUE;
      }

      /* rate adaptation mode */
      if (!commerror) {
         char putdata[2];
         putdata[0] = (char)configData->RAModeDnstr;
         putdata[1] = (char)configData->RAModeUpstr;
         if (!wrctrle(putdata,CTEAD_LT_RAMODE_DN,2))
            commerror = TRUE;
      }

      /* bitrate */
      if (!commerror) {
         char putdata[24];
         putdata[0] = (char)(configData->InterlPlannedBitrateDnstr % 256);
         putdata[1] = (char)(configData->InterlPlannedBitrateDnstr / 256);
         putdata[2] = (char)(configData->InterlPlannedBitrateUpstr % 256);
         putdata[3] = (char)(configData->InterlPlannedBitrateUpstr / 256);
         putdata[4] = (char)(configData->FastPlannedBitrateDnstr % 256);
         putdata[5] = (char)(configData->FastPlannedBitrateDnstr / 256);
         putdata[6] = (char)(configData->FastPlannedBitrateUpstr % 256);
         putdata[7] = (char)(configData->FastPlannedBitrateUpstr / 256);
         putdata[8] = (char)(configData->InterlMinBitrateDnstr % 256);
         putdata[9] = (char)(configData->InterlMinBitrateDnstr / 256);
         putdata[10] = (char)(configData->InterlMinBitrateUpstr % 256);
         putdata[11] = (char)(configData->InterlMinBitrateUpstr / 256);
         putdata[12] = (char)(configData->FastMinBitrateDnstr % 256);
         putdata[13] = (char)(configData->FastMinBitrateDnstr / 256);
         putdata[14] = (char)(configData->FastMinBitrateUpstr % 256);
         putdata[15] = (char)(configData->FastMinBitrateUpstr / 256);
         putdata[16] = (char)(configData->InterlMaxBitrateDnstr % 256);
         putdata[17] = (char)(configData->InterlMaxBitrateDnstr / 256);
         putdata[18] = (char)(configData->InterlMaxBitrateUpstr % 256);
         putdata[19] = (char)(configData->InterlMaxBitrateUpstr / 256);
         putdata[20] = (char)(configData->FastMaxBitrateDnstr % 256);
         putdata[21] = (char)(configData->FastMaxBitrateDnstr / 256);
         putdata[22] = (char)(configData->FastMaxBitrateUpstr % 256);
         putdata[23] = (char)(configData->FastMaxBitrateUpstr / 256);
         if (!wrctrle(putdata,CTEAD_LT_INTERL_PLANNED_BITRATE_DN,24))
            commerror = TRUE;
      }

      /* rate adaptation ratio */
      if (!commerror) {
         char putdata[2];
         putdata[0] = (char)configData->RARatioDnstr;
         putdata[1] = (char)configData->RARatioUpstr;
         if (!wrctrle(putdata,CTEAD_LT_RARATIO_DN,2))
            commerror = TRUE;
      }

      /* rate adaptation shift margin */
      if (!commerror) {
         char putdata[4];
         putdata[0] = (char)configData->RADownshiftMarginDnstr;
         putdata[1] = (char)configData->RADownshiftMarginUpstr;
         putdata[2] = (char)configData->RAUpshiftMarginDnstr;
         putdata[3] = (char)configData->RAUpshiftMarginUpstr;
         if (!wrctrle(putdata,CTEAD_LT_RADOWNSHIFTMARGIN_DN,4))
            commerror = TRUE;
      }

      /* rate adaptation shift interval */
      if (!commerror) {
         char putdata[8];
         putdata[0] = (char)configData->RADownshiftIntervalDnstr;
         putdata[1] = (char)configData->RADownshiftIntervalUpstr;
         /* dummy value */
         putdata[2] = (char)-1;
         /* dummy value */
         putdata[3] = (char)-1;
         putdata[4] = (char)(configData->RAUpshiftIntervalDnstr % 256);
         putdata[5] = (char)(configData->RAUpshiftIntervalDnstr / 256);
         putdata[6] = (char)(configData->RAUpshiftIntervalUpstr % 256);
         putdata[7] = (char)(configData->RAUpshiftIntervalUpstr / 256);
         if (!wrctrle(putdata,CTEAD_LT_RADOWNSHIFTINTERVAL_DN,8))
            commerror = TRUE;
      }

      /* max interleaved channel delay */
      if (!commerror) {
         char putdata[2];
         putdata[0] = (char)configData->InterlMaxDelayDnstr;
         putdata[1] = (char)configData->InterlMaxDelayUpstr;
         if (!wrctrle(putdata,CTEAD_LT_INTERL_MAXDELAY_DN,2))
            commerror = TRUE;
      }

      /* utopia parameters */
      if (!commerror) {
         char putdata[3];
         putdata[0] = (char)configData->UtopiaLevel;
         putdata[1] = (char)configData->UtopiaAddrFast;
         putdata[2] = (char)configData->UtopiaAddrInterl;
         if (!wrctrle(putdata,CTEAD_UTOPIA_LEVEL,3))
            commerror = TRUE;
      }

      /* functionality code */
      if (!commerror) {
         char putdata[1];
         putdata[0] = (char)configData->FunctionCode1FD;
         if (!wrctrle(putdata,CTEAD_FUNC_FIELD_1FD,1))
            commerror = TRUE;
      }

      /* vendorID */
      if (!commerror) {
         char putdata[8];
         putdata[0] = (char)configData->itu_vendorid_countrycode;
         putdata[1] = (char)configData->itu_vendorid_reserved;
         putdata[2] = (char)configData->itu_vendorid_vendorcode_1;
         putdata[3] = (char)configData->itu_vendorid_vendorcode_2;
         putdata[4] = (char)configData->itu_vendorid_vendorcode_3;
         putdata[5] = (char)configData->itu_vendorid_vendorcode_4;
         putdata[6] = (char)configData->itu_vendorid_vendorspecific_1;
         putdata[7] = (char)configData->itu_vendorid_vendorspecific_2;
         if (!wrctrle(putdata,CTEAD_ITU_VENDORID_COUNTRYCODE,8))
            commerror = TRUE;
      }

      /* the adsl open command */
      if (!commerror) {
         char putdata[1];
         putdata[0] = ADSL_OPEN_MULTIMODE;
         if (!wrctrle(putdata,(unsigned int)TXCOMMANDREG,1))
            commerror = TRUE;
      }
   } 

   /* return C_CONF_DATA_ACK if all ok, C_CONF_DATA_REJ if comms */
   /* ok but modem was not down or up, C_CONF_DATA_COMMPROBLEM   */
   /* if comms not ok */
   if (commerror) 
      returnvalue = C_CONF_DATA_COMMPROBLEM;
   else {
      if (!isdown) 
         returnvalue = C_CONF_DATA_REJ;
      else 
         returnvalue = C_CONF_DATA_ACK;
   }

   return returnvalue;
}



/*
 *
 */
unsigned int NT_ADSL_enableModemLine(struct T_adsl_ConfigurationData* configData)
{
   char status[1];
   bool commerror = FALSE;
   bool isdown = FALSE;
   unsigned int returnvalue;

   /* check whether modemstatus is down or up */
   if (rdctrle(status,CTEAD_MODEM_STATUS,1)) {
      isdown = (status[0]==MODEM_STATUS_DOWN || status[0]==MODEM_STATUS_UP);
   }
   else 
      commerror = TRUE;

   if (isdown) {
      /* utopia parameters */
      if (!commerror) {
         char putdata[3];
         putdata[0] = (char)configData->UtopiaLevel;
         putdata[1] = (char)configData->UtopiaAddrFast;
         putdata[2] = (char)configData->UtopiaAddrInterl;
         if (!wrctrle(putdata,CTEAD_UTOPIA_LEVEL,3))
            commerror = TRUE;
      }

      /* functionality code */
      if (!commerror) {
         char putdata[1];
         putdata[0] = (char)configData->FunctionCode1FD;
         if (!wrctrle(putdata,CTEAD_FUNC_FIELD_1FD,1))
            commerror = TRUE;
      }

      /* vendorID */
      if (!commerror) {
         char putdata[8];
         putdata[0]=(char)configData->itu_vendorid_countrycode;
         putdata[1]=(char)configData->itu_vendorid_reserved;
         putdata[2]=(char)configData->itu_vendorid_vendorcode_1;
         putdata[3]=(char)configData->itu_vendorid_vendorcode_2;
         putdata[4]=(char)configData->itu_vendorid_vendorcode_3;
         putdata[5]=(char)configData->itu_vendorid_vendorcode_4;
         putdata[6]=(char)configData->itu_vendorid_vendorspecific_1;
         putdata[7]=(char)configData->itu_vendorid_vendorspecific_2;
         if (!wrctrle(putdata,CTEAD_ITU_VENDORID_COUNTRYCODE,8))
            commerror = TRUE;
      }

      /* the adsl open command */
      if (!commerror) {
         char putdata[1];
         putdata[0]=ADSL_OPEN;
         if (!wrctrle(putdata,(unsigned int)TXCOMMANDREG,1))
            commerror = TRUE;
      }
   } 

   /* return C_CONF_DATA_ACK if all ok, C_CONF_DATA_REJ if comms */
   /* ok but modem was not down or up, C_CONF_DATA_COMMPROBLEM   */
   /* if comms not ok */
   if (commerror) 
      returnvalue = C_CONF_DATA_COMMPROBLEM;
   else {
      if (!isdown) 
         returnvalue = C_CONF_DATA_REJ;
      else 
         returnvalue = C_CONF_DATA_ACK;
   }

   return returnvalue;
}



/*
 *
 */
unsigned int NT_ADSL_enableModemLine_glite(struct T_adsl_ConfigurationData* configData)
{
   char status[1];
   bool commerror = FALSE;
   bool isdown = FALSE;
   unsigned int returnvalue;

   /* check whether modemstatus is down or up */
   if (rdctrle(status,CTEAD_MODEM_STATUS,1)) {
      isdown = (status[0]==MODEM_STATUS_DOWN || status[0]==MODEM_STATUS_UP);
   }
   else 
      commerror = TRUE;

   if (isdown) {
      /* utopia parameters */
      if (!commerror) {
         char putdata[3];
         putdata[0] = (char)configData->UtopiaLevel;
         putdata[1] = (char)configData->UtopiaAddrFast;
         putdata[2] = (char)configData->UtopiaAddrInterl;
         if (!wrctrle(putdata,CTEAD_UTOPIA_LEVEL,3))
            commerror = TRUE;
      }

      /* functionality code */
      if (!commerror) {
         char putdata[1];
         putdata[0] = (char)configData->FunctionCode1FD;
         if (!wrctrle(putdata,CTEAD_FUNC_FIELD_1FD,1))
            commerror = TRUE;
      }

      /* vendorID */
      if (!commerror) { 
         char putdata[8];
         putdata[0] = (char)configData->itu_vendorid_countrycode;
         putdata[1] = (char)configData->itu_vendorid_reserved;
         putdata[2] = (char)configData->itu_vendorid_vendorcode_1;
         putdata[3] = (char)configData->itu_vendorid_vendorcode_2;
         putdata[4] = (char)configData->itu_vendorid_vendorcode_3;
         putdata[5] = (char)configData->itu_vendorid_vendorcode_4;
         putdata[6] = (char)configData->itu_vendorid_vendorspecific_1;
         putdata[7] = (char)configData->itu_vendorid_vendorspecific_2;
         if (!wrctrle(putdata,CTEAD_ITU_VENDORID_COUNTRYCODE,8))
            commerror = TRUE;
      }

      /* the adsl open command */
      if (!commerror) {
         char putdata[1];
         putdata[0] = ADSL_OPEN_GLITE;
         if (!wrctrle(putdata,(unsigned int)TXCOMMANDREG,1))
            commerror = TRUE;
      }
   } 

   /* return C_CONF_DATA_ACK if all ok, C_CONF_DATA_REJ if comms */
   /* ok but modem was not down or up, C_CONF_DATA_COMMPROBLEM   */
   /* if comms not */
   if (commerror) 
      returnvalue = C_CONF_DATA_COMMPROBLEM;
   else {
      if (!isdown) 
         returnvalue = C_CONF_DATA_REJ;
      else 
         returnvalue = C_CONF_DATA_ACK;
   }

   return returnvalue;
}



/*
 *
 */
unsigned int NT_ADSL_enableModemLine_gdmt(struct T_adsl_ConfigurationData* configData)
{
   char status[1];
   bool commerror = FALSE;
   bool isdown = FALSE;
   unsigned int returnvalue;

   /* check whether modemstatus is down or up */
   if (rdctrle(status,CTEAD_MODEM_STATUS,1)) {
      isdown = (status[0]==MODEM_STATUS_DOWN || status[0]==MODEM_STATUS_UP);
   }
   else 
      commerror = TRUE;

   if (isdown) {
      /* utopia parameters */
      if (!commerror) {
         char putdata[3];
         putdata[0] = (char)configData->UtopiaLevel;
         putdata[1] = (char)configData->UtopiaAddrFast;
         putdata[2] = (char)configData->UtopiaAddrInterl;
         if (!wrctrle(putdata,CTEAD_UTOPIA_LEVEL,3))
            commerror = TRUE;
      }

      /* functionality code */
      if (!commerror) {
         char putdata[1];
         putdata[0] = (char)configData->FunctionCode1FD;
         if (!wrctrle(putdata,CTEAD_FUNC_FIELD_1FD,1))
            commerror = TRUE;
      }

      /* vendorID */
      if (!commerror) {
         char putdata[8];
         putdata[0] = (char)configData->itu_vendorid_countrycode;
         putdata[1] = (char)configData->itu_vendorid_reserved;
         putdata[2] = (char)configData->itu_vendorid_vendorcode_1;
         putdata[3] = (char)configData->itu_vendorid_vendorcode_2;
         putdata[4] = (char)configData->itu_vendorid_vendorcode_3;
         putdata[5] = (char)configData->itu_vendorid_vendorcode_4;
         putdata[6] = (char)configData->itu_vendorid_vendorspecific_1;
         putdata[7] = (char)configData->itu_vendorid_vendorspecific_2;
         if (!wrctrle(putdata,CTEAD_ITU_VENDORID_COUNTRYCODE,8))
            commerror = TRUE;
      }

      /* the adsl open command */
      if (!commerror) {
         char putdata[1];
         putdata[0]=ADSL_OPEN_GDMT;
         if (!wrctrle(putdata,(unsigned int)TXCOMMANDREG,1))
            commerror = TRUE;
      }
   } 

   /* return C_CONF_DATA_ACK if all ok, C_CONF_DATA_REJ if comms */
   /* ok but modem was not down or up, C_CONF_DATA_COMMPROBLEM   */
   /* if comms not ok */
   if (commerror) 
      returnvalue = C_CONF_DATA_COMMPROBLEM;
   else {
      if (!isdown) 
         returnvalue = C_CONF_DATA_REJ;
      else 
         returnvalue = C_CONF_DATA_ACK;
   }

   return returnvalue;
}



/*
 *
 */
unsigned int NT_ADSL_enableModemLine_ansi(struct T_adsl_ConfigurationData* configData)
{
   char status[1];
   bool commerror = FALSE;
   bool isdown = FALSE;
   unsigned int returnvalue;

   /* check whether modemstatus is down or up */
   if (rdctrle(status,CTEAD_MODEM_STATUS,1)) {
      isdown = (status[0]==MODEM_STATUS_DOWN || status[0]==MODEM_STATUS_UP);
   }
   else 
      commerror = TRUE;

   if (isdown) {
      /* utopia parameters */
      if (!commerror) {
         char putdata[3];
         putdata[0] = (char)configData->UtopiaLevel;
         putdata[1] = (char)configData->UtopiaAddrFast;
         putdata[2] = (char)configData->UtopiaAddrInterl;
         if (!wrctrle(putdata,CTEAD_UTOPIA_LEVEL,3))
            commerror = TRUE;
      }

      /* functionality code */
      if (!commerror) {
         char putdata[1];
         putdata[0] = (char)configData->FunctionCode1FD;
         if (!wrctrle(putdata,CTEAD_FUNC_FIELD_1FD,1))
            commerror = TRUE;
      }

      /* vendorID */
      if (!commerror) {
         char putdata[8];
         putdata[0] = (char)configData->itu_vendorid_countrycode;
         putdata[1] = (char)configData->itu_vendorid_reserved;
         putdata[2] = (char)configData->itu_vendorid_vendorcode_1;
         putdata[3] = (char)configData->itu_vendorid_vendorcode_2;
         putdata[4] = (char)configData->itu_vendorid_vendorcode_3;
         putdata[5] = (char)configData->itu_vendorid_vendorcode_4;
         putdata[6] = (char)configData->itu_vendorid_vendorspecific_1;
         putdata[7] = (char)configData->itu_vendorid_vendorspecific_2;
         if (!wrctrle(putdata,CTEAD_ITU_VENDORID_COUNTRYCODE,8))
            commerror = TRUE;
      }

      /* the adsl open command */
      if (!commerror) {
         char putdata[1];
         putdata[0]=ADSL_OPEN_ANSI;
         if (!wrctrle(putdata,(unsigned int)TXCOMMANDREG,1))
            commerror = TRUE;
      }
   } 

   /* return C_CONF_DATA_ACK if all ok, C_CONF_DATA_REJ if comms */
   /* ok but modem was not down or up, C_CONF_DATA_COMMPROBLEM   */
   /* if comms not ok */
   if (commerror) 
      returnvalue = C_CONF_DATA_COMMPROBLEM;
   else {
      if (!isdown) 
         returnvalue = C_CONF_DATA_REJ;
      else 
         returnvalue = C_CONF_DATA_ACK;
   }

   return returnvalue;
}



/*
 *
 */
unsigned int NT_ADSL_enableModemLine_multimode(struct T_adsl_ConfigurationData* configData)
{
   char status[1];
   bool commerror = FALSE;
   bool isdown = FALSE;
   unsigned int returnvalue;

   /* check whether modemstatus is down or up */
   if (rdctrle(status,CTEAD_MODEM_STATUS,1)) {
      isdown = (status[0]==MODEM_STATUS_DOWN || status[0]==MODEM_STATUS_UP);
   }
   else 
      commerror = TRUE;

   if (isdown) {
      /* utopia parameters */
      if (!commerror) {
         char putdata[3];
         putdata[0] = (char)configData->UtopiaLevel;
         putdata[1] = (char)configData->UtopiaAddrFast;
         putdata[2] = (char)configData->UtopiaAddrInterl;
         if (!wrctrle(putdata,CTEAD_UTOPIA_LEVEL,3))
            commerror = TRUE;
      }

      /* functionality code */
      if (!commerror) {
         char putdata[1];
         putdata[0] = (char)configData->FunctionCode1FD;
         if (!wrctrle(putdata,CTEAD_FUNC_FIELD_1FD,1))
            commerror = TRUE;
      }

      /* vendorID */
      if (!commerror) {
         char putdata[8];
         putdata[0] = (char)configData->itu_vendorid_countrycode;
         putdata[1] = (char)configData->itu_vendorid_reserved;
         putdata[2] = (char)configData->itu_vendorid_vendorcode_1;
         putdata[3] = (char)configData->itu_vendorid_vendorcode_2;
         putdata[4] = (char)configData->itu_vendorid_vendorcode_3;
         putdata[5] = (char)configData->itu_vendorid_vendorcode_4;
         putdata[6] = (char)configData->itu_vendorid_vendorspecific_1;
         putdata[7] = (char)configData->itu_vendorid_vendorspecific_2;
         if (!wrctrle(putdata,CTEAD_ITU_VENDORID_COUNTRYCODE,8))
            commerror = TRUE;
      }

      /* the adsl open command */
      if (!commerror) {
         char putdata[1];
         putdata[0] = ADSL_OPEN_MULTIMODE;
         if (!wrctrle(putdata,(unsigned int)TXCOMMANDREG,1))
            commerror = TRUE;
      }
   } 

   /* return C_CONF_DATA_ACK if all ok, C_CONF_DATA_REJ if comms */
   /* ok but modem was not down or up, C_CONF_DATA_COMMPROBLEM   */
   /* if comms not ok */
   if (commerror) 
      returnvalue = C_CONF_DATA_COMMPROBLEM;
   else {
      if (!isdown) 
         returnvalue = C_CONF_DATA_REJ;
      else 
         returnvalue = C_CONF_DATA_ACK;
   }

   return returnvalue;
}



/*
 *
 */
unsigned int ADSL_disableModemLine(void)
{
   bool commerror = FALSE;
   char status[1];
   bool isdown=FALSE, inshowtime=FALSE, waitforinit=FALSE, init=FALSE;
   unsigned int returnvalue;

   /* check modem status (down,initializing,showtime) */
   if (rsctrle(status,CTEAD_MODEM_STATUS,1)) {
      isdown = (status[0]==MODEM_STATUS_DOWN);
      inshowtime = (status[0]==MODEM_STATUS_UP);
      waitforinit = (status[0]==MODEM_STATUS_WAIT_FOR_INIT);
      init = (status[0]==MODEM_STATUS_INITIALIZING);
   }
   else 
      commerror = TRUE;

   /* the adsl close command */
   if (inshowtime || waitforinit || init) {
      if (!commerror) {
         char putdata[1];
         putdata[0] = ADSL_CLOSE;
         if (!wrctrle(putdata,(unsigned int)TXCOMMANDREG,1))
            commerror =TRUE;
      }
   }

   /* return C_CONF_DATA_ACK if all ok, C_CONF_DATA_REJ if comms    */
   /* ok but modem was in an unknown state, C_CONF_DATA_COMMPROBLEM */
   /* if comms not ok, C_CONF_DATA_ALREADY_DOWN when modem was down */
   if (commerror) 
      returnvalue = C_CONF_DATA_COMMPROBLEM;
   else if (inshowtime||waitforinit||init) 
      returnvalue = C_CONF_DATA_ACK;
   else if (isdown) 
      returnvalue = C_CONF_DATA_ALREADY_DOWN;
   else 
      /* (other state than inshowtime||waitforinit||init||down) */
      returnvalue = C_CONF_DATA_REJ;

   return returnvalue;
}



/*
 *
 */
unsigned int ADSL_disableModemLine_orderly_shutdown(void)
{
   bool commerror = FALSE;
   char status[1];
   bool isdown=FALSE, inshowtime=FALSE, waitforinit=FALSE, init=FALSE;
   unsigned int returnvalue;

   /* check modem status (down,initializing,showtime) */
   if (rsctrle(status,CTEAD_MODEM_STATUS,1)) {
      isdown = (status[0]==MODEM_STATUS_DOWN);
      inshowtime = (status[0]==MODEM_STATUS_UP);
      waitforinit = (status[0]==MODEM_STATUS_WAIT_FOR_INIT);
      init = (status[0]==MODEM_STATUS_INITIALIZING);
   }
   else 
      commerror = TRUE;

   /* the adsl close command */
   if (inshowtime /*|| waitforinit || init*/) {
      if (!commerror) {
         char putdata[1];
         putdata[0] = ADSL_CLOSE_ORDERLY_SHUTDOWN;
         if (!wrctrle(putdata,(unsigned int)TXCOMMANDREG,1))
            commerror = TRUE;
      }
   }

   /* return C_CONF_DATA_ACK if all ok, C_CONF_DATA_REJ if comms    */
   /* ok but modem was in an unknown state, C_CONF_DATA_COMMPROBLEM */
   /* if comms not ok, C_CONF_DATA_ALREADY_DOWN when modem was down */
   if (commerror) 
      returnvalue = C_CONF_DATA_COMMPROBLEM;
   else if (inshowtime/*||waitforinit||init*/) 
      returnvalue = C_CONF_DATA_ACK;
   else if (isdown) 
      returnvalue = C_CONF_DATA_ALREADY_DOWN;
   else 
      /* (other state than inshowtime||waitforinit||init||down) */
      returnvalue = C_CONF_DATA_REJ;

   return returnvalue;
}



/*
 *
 */
unsigned int NT_ADSL_dyingGasp(void)
{
   bool commerror=FALSE;
   char putdata[1];
   unsigned int returnvalue;

   /* the adsl dying gasp command */
   putdata[0]=ADSL_SEND_DYING_GASP;
   if (!wrctrle(putdata,(unsigned int)TXCOMMANDREG,1))
      commerror =TRUE;

   /* return C_CONF_DATA_ACK if all ok, C_CONF_DATA_COMMPROBLEM */
   /* if comms not ok */
   if (commerror) 
      returnvalue = C_CONF_DATA_COMMPROBLEM;
   else 
      returnvalue = C_CONF_DATA_ACK;

   return returnvalue;
}



/*
 *
 */
unsigned int ADSL_write_functionality_code_1FD(char ch)
{
   bool commerror = FALSE;
   char putdata[1];
   unsigned int returnvalue;

   putdata[0] = ch;
   if (!wrctrle(putdata,CTEAD_FUNC_FIELD_1FD,1))
      commerror = TRUE;

   /* return C_CONF_DATA_ACK if all ok, C_CONF_DATA_COMMPROBLEM if */
   /* comms not ok */
   if (commerror) 
      returnvalue = C_CONF_DATA_COMMPROBLEM;
   else 
      returnvalue = C_CONF_DATA_ACK;
   
   return returnvalue;
}



/*
 *
 */
unsigned int ADSL_SelfTest_Long(void)
{
   char status[1];
   bool commerror = FALSE;
   bool isdown = FALSE;
   unsigned int returnvalue;

   /* check whether modemstatus is down */
   if (rdctrle(status,CTEAD_MODEM_STATUS,1)) {
      isdown = (status[0]==MODEM_STATUS_DOWN);
   }
   else 
      commerror = TRUE;

   /* the selftest long command */
   if (isdown) {
      if (!commerror) {
         char putdata[1];
         putdata[0] = ADSL_SELFTEST_LONG;
         if (!wrctrle(putdata,(unsigned int)TXCOMMANDREG,1))
            commerror = TRUE;
      }
   } 

   /* return C_CONF_DATA_ACK if all ok, C_CONF_DATA_REJ if comms */
   /* ok but modem was not down, C_CONF_DATA_COMMPROBLEM if comms*/
   /* not ok */
   if (commerror) 
      returnvalue = C_CONF_DATA_COMMPROBLEM;
   else {
      if (!isdown) 
         returnvalue = C_CONF_DATA_REJ;
      else 
         returnvalue = C_CONF_DATA_ACK;
   }
   
   return returnvalue;
}



/*
 *
 */
unsigned int ADSL_SelfTest_Short(void)
{
   char status[1];
   bool commerror = FALSE;
   bool isdown = FALSE;
   unsigned int returnvalue;

   /* check whether modemstatus is down */
   if (rdctrle(status,CTEAD_MODEM_STATUS,1)) {
      isdown = (status[0]==MODEM_STATUS_DOWN);
   }
   else 
      commerror = TRUE;

   /* the selftest long command */
   if (isdown) {
      if (!commerror) {
         char putdata[1];
         putdata[0] = ADSL_SELFTEST_SHORT;
         if (!wrctrle(putdata,(unsigned int)TXCOMMANDREG,1))
            commerror = TRUE;
      }
   } 

   /* return C_CONF_DATA_ACK if all ok, C_CONF_DATA_REJ if comms */
   /* ok but modem was not down, C_CONF_DATA_COMMPROBLEM if comms*/
   /* not ok */
   if (commerror) 
      returnvalue = C_CONF_DATA_COMMPROBLEM;
   else {
      if (!isdown)
         returnvalue = C_CONF_DATA_REJ;
      else 
         returnvalue = C_CONF_DATA_ACK;
   }

   return returnvalue;
}
