

#if !defined(APIHEADER)
#define APIHEADER

/* temporay get-around */
#define  NUMBER_OF_TONES       5
#define  NUMBER_OF_LOGWORDS    7

#include "apiconstants.h"
#include "ctrlereadwrite.h"
/* #include "detonator.h" */



struct T_swVersion {
   unsigned char near_end;
   unsigned char far_end;
};

struct T_VendorId { 
   unsigned short near_end;
   unsigned short far_end;
};

struct T_DMTEngineInfo {
   unsigned short version;
};

struct T_Controller_SW_version {
   unsigned char number1,number2,number3;
};

struct T_LTadslNearEndLineOperData {
   unsigned short relCapacityOccupationUpstr;
   unsigned short attainableBitrate;
   signed char noiseMarginUpstr;
   signed char outputPowerDnstr;
   unsigned char attenuationUpstr;
   unsigned char carrierLoad[128];
};

struct T_LTadslFarEndLineOperData {
   unsigned short relCapacityOccupationDnstr;
   unsigned short attainableBitrate;
   signed char noiseMarginDnstr;
   signed char outputPowerUpstr;
   unsigned char attenuationDnstr;
};

struct T_NTadslNearEndLineOperData {
   unsigned short relCapacityOccupationDnstr;
   signed char noiseMarginDnstr;
   signed char outputPowerUpstr;
   unsigned char attenuationDnstr;
};

struct T_NTadslFarEndLineOperData {
   unsigned short relCapacityOccupationUpstr;
   signed char noiseMarginUpstr;
   signed char outputPowerDnstr;
   unsigned char attenuationUpstr;
   unsigned char carrierLoad[128];
};

struct T_adslChannelOperData {
   unsigned short actualBitrateNearInt;
   unsigned short actualBitrateNearFast;
   unsigned short actualBitrateFarInt;
   unsigned short actualBitrateFarFast;
};

struct T_adsl_def_counters {
   unsigned short FecNotInterleaved;
   unsigned short FecInterleaved;
   unsigned short CrcNotInterleaved;
   unsigned short CrcInterleaved;
   unsigned short HecNotInterleaved;
   unsigned short HecInterleaved;
};

struct T_adsl_def_counter_set {
   struct T_adsl_def_counters near_end;
   struct T_adsl_def_counters far_end;
};

struct T_adsl_def_bitmaps {
   unsigned char status;
   unsigned char change;
};

struct T_adsl_def_bitmap_set {
   struct T_adsl_def_bitmaps near_end;
   struct T_adsl_def_bitmaps far_end;
};

struct T_BERdata {
   unsigned short AccumulatedBer;
   unsigned int NsecValidBer;
   unsigned int NsecInvalidBer;
};

struct T_BERdata_set {
   struct T_BERdata berFast;
   struct T_BERdata berInterleaved;
};

enum T_RAMode {
   OPERATOR,
   AUTOMATIC,
   DYNAMIC
};

struct T_adsl_ConfigurationData {
   unsigned char MinNoiseMarginDnstr;
   unsigned char MinNoiseMarginUpstr;
   unsigned char MaxAddNoiseMarginDnstr;
   unsigned char MaxAddNoiseMarginUpstr;
   unsigned char TargetNoiseMarginDnstr;
   unsigned char TargetNoiseMarginUpstr;
   signed char MaxPSDDnstr;
   unsigned char MaxAggrPwrLvlDnstr;
   unsigned char MaxAggrPwrLvlUpstr;
   unsigned char CarrierMask[32];
   enum T_RAMode RAModeDnstr;
   enum T_RAMode RAModeUpstr;
   unsigned char RARatioDnstr;
   unsigned char RARatioUpstr;
   unsigned char RADownshiftMarginDnstr;
   unsigned char RADownshiftMarginUpstr;
   unsigned char RAUpshiftMarginDnstr;
   unsigned char RAUpshiftMarginUpstr;
   unsigned char RADownshiftIntervalDnstr;
   unsigned char RADownshiftIntervalUpstr;
   unsigned short RAUpshiftIntervalDnstr;
   unsigned short RAUpshiftIntervalUpstr;
   unsigned short InterlMinBitrateDnstr;
   unsigned short InterlMinBitrateUpstr;
   unsigned short InterlPlannedBitrateDnstr;
   unsigned short InterlPlannedBitrateUpstr;
   unsigned short InterlMaxBitrateDnstr;
   unsigned short InterlMaxBitrateUpstr;
   unsigned char InterlMaxDelayDnstr;
   unsigned char InterlMaxDelayUpstr;
   unsigned short FastMinBitrateDnstr;
   unsigned short FastMinBitrateUpstr;
   unsigned short FastPlannedBitrateDnstr;
   unsigned short FastPlannedBitrateUpstr;
   unsigned short FastMaxBitrateDnstr;
   unsigned short FastMaxBitrateUpstr;
   unsigned char UtopiaLevel;
   unsigned char UtopiaAddrFast;
   unsigned char UtopiaAddrInterl;
   unsigned char FunctionCode1FD;
   unsigned char ExtraFunctionCode1FC;
   unsigned char itu_vendorid_countrycode;
   unsigned char itu_vendorid_reserved;
   unsigned char itu_vendorid_vendorcode_1;
   unsigned char itu_vendorid_vendorcode_2;
   unsigned char itu_vendorid_vendorcode_3;
   unsigned char itu_vendorid_vendorcode_4;
   unsigned char itu_vendorid_vendorspecific_1;
   unsigned char itu_vendorid_vendorspecific_2;
};

struct T_GabaritInfo {
   signed int data[NUMBER_OF_TONES];
   double gablowvarlt[NUMBER_OF_TONES];
   double gablowvarnt[NUMBER_OF_TONES];
   double gabhighvarlt[NUMBER_OF_TONES];
   double gabhighvarnt[NUMBER_OF_TONES];
   double gablowtemp[NUMBER_OF_TONES];
   double gabhightemp[NUMBER_OF_TONES];
};

struct T_LogInfo {
   char data[NUMBER_OF_LOGWORDS*4];
};

struct T_ADSL_Requested_Info {
   unsigned char adsl_requested_info_0;
   unsigned char adsl_requested_info_1;
   unsigned char adsl_requested_info_2;
   unsigned char adsl_requested_info_3;
   unsigned char adsl_requested_info_4;
   unsigned char adsl_requested_info_5;
   unsigned char adsl_requested_info_6;
   unsigned char adsl_requested_info_7;
   unsigned char adsl_requested_info_8;
};

unsigned int ADSL_SelfTest_Long(void);
unsigned int ADSL_SelfTest_Short(void);
unsigned int ADSL_def_counter_poll(struct T_adsl_def_counter_set *p_counter_set);
unsigned int ADSL_def_bitmap_poll(struct T_adsl_def_bitmap_set *p_bitmap_set);
unsigned int ADSL_disableModemLine(void);
unsigned int ADSL_disableModemLine_orderly_shutdown(void);
unsigned int ADSL_getVersion(struct T_swVersion* p_swVersion);
unsigned int ADSL_getVendorId(struct T_VendorId* p_VendorId);
unsigned int ADSL_get_controller_SWVersion(struct T_Controller_SW_version* p_ControllerSWVersion);
unsigned int ADSL_get_ChannelOperData(struct T_adslChannelOperData *p_Operdata);
unsigned int ADSL_get_BER_data(struct T_BERdata_set *p_ber_set);
unsigned int ADSL_getDMTEngineInfo(struct T_DMTEngineInfo *);
unsigned int ADSL_getGabaritInfo(struct T_GabaritInfo*, unsigned int offset);
unsigned int ADSL_getLogInfo(struct T_LogInfo*, unsigned int offset);
unsigned int ADSL_getITUVendorIDInfo(struct T_ADSL_Requested_Info *);
unsigned int ADSL_getoperationalmode_Info(struct T_ADSL_Requested_Info*);
unsigned int ADSL_sendDMTEngineInfoCommand(void);
unsigned int ADSL_sendGabaritInfoCommand(unsigned int offset);
unsigned int ADSL_sendLogInfoCommand2(unsigned int offset, 
                                      unsigned int baseaddress);
unsigned int ADSL_sendLogInfoCommand(unsigned int offset);
unsigned int ADSL_sendITUVendorIDInfoCommand(bool);
unsigned int ADSL_send_getoperationalmode_InfoCommand(void);
unsigned int ADSL_write_functionality_code_1FD(char);
unsigned int LT_ADSL_get_NearEndLineOperData(struct T_LTadslNearEndLineOperData* p_OperData); 
unsigned int LT_ADSL_get_FarEndLineOperData(struct T_LTadslFarEndLineOperData* p_OperData);
unsigned int LT_ADSL_enableModemLine(struct T_adsl_ConfigurationData* configData);
unsigned int LT_ADSL_enableModemLine_ansi(struct T_adsl_ConfigurationData* configData);
unsigned int LT_ADSL_enableModemLine_gdmt(struct T_adsl_ConfigurationData* configData);
unsigned int LT_ADSL_enableModemLine_glite(struct T_adsl_ConfigurationData* configData);
unsigned int LT_ADSL_enableModemLine_multimode(struct T_adsl_ConfigurationData *configData);
unsigned int NT_ADSL_dyingGasp(void);
unsigned int NT_ADSL_enableModemLine(struct T_adsl_ConfigurationData *configData);
unsigned int NT_ADSL_enableModemLine_glite(struct T_adsl_ConfigurationData *configData);
unsigned int NT_ADSL_enableModemLine_gdmt(struct T_adsl_ConfigurationData* configData);
unsigned int NT_ADSL_enableModemLine_multimode(struct T_adsl_ConfigurationData *configData);
unsigned int NT_ADSL_enableModemLine_ansi(struct T_adsl_ConfigurationData *configData);
unsigned int NT_ADSL_get_NearEndLineOperData(struct T_NTadslNearEndLineOperData *p_OperData);
unsigned int NT_ADSL_get_FarEndLineOperData(struct T_NTadslFarEndLineOperData *p_OperData); 


#endif
