
#if !defined(CONSTANTS_HEADER)
#define CONSTANTS_HEADER


#include "ctrleaddressmap.h"     /* addedz */
/* #include "detonator.h" */          /* addedz */


/**********GUI constants*******************************/
const int MONWNDHOREXTRASIZE = 250;
const int MONWNDVEREXTRASIZE = 33;
const int MONWNDHORSIZE = 596;
const int MONWNDVERTSIZE = 450;
const int RWBUTTONSHIFT = 50;
/**********Serial CTRLE Constants**********************/
#define D_MAXNOBYTE   64
const int MAXNOBYTE = D_MAXNOBYTE;          /* reduced: was 128; */
#define D_SEQSIZE     D_MAXNOBYTE + 7
const int SEQSIZE = D_SEQSIZE;              /* =135 */
#define D_SEQESCSIZE  2+(D_MAXNOBYTE+5)*2
const int SEQESCSIZE = D_SEQESCSIZE;        /* =268 */
const int SEQESCASCIISIZE = (D_SEQESCSIZE*4)+1+10;   /* =268*4+1+10(safe) */
const int FLASHSEQSIZE = 1028;
#define D_GABARITLINESIZE   50
const int GABARITLINESIZE = D_GABARITLINESIZE;
const int SEQGABARITSIZE = NUMBER_OF_TONES*D_GABARITLINESIZE;
const int TIMEOUTCNTR = 3;            /* in seconds 12000; for slower armc */
                                      /* 8000; for VCdevenv */
                                      /* 50000; for portable pc emul */
const int INSTRINGSIZE = 1024;
/**********Serial CTRLE Constants**********************/
const char ENDSYNC = (char)0x5A;
const char SYNC = (char)0xA5;
const char READC = (char)0x00;
const char WRITEC = (char)0x01;
const char POLLC = (char)0x03;
const char INVALIDC = (char)0x07;
const char DOWNLOAD = (char)0x09;
const char INTC = (char)0x0C;
const char RESETC = (char)0x0F;

/**********Management Entity Constants****************/
const unsigned char COMMSTRYNO = (unsigned char)3;
const unsigned char BLOCKTRYNO = (unsigned char)3;
const int RESPAVCNTPOLL = (int)4;
const int RESPAVCNTINT = (int)5000;
const int WAITEMPTYBUFFER = (int)10000;
const int TIMER3_INT_POLL_RATIO = 140;      /* +-7s     80; */
                                            /* +-4s     200; */ 
                                            /* 40 ms  -> +-10 s */
const int SIGNALLOSTCNTR = (int)60;  /*[60;3 s} time between close and open */
const int SIGNALLOSTCLOSECNTR = (int)120; /*[60; 3 s} time between lost and close */

/**********Management Entity Constants: Modem_Load_Block********/
/**********assigned to modem_block_available_cause**************/
const int DMT_ENGINE_VERSION = (int)1;
const int CAUSE_GET_OPMODE = (int)2;
const int CAUSE_ITU_VENDORID_NEAR = (int)3;
const int CAUSE_ITU_VENDORID_FAR = (int)4;

/**********CTRLE ADDRESS AND COMMAND CONSTANTS*********/
const unsigned int CTRLEMAXADDRESS = (unsigned int)0x1FF;
/**********CTRLE MANAGEMENT ENTITY COMMANDS************/
const char ADSL_SELFTEST_LONG = (char)0x01;
const char ADSL_SELFTEST_SHORT = (char)0x02;
const char ADSL_OPEN = (char)0x03;
const char ADSL_CLOSE = (char)0x04;
const char ADSL_OPEN_ANSI = (char)0x05;         /* ANSI */
const char ADSL_OPEN_GDMT = (char)0x06;         /* GDMT */
const char ADSL_OPEN_GLITE = (char)0x07;        /* GLITE */
const char ADSL_OPEN_MULTIMODE = (char)0x08;    /* multimode */
const char ADSL_SEND_DYING_GASP = (char)0x0D;
const char ADSL_CLOSE_ORDERLY_SHUTDOWN = (char)0x0E;
const char MODEM_DUMP_BLOCK = (char)0x12;
const char MODEM_LOAD_BLOCK = (char)0x13;
const char ADSL_JUMP_ADDRESS = (char)0x14;
const char GET_OPERATIONAL_MODE = (char)0x31;
const char GET_NEAR_ITU_VENDOR_ID = (char)0x32;
const char GET_FAR_ITU_VENDOR_ID = (char)0x33;
/**********CTRLE MODEM COMPONENT RESPONSES*************/
const char ADSL_OPERATIONAL_MODE_AVAILABLE = (char)0x12;
const char ADSL_OPERATIONAL_MODE_NACK = (char)0x13;
const char ADSL_NEAR_IDENTIFICATION_AV = (char)0x14;
const char ADSL_NEAR_IDENTIFICATION_NACK = (char)0x15;
const char ADSL_FAR_IDENTIFICATION_AV = (char)0x16;
const char ADSL_FAR_IDENTIFICATION_NACK = (char)0x17;
const char ADSL_OPEN_REJECTED = (char)0x21;
const char ADSL_OPEN_FAILED = (char)0x22;
const char ADSL_OPEN_FAILED_ON_TIMEOUT = (char)0x23;
const char ADSL_CONNECTION_OPENED = (char)0x24;
const char ADSL_CONNECTION_CLOSED = (char)0x25;
const char ADSL_CLOSE_REJECTED = (char)0x26;
const char ADSL_SELFTEST_RESULTS = (char)0x27;
const char ADSL_ORDERLY_SHUTDOWN_EXECUTED = (char)0x28;
const char ADSL_ORDERLY_SHUTDOWN_REJECTED =(char)0x29;
const char ADSL_ORDERLY_SHUTDOWN_ACK = (char)0x30;
const char ADSL_ORDERLY_SHUTDOWN_NACK = (char)0x31;
const char ADSL_DYING_GASP_SENT = (char)0x34;
const char ADSL_DYING_GASP_REJECTED = (char)0x35;
const char ADSL_SIGNAL_LOST = (char)0x41;
const char ADSL_SUICIDE_REQUEST = (char)0x42;
/* const char ADSL_SERIAL_INTERFACE_FRAMING_ERROR=(char)0x42; */
const char ADSL_UNKNOWN_OPCODE = (char)0x60;
const char MODEM_REG_AVAILABLE = (char)0x61;
const char MODEM_REG_WRITE_ACK = (char)0x62;
const char MODEM_REG_WRITE_NACK = (char)0x63;
const char MODEM_BLOCK_AVAILABLE = (char)0x64;
const char MODEM_BLOCK_DUMP_ACK = (char)0x65;
const char MODEM_BLOCK_DUMP_NACK = (char)0x66;
/* const char MODEM_STATE_CHANGE=(char)0x70; */

/**********ADSL_Open_Failed error codes****************/


const char NO_LOCK_POSSIBLE = (char)0x0A;
const char PROTOCOL_ERROR = (char)0x0F;
const char MESSAGE_ERROR = (char)0x14;
/*const char REQ_BITRATE_TOO_HIGH=(char)0x05;*/
/*const char ATU_R_NOT_DETECTED=(char)0x19;*/
const char INCOMPATIBLE_LINE_CONDITIONS = (char)0x05;
const char SPURIOUS_ATU_DETECTED = (char)0x19;
const char DS_REQ_BITRATE_TOO_HIGH_FOR_LITE = (char)0x1E;
const char INTERLEAVED_PROFILE_REQUIRED_FOR_LITE = (char)0x23;
const char FORCED_SILENCE = (char)0x28;
const char UNSELECTABLE_OPERATION_MODE = (char)0x2D;


/**********ADSL_Selftest_Result codes******************/
const char SELFTEST_SHORT_OK = (char)0x00;     /* 2 is short */
const char SELFTEST_SHORT_WARNING = (char)0x01;
const char SELFTEST_SHORT_ERROR = (char)0x02;
const char SELFTEST_SHORT_READY = (char)0x27;
const char SELFTEST_LONG_OK = (char)0x03;      /* 1 is long */
const char SELFTEST_LONG_WARNING = (char)0x04;
const char SELFTEST_LONG_ERROR = (char)0x05;
/**********Modem Status Codes**************************/
const char MODEM_STATUS_DOWN = (char)0x00;
const char MODEM_STATUS_WAIT_FOR_INIT = (char)0x08;
const char MODEM_STATUS_INITIALIZING = (char)0x10;
const char MODEM_STATUS_UP = (char)0x20;
/******************************************************/

/**********SACHEM REGISTER ADDRESS CONSTANTS***********/
#define D_SACHEM_BASE_ADDRESS     (unsigned int)0x01400000
const unsigned int SACHEM_BASE_ADDRESS = D_SACHEM_BASE_ADDRESS;
#define D_SACHEM_VERSION_OFFSET   (unsigned int)0x20
const unsigned int SACHEM_VERSION_OFFSET = D_SACHEM_VERSION_OFFSET;

const unsigned int SACHEM_VERSION_ADDRESS = (unsigned int)
  D_SACHEM_BASE_ADDRESS + D_SACHEM_VERSION_OFFSET;
/******************************************************/
const int SACHEM_VERSION_LENGTH = (int)2;

/**********GABARIT TEST RESULTS CONSTANTS**************/
const unsigned int GABARIT_BASE_ADDRESS = (unsigned int)0x100000;
#define D_GABARIT_BLOCK_LENGTH            (int)16
const int GABARIT_BLOCK_LENGTH = D_GABARIT_BLOCK_LENGTH;

/**********LOG TEST RESULTS CONSTANTS******************/
const unsigned int LOG_BASE_ADDRESS_NT = (unsigned int)0x59090;
const unsigned int LOG_BASE_ADDRESS_LT = (unsigned int)0x58744;
#define D_LOG_BLOCK_LENGTH                (int)16
const int LOG_BLOCK_LENGTH = D_LOG_BLOCK_LENGTH;

/**********MODEM CONTROLLER CODE CONSTANTS*************/
const unsigned int CTRLE_BASE_ADDRESS = (unsigned int)0x04000000;

#endif

