
#if !defined(CTRLEADDRESSMAP_HEADER)
#define CTRLEADDRESSMAP_HEADER


/**********CTRLE REGISTER ADDRESSES********************/

/* COMMON */
const char TXCOMMANDREG = (char)0x00;
const char RXCOMMANDREG = (char)0x01;
const char RXCOMAVREG = (char)0x03;
const char BLCKBADDRREG = (char)0x08;
const char BLCKDATAREG = (char)0x0E;
const unsigned int CTEAD_LT_MINNOISEMARGIN_DN = (unsigned int)0x040;
const unsigned int CTEAD_LT_MAXPSD_DN = (unsigned int)0x046;
const unsigned int CTEAD_LT_MAXAGGPOWERLEVEL_DN = (unsigned int)0x048;
const unsigned int CTEAD_UTOPIA_LEVEL = (unsigned int)0x04A;
const unsigned int CTEAD_LT_CARRIERMASK = (unsigned int)0x050;
const unsigned int CTEAD_LT_RAMODE_DN = (unsigned int)0x070;
const unsigned int CTEAD_LT_INTERL_PLANNED_BITRATE_DN = (unsigned int)0x074;
const unsigned int CTEAD_LT_RARATIO_DN = (unsigned int)0x08C;
const unsigned int CTEAD_LT_RADOWNSHIFTMARGIN_DN = (unsigned int)0x090;
const unsigned int CTEAD_LT_RADOWNSHIFTINTERVAL_DN = (unsigned int)0x094;
const unsigned int CTEAD_LT_INTERL_MAXDELAY_DN = (unsigned int)0x09C;
const unsigned int CTEAD_ACC_BER_FAST = (unsigned int)0x0A3;
const unsigned int CTEAD_ACC_BER_IL = (unsigned int)0x0B0;
const unsigned int CTEAD_ITU_VENDORID_COUNTRYCODE = (unsigned int)0x0BA;
const unsigned int CTEAD_ADSL_REQUESTED_INFO_0 = (unsigned int)0x0E0;
const unsigned int CTEAD_MODEM_STATUS = (unsigned int)0x100;
const unsigned int CTEAD_RVERSION_NEAR_END = (unsigned int)0x102;
const unsigned int CTEAD_RVERSION_FAR_END = (unsigned int)0x103;
const unsigned int CTEAD_RVENDOR_NEAR_END_LSB = (unsigned int)0x104;
const unsigned int CTEAD_RVENDOR_FAR_END_LSB = (unsigned int)0x106;

/* LT */
const unsigned int CTEAD_LT_FAR_RELCAPACITYOCC_DN_LSB = (unsigned int)0x108;
const unsigned int CTEAD_LT_FAR_NOISEMARGIN_DN = (unsigned int)0x10A;
const unsigned int CTEAD_LT_FAR_OUTPUTPOWER_UP = (unsigned int)0x10B;
const unsigned int CTEAD_LT_FAR_ATTENUATION_DN = (unsigned int)0x10C;
const unsigned int CTEAD_LT_FAR_ATTAINABLE_BITRATE_LSB = (unsigned int)0x10E;
const unsigned int CTEAD_LT_NEAR_RELCAPACITYOCC_UP_LSB = (unsigned int)0x110;
const unsigned int CTEAD_LT_NEAR_NOISEMARGIN_UP = (unsigned int)0x112;
const unsigned int CTEAD_LT_NEAR_OUTPUTPOWER_DN = (unsigned int)0x113;
const unsigned int CTEAD_LT_NEAR_ATTENUATION_UP = (unsigned int)0x114;
const unsigned int CTEAD_LT_NEAR_ATTAINABLE_BITRATE_LSB = (unsigned int)0x116;
const unsigned int CTEAD_LT_NEAR_CARRIER_LOAD = (unsigned int)0x118;

/* NT */
const unsigned int CTEAD_NT_NEAR_RELCAPACITYOCC_DN_LSB = (unsigned int)0x108;
const unsigned int CTEAD_NT_NEAR_NOISEMARGIN_DN = (unsigned int)0x10A;
const unsigned int CTEAD_NT_NEAR_OUTPUTPOWER_UP = (unsigned int)0x10B;
const unsigned int CTEAD_NT_NEAR_ATTENUATION_DN = (unsigned int)0x10C;
const unsigned int CTEAD_NT_FAR_RELCAPACITYOCC_UP_LSB = (unsigned int)0x110;
const unsigned int CTEAD_NT_FAR_NOISEMARGIN_UP = (unsigned int)0x112;
const unsigned int CTEAD_NT_FAR_OUTPUTPOWER_DN = (unsigned int)0x113;
const unsigned int CTEAD_NT_FAR_ATTENUATION_UP = (unsigned int)0x114;
const unsigned int CTEAD_NT_FAR_CARRIER_LOAD = (unsigned int)0x118;

/* COMMON */
const unsigned int CTEAD_NEAR_INT_CHANNELDATA_LSB = (unsigned int)0x1A0;
const unsigned int CTEAD_NEAR_FAST_CHANNELDATA_LSB = (unsigned int)0x1A2;
const unsigned int CTEAD_FAR_INT_CHANNELDATA_LSB = (unsigned int)0x1A4;
const unsigned int CTEAD_FAR_FAST_CHANNELDATA_LSB = (unsigned int)0x1A6;
const unsigned int CTEAD_NEAR_FEC_NI_LSB = (unsigned int)0x1B0;
const unsigned int CTEAD_NEAR_BITMAP_STATUS = (unsigned int)0x1E0;
const unsigned int R_OPEN_FAILED_REG = (unsigned int)0x1E4;
const unsigned int R_SELFTEST_RESULTS_REG = (unsigned int)0x1E5;
const unsigned int CTEAD_FUNC_FIELD_1FC = (unsigned int)0x1FC;
const unsigned int CTEAD_FUNC_FIELD_1FD = (unsigned int)0x1FD;
const unsigned int CTEAD_CONTROLLER_SW_VERSION = (unsigned int)0x1FE;



#endif

