/*****************************************************************************
 *     $Id: arbiter.h,v 1.1 1999/09/24 19:44:12 pzo Exp $
 *
 *     Description:  Banyan Bus Arbiter Header File
 *     Author:       Peter Z. Onufryk
 *     Company:      AT&T
 *
 *     $Log: arbiter.h,v $
 *     Revision 1.1  1999/09/24 19:44:12  pzo
 *     added header files to cvs
 *
 *
 *****************************************************************************/

#ifndef _arbiter
#define _arbiter

/******************************************************************************
 * ARBC0 register
 *****************************************************************************/

#define ARBC0_DMA0(v)      ((v&0x3)<<0)        /* DMA0 field                  */
#define ARBC0_DMA1(v)      ((v&0x3)<<2)        /* DMA1 field                  */
#define ARBC0_DMA2(v)      ((v&0x3)<<4)        /* DMA2 field                  */
#define ARBC0_DMA3(v)      ((v&0x3)<<6)        /* DMA3 field                  */
#define ARBC0_DMA4(v)      ((v&0x3)<<8)        /* DMA4 field                  */
#define ARBC0_DMA5(v)      ((v&0x3)<<10)       /* DMA5 field                  */
#define ARBC0_DMA6(v)      ((v&0x3)<<12)       /* DMA6 field                  */
#define ARBC0_DMA7(v)      ((v&0x3)<<14)       /* DMA7 field                  */
#define ARBC0_DMA8(v)      ((v&0x3)<<16)       /* DMA8 field                  */
#define ARBC0_DMA9(v)      ((v&0x3)<<18)       /* DMA9 field                  */
#define ARBC0_DMA10(v)     ((v&0x3)<<20)       /* DMA10 field                 */
#define ARBC0_DMA11(v)     ((v&0x3)<<22)       /* DMA11 field                 */
#define ARBC0_DMA12(v)     ((v&0x3)<<24)       /* DMA12 field                 */
#define ARBC0_DMA13(v)     ((v&0x3)<<26)       /* DMA13 field                 */
#define ARBC0_DMA14(v)     ((v&0x3)<<28)       /* DMA14 field                 */
#define ARBC0_DMA15(v)     ((v&0x3)<<30)       /* DMA15 field                 */

/******************************************************************************
 * ARBC1 register
 *****************************************************************************/

#define ARBC1_CPU(v)       ((v&0x3)<<0)        /* CPU field                   */
#define ARBC1_EXTBM(v)     ((v&0x3)<<2)        /* external bus master field   */

#endif /* _arbiter */


