/*****************************************************************************
 *
 *     Description:   ATM Header File
 *     Author:        Li-Chin Wang 
 *     Company:       AT&T
 *
 *     $Log: atm.h,v $
 *     Revision 1.10  2000/01/31 20:38:15  licwang
 *     Change the define
 *
 *     Revision 1.9  2000/01/31 20:33:37  licwang
 *     Add the new define value for DEVCMD
 *
 *     Revision 1.8  1999/11/18 15:18:21  licwang
 *     Chnage the ATMU2PC_p28 to ATMU2PC_P28
 *
 *     Revision 1.7  1999/10/28 14:03:57  licwang
 *     Corrected errors of mask
 *
 *     Revision 1.6  1999/10/21 17:47:49  licwang
 *     Correct errors
 *
 *     Revision 1.5  1999/10/21 17:44:43  licwang
 *     Change UN to  UND
 *
 *     Revision 1.4  1999/10/19 17:35:30  licwang
 *     Add header for atm0/1s
 *
 *     Revision 1.3  1999/10/18 23:14:33  licwang
 *     Correct errors
 *
 *     Revision 1.2  1999/10/18 22:55:11  licwang
 *     Modify atm.h from lower case to upper case and remove unused header
 *
 *     Revision 1.1  1999/10/14 15:50:56  liCwang
 *     Add header for ATM interfaCe
 *
 *
 *****************************************************************************/

#ifndef _atm
#define _atm

#define ATM_DISABLE         0
#define ATM_UTOPIA1         1
#define ATM_UTOPIA2         2
#define ATM_DPI1            3
#define ATM_DPI2            4

/******************************************************************************
 * ATMINTFC register
 *****************************************************************************/

#define ATMINTFC_M(v)        ((v&0x7)<<0)        /* M field                  */
#define ATMINTFC_RES         (1<<3)              /* RES field                */


/******************************************************************************
 *ATM[0/1]C register
 *****************************************************************************/

#define ATMC_IE              (1<<0)              /* IE field                 */
#define ATMC_OE              (1<<1)              /* OE field                 */
#define ATMC_CF              (1<<2)              /* CF field                 */
#define ATMC_CMS             (1<<3)              /* CMS field                */

/******************************************************************************
 *ATM[0/1]S register
 *****************************************************************************/

#define ATMS_IR              (1<<0)              /* IR field                 */
#define ATMS_OR              (1<<1)              /* OR field                 */
#define ATMS_OVR             (1<<2)              /* OVR field                */
#define ATMS_UND             (1<<3)              /* UND field                */
#define ATMS_CD              (1<<4)              /* CD field                 */

/******************************************************************************
 * ATMCP register
 *****************************************************************************/

#define ATMU2PC_P28          (1<<0)             /* P28 field                 */
#define ATMU2PC_P29          (1<<1)             /* P29 field                 */
#define ATMU2PC_P30          (1<<2)             /* P30 field                 */

/******************************************************************************
 * CRC10C register
 *****************************************************************************/

#define CRC10C_EN            (1<<0)          /* en field                     */



/******************************************************************************
 * CRC10VAL register
 *****************************************************************************/

#define CRC10C_VAL(v)       ((v&0x1023)<<0)     /* CRC10VAL field            */

/******************************************************************************
 * DEVCMD register
 *****************************************************************************/

#define	NOCRC    0x0
#define	CRC10    0x1
#define	CRC32    0x4
#define	CRC32_FD  0x5
#define	CRC32_LD  0x6
#define	CRC32_FLD 0x7


#endif   /*endif*/
