/*****************************************************************
**  File : atm_user_conf.c
**
**		ATM module configuration.
**
** Copyright 2000, Integrated Device Technology, Inc.
** Company Confidential of Integrated Device Technology, Inc.
**
*******************************************************************
**
**  Date         Developer                 Comment
*******************************************************************
**  08/01/2001   srinivas voleti           Original
**                                         (moved from sar_api.c)
**
**               P. Sadik                  Ported to linux
******************************************************************/

#include "sys_ss_def.h"
#include "banyan.h"
#include "atm.h"
#include "dma.h"
#include "sar_if.h"
#include "sardrv.h"

void oam_cell_gen();
void oam_cell_rx();
void init_atm_phy(void );
int get_atm_phy();
int set_atm_phy();

UInt32 atm_config_type = HW_UTOPIA_2_TYPE;

ATMIF_CONFIG_st if_config[] = \
				{ 
					{ 
						DFLT_SWITCH, 
						DFLT_PORT, 
						DFLT_IF, 
						CFG_UTO1,  
						MAX_VCCS, 
						VPI_MASK,
						VCI_MASK,
						VPI_SHFT,
						oam_cell_gen,  
						oam_cell_rx, 
						NULL, 
						NULL, 
						NULL
					},
					{ 
						DFLT_SWITCH, 
						DFLT_PORT, 
						DFLT_IF, 
						CFG_UTO2,  
						MAX_VCCS, 
						VPI_MASK,
						VCI_MASK,
						VPI_SHFT,
						oam_cell_gen,  
						oam_cell_rx, 
						init_atm_phy, 
						get_atm_phy, 
						set_atm_phy
					},
					{ 
						DFLT_SWITCH, 
						DFLT_PORT, 
						DFLT_IF, 
						CFG_UTO2_SLAVE,  
						MAX_VCCS, 
						VPI_MASK,
						VCI_MASK,
						VPI_SHFT,
						oam_cell_gen,  
						oam_cell_rx, 
						NULL, 
						NULL, 
						NULL
					},
					{ 
						DFLT_SWITCH, 
						DFLT_PORT, 
						DFLT_IF, 
						CFG_UTO1_SLAVE,  
						MAX_VCCS, 
						VPI_MASK,
						VCI_MASK,
						VPI_SHFT,
						oam_cell_gen,  
						oam_cell_rx, 
						NULL, 
						NULL, 
						NULL
					},
					{ 
						DFLT_SWITCH, 
						DFLT_PORT, 
						DFLT_IF, 
						CFG_UTO2_ALC_SLAVE,  
						MAX_VCCS, 
						VPI_MASK,
						VCI_MASK,
						VPI_SHFT,
						oam_cell_gen,  
						oam_cell_rx, 
						NULL, 
						NULL, 
						NULL
					},
					{ 
						DFLT_SWITCH, 
						DFLT_PORT, 
						DFLT_IF, 
						CFG_UTO2_RP351,  
						MAX_VCCS, 
						VPI_MASK,
						VCI_MASK,
						VPI_SHFT,
						oam_cell_gen,  
						oam_cell_rx, 
						NULL, 
						NULL, 
						NULL
					}
				};

