/***************************************************************
** File : phy_77v1053.h
**
**    Definitions for ATM PHY 77v1053.
**
** Copyright 1999, Integrated Device Technology, Inc.
** Company Confidential of Integrated Device Technology, Inc.
**
****************************************************************
**
**  Date         Developer                 Comment
****************************************************************
**  10/30/2000   srinivas voleti           Original
**
***************************************************************/

#ifndef __PHY_77V1053_H__
#define __PHY_77V1053_H__

#define	ATM_PHY_BASE	0xb4000000

/* Offsets of the PHY registers for a single port */
#define	ATM_PHY_MASTER_CTRL_REG	0x00
#define	ATM_PHY_INTR_STS_REG	0x01
#define	ATM_PHY_DIAG_CTRL_REG	0x02
#define	ATM_PHY_LED_HEC_SC_REG	0x03
#define	ATM_PHY_LB_CNTR_REG		0x04
#define	ATM_PHY_UB_CNTR_REG		0x05
#define	ATM_PHY_CNTRS_RDSEL_REG	0x06
#define	ATM_PHY_INTR_MASK_REG	0x07
#define	ATM_PHY_ENH_CTRL_REG	0x08

/* The RxREF & TxREF control register is common for all the subports */
#define	ATM_PHY_REF_CTRL_REG	0x40

/* Master Control Register */
#define	MC_DISC_ERR_CELLS		0x40
#define	MC_CELL_ERR_INTR_EN		0x20
#define	MC_XMIT_DATA_PAR_CHK	0x10
#define	MC_DISC_RX_IDLE_CELLS	0x08
#define	MC_HALT_TX				0x04
#define	MC_INTR_PIN_EN			0x01

/* Interrupt Status Register */
#define	IS_GOOD_SIG				0x40
#define	IS_RX_HEC_ERR_CELL		0x20
#define	IS_RX_SHORT_CELL		0x10
#define	IS_TX_PAR_ERR			0x08
#define	IS_RX_SIG_COND_CHG		0x04
#define	IS_RX_SYM_ERR			0x02
#define	IS_RX_FIFO_OVERFLOW		0x01

/* Diagnostic Control Register */
#define	DC_TXCLAV_DEASRT_FORCE	0x80
#define	DC_RFLUSH				0x10
#define	DC_TX_PAYLD_ERR_INSERT	0x08
#define	DC_TX_HEC_ERR_INSERT	0x04
#define	DC_PHY_LPBK				0x02
#define	DC_LINE_LPBK			0x01

/* LED Driver & HEC Status or Control Registers */
#define	LH_RX_HEC_DIS		0x40
#define	LH_TX_HEC_DIS		0x20
#define	LH_RXREF_PULSE_8	0x18
#define	LH_RXREF_PULSE_4	0x10
#define	LH_RXREF_PULSE_2	0x08
#define	LH_RXREF_PULSE_0	0x00
#define	LH_FIFO_STS			0x04
#define	LH_TXLED_STS		0x02
#define	LH_RXLED_STS		0x01

/* Counter Select Registers */
#define	CS_SYM_ERR			0x08
#define	CS_TXCELL			0x04
#define	CS_RXCELL			0x02
#define	CS_RX_HEC_ERR		0x01

/* Interrupt Mask Register */
#define	IM_HEC_ERR_CELL		0x20
#define	IM_SHORT_CUT_ERR	0x10
#define	IM_TX_PAR_ERR		0x08
#define	IM_RX_SIG_COND_CHG	0x04
#define	IM_RX_CELL_SYM_ERR	0x02
#define	IM_RX_FIFO_OVERFLOW	0x01

/* Enhanced Control Registers */
#define	EC_IND_PORT_SW_RESET	0x80
#define	EC_TXC_IS_RXC			0x40
#define	EC_UTO2_PORT_ADDR_MASK	0x1f

/* RxREF & TxREF Control Register */
#define	RxREF_SRC_SEL_MASK		0xc0
#define	RxREF_SRC_SEL_BIT_POS	0x6
#define	MASTER_SW_RESET			0x20
#define	RX_TO_TX_LOOP_SEL_MASK	0x07
#endif /* __PHY_77V1053_H__ */
