/*****************************************************************
**  File : sar_linux_specific.h
**
**		Includes data structures & definitions for vxWorks specific
**		MBUF resource management. 
**
** Copyright 2000, Integrated Device Technology, Inc.
** Company Confidential of Integrated Device Technology, Inc.
**
** NOTE:
**
*******************************************************************
**
**  Date         Developer                 Comment
*******************************************************************
**  08/30/2000   srinivas voleti           Original
**  10/15/2001   P. Sadik                  Ported from 
**                                     sar_vxworks_specific.h
******************************************************************/
    
#ifndef	__SAR_LINUX_SPECIFIC_H__
#define	__SAR_LINUX_SPECIFIC_H__
/* Priorities */
#define SARSCH_PRI          60
#define	SARSTAT_PRI			59

#define	SARSCH_STK_SIZE		5000
#define	SARSTAT_STK_SIZE	5000

typedef struct _t_UNALIGNED_MEM_st {
  char    *pATM;
  char    *vc_table;
  char    *vp_table;
  char    *free_vc_base;
  char    *status_base;
  char    *free_dlist_base;
  char    *pad_buffer0;
  char    *pad_buffer1;
  char    *pad_buffer2;
  char    *L2_table[MAX_VPI]; 
} UNALIGNED_MEM_st; 

/* Function prototypes */
//void *rtos_dependent_init( int parm);
void *rtos_dependent_init(pATMIF_st parm);
void free_atmif_rtos_resources(void *p);
int install_sar_int_hdlr(pATMIF_st pATM);
void post_status(void *p);
void wait_status(void *p);
void create_free_mbuf_list(UInt32 size, UInt32 cnt);
void bzero(volatile char* s, size_t count); 
#endif /* !__SAR_VX_SPECIFIC_H__ */
