/***************************************************************
** File : sar_OAM.h
**
**    Definitions and data structures to support OAM over softSAR
**
** Copyright 1999, Integrated Device Technology, Inc.
** Company Confidential of Integrated Device Technology, Inc.
**
****************************************************************
**
**  Date         Developer                 Comment
****************************************************************
**  08/24/1999   srinivas voleti           Original
**  09/13/1999   srinivas voleti           Changes to support subports
**  09/22/2001   P. Sadik                  Ported to linux
***************************************************************/

#ifndef __SSAR_OAM_H__
#define __SSAR_OAM_H__

/* F4 Flow */
#define	OAM_F4_SEG_VC			0x03
#define	OAM_F4_END_2_END_VC		0x04

/* F5 Flow */
#define	OAM_F5_SEG_PTI			0x04
#define	OAM_F5_END_2_END_PTI	0x05

/* OAM Types */
#define	OAM_FLT_MGMT_TYPE		0x01
#define	OAM_PERF_MGMT_TYPE		0x02
#define	OAM_ACT_DEACT_TYPE		0x08
#define	OAM_SYS_MGMT_TYPE		0x0f

/* Function Types */
#define	OAM_FLT_AIS				0x00
#define	OAM_FLT_RDI				0x01
#define	OAM_FLT_CONT_CHK		0x04
#define	OAM_FLT_LPBK			0x08
#define	OAM_PERF_FWD_MON		0x00
#define	OAM_PERF_BCK_REP		0x01
#define	OAM_ACT_DEACT_PERF_MON	0x00
#define	OAM_ACT_DEACT_CONT_CHK	0x01

/* Macros for OAM & function types */
#define	GET_OAM_TYPE(val)	((val >> 4) & 0x0f)
#define	GET_FUNC_TYPE(val)	(val & 0x0f)
#define	JOIN_OAM_FUNC_FIELDS(oam_type, func_type)	\
							((oam_type << 4) | func_type)

/* Function prototypes */
void oam_cell_gen(UInt32 subport, UInt32 vpi, UInt32 vci, UInt32 pti,
                       		 UByte oam_type, UByte func_type);

#endif /* __SSAR_OAM_H__ */
