/*****************************************************************
**  File : sar_others.c
**
** This file is a temporary file & contains functions to take care of 
** compilations. This file will ultimately be deleted.
**
** Copyright 2000, Integrated Device Technology, Inc.
** Company Confidential of Integrated Device Technology, Inc.
**
*******************************************************************
**
**  Date         Developer                 Comment
*******************************************************************
**  09/11/2000   srinivas voleti           Original
**  09/10/2001   P. Sadik                  Ported to linux.
******************************************************************/
#include <linux/module.h>
#include <linux/config.h>
#include <linux/kernel.h>
#include <linux/vmalloc.h> /* for vmalloc */
#include <linux/mm.h>
#include <linux/pci.h>
#include <linux/errno.h>
#include <linux/atm.h>
#include <linux/atmdev.h>
#include <linux/sonet.h>
#include <linux/skbuff.h>
#include <linux/time.h>
#include <linux/timex.h>
#include <linux/sched.h> /* for xtime */
#include <linux/delay.h>
#include <linux/uio.h>
#include <linux/init.h>
#include <asm/system.h>
#include <asm/io.h>
#include <asm/uaccess.h>
#include <asm/string.h>
#include <asm/byteorder.h>

#include <linux/string.h>
#include "sys_ss_def.h"
#include "sar_if.h"
#include "sardrv.h"
#include "sar_linux_specific.h"
#include "banyan.h"
#include "atm.h"
#include "dma.h"

extern void *atm_register(void );

extern   void     *gATM;
volatile UInt32   gForever;
volatile UInt32	  *gForever_addr = &gForever;
extern   UInt32   atm_config_type;
extern   void     sar_xmit_dma0(pATM_VC_st pVC);
extern   void     taskDelay(unsigned long);

/******************************************************************
** FUNCTION : s_init
**
** DESCRIPTION:
**
** NOTE:
**
******************************************************************/
void s_init(UInt32 type)
{
  void	*handle;

  atm_config_type = type;

  handle = (void *)atm_register();

  gATM = handle;

} /* s_init */

void s_vp_setup(UInt32 sp, UInt32 vpi, UInt32 mask, UInt32 bit_pos)
{
  VPT_CONFIG_st	vpt;

  vpt.subport = sp;	
  vpt.vpi     = vpi;	
  vpt.mask    = mask;	
  vpt.bit_pos = bit_pos;	

  banyan_atm_ioctl(gATM, SARIO_VPT_SETUP, &vpt, 0, NULL, 0, NULL);
}

void s_vp_shut(UInt32 subport, UInt32 vpi)
{
  VPT_CONFIG_st	vpt;

  vpt.subport = subport;
  vpt.vpi = vpi;
  
  banyan_atm_ioctl(gATM, SARIO_VPT_PURGE, &vpt, 0, NULL, 0, NULL);
}

void s_purge_vcs(void)
{
  banyan_atm_ioctl(gATM, SARIO_PURGE_VCS, NULL, 0, NULL, 0, NULL);
}

void appl_tx_hdlr_0(pATM_VC_st pVC, M_BLK_ID m)
{

} 

void appl_tx_hdlr_1(pATM_VC_st pVC, M_BLK_ID m)
{
  struct atm_vcc *vcc = pVC->proto;
  vcc->pop(vcc,m);
  //  dev_kfree_skb(m);
}

void appl_rx_hdlr_0(pATM_VC_st pVC, M_BLK_ID m, UInt32 len)
{
  struct atm_vcc *vcc = pVC->proto;

  vcc->push(vcc,m);
  //  dev_kfree_skb(m);
}

pATM_VC_st s_open_vc(UInt32 sp, UByte vcch, UByte fm, struct atm_vcc *vcc)
{
  VC_CONFIG_st	vc;
  UInt32	control;
  pATM_VC_st	pVC;
  UInt32 aal = vcc->qos.aal;

  control = (VPCI_ADMIN_UP | (aal & AAL_TYPE_MASK));

  if (fm)
    control |= FRAME_MODE;
  if (vcch && (aal == AAL5_TYPE))
    control |= CHAN_MASK;

  vc.subport = sp;
  vc.vpi     = vcc->vpi;
  vc.vci     = vcc->vci;

  if(vcc->pop)
    vc.tx_hdlr = vcc->pop;
  else
    {
      vc.tx_hdlr = vcc->pop = appl_tx_hdlr_1;
    }

  vc.rx_hdlr = appl_rx_hdlr_0;

  vc.control = control;
  vc.proto = vcc;

  if ((banyan_atm_ioctl(gATM, SARIO_VC_SETUP, &vc, 0, &pVC, 0, NULL)) == OK)
    {
      return(pVC);
    }
  else
    {
      printk("Open Connection failed \n");
      return(NULL);
    }
}

void s_close_vc(UInt32 sp, UInt32 vpi, UInt32 vci)
{
  VC_CONFIG_st	vc;
  pATM_VC_st		pVC;

  vc.subport = sp;
  vc.vpi     = vpi;
  vc.vci     = vci;

  if ((banyan_atm_ioctl(gATM, SARIO_GET_VC_HANDLE, &vc, 0, &pVC, 0, NULL)) == OK)
    {
      banyan_atm_ioctl(gATM, SARIO_VC_TEARDOWN, pVC, 0, NULL, 0, NULL);
    }
}

void s_dump_vc_status(UInt32 sp, UInt32 vpi, UInt32 vci)
{
  VC_CONFIG_st	vc;
  pATM_VC_st		pVC;

  vc.subport = sp;
  vc.vpi     = vpi;
  vc.vci     = vci;

  banyan_atm_ioctl(gATM, SARIO_GET_VC_HANDLE, &vc, 0, &pVC, 0, NULL);

  if (pVC)
    banyan_atm_ioctl(pVC, SARIO_GET_VC_ST, NULL, 0, NULL, 0, NULL);
  else
    printk("Connection not configured\n");
}

int send_pdu(UInt32 sp, UInt32 vpi, UInt32 vci, UInt32 aal_type, 
	     UInt32 pdu_size, UInt32 bufs_per_pdu, UInt32 cnt)
{
  pATMIF_st		pATM;
  VC_CONFIG_st    vc;
  pATM_VC_st      pVC;
  volatile struct sk_buff *pmbuf, *pfirst = 0;
  char			*buf;
  UInt32			*p = 0;
  Int32			size;

  vc.subport = sp;
  vc.vpi     = vpi;
  vc.vci     = vci;

  /* Get the connection ID */
  banyan_atm_ioctl(gATM, SARIO_GET_VC_HANDLE, &vc, 0, &pVC, 0, NULL);

  if (pVC == 0)
    {
      printk("Connection not configured\n");
      return FALSE;
    }
  else
    {
      pATM = (pATMIF_st )gATM;

      if( (pmbuf = dev_alloc_skb(pdu_size + 2)) == NULL)
      {
	printk("No buffer\n");
	return FALSE;
      }
	  
      /* Initialize the skbuf structure */
      skb_put(pmbuf,pdu_size);

      /* Fill up the transmit buffers with some known data */
      size = pdu_size;
      p = (UInt32 *)pmbuf->data;
      do {
	*p++ = htonl(0xdeadbeef);
	*p++ = htonl(0x12345678);
	size -= 8;
      } while (size > 0);

      flush_cache_all();
      
      while (cnt)
	{
	  /* Call the SOFTSAR API to transmit */
	  banyan_atm_ioctl(pVC, SARIO_XMIT, (struct sk_buff *)pfirst, 
		    aal_type, (void *)appl_tx_hdlr_0, 0, NULL);
	  if (*gForever_addr == 0)
	    cnt--;
	}
    }

  return TRUE;
} /* send_pdu */

/******************************************************************
** FUNCTION : compute_address
**
** DESCRIPTION:
**      Given the addresses when the RAS & CAS are active along with the state
**  of the BWE[0-3] bits, the SDRAM address is computed. This is a tool
**  to debug using the logic analyzer.
**
** NOTE:
**  ras is the address on the AD[0-31] when RAS is active.
**  cas is the address on the AD[0-31] when CAS is active.
**      These addresses are read out from the logic analyzer.
**
******************************************************************/
void compute_address(UInt32 ras, UInt32 cas, UInt32 bwe)
{
  UInt32 t1, t2, t3, addr;

  cas &= 0x3fc;

  t1 = ras & 0x18000;
  t1 >>= 1;
  t2 = ras &0x3ffc;
  t3 = t1 | t2;

  t3 <<= 8;
  addr = cas | t3;

  if (bwe == 1)
    addr |= 0x1000000;

  addr |= 0xa0000000;
  printk("address = 0x%x\n", (int )addr);

} /* compute_address */ 

void flush_fifo(UInt32 unit)
{
  if (unit)
    {
      DROP_ATM_CELL(&atm.ch1.atmid);
    }
  else
    {
      DROP_ATM_CELL(&atm.ch0.atmid);
    }
} /* flush_fifo */

