/***************************************************************
** File : sys_ss_def.h
**
**    System definitions used by the SOFTSAR related files
**
** Copyright 2000, Integrated Device Technology, Inc.
** Company Confidential of Integrated Device Technology, Inc.
**
****************************************************************
**
**  Date         Developer                 Comment
****************************************************************
**  08/25/2000   srinivas voleti           Original
**  10/22/2001   P. Sadik                  Ported to linux
***************************************************************/

#ifndef __SYS_SS_DEF_H__
#define __SYS_SS_DEF_H__

#include <linux/skbuff.h>

typedef struct sk_buff MBLK;
typedef MBLK *      M_BLK_ID;

typedef unsigned long UInt32;
typedef signed long Int32;
typedef unsigned short UInt16;
typedef signed short Int16;
typedef unsigned char UByte;
typedef signed char Byte;

#define MAX_CELL_PAYLOAD    48          /* Maximum cell payload */
#define K0_TO_K1(addr)      (addr | 0xa0000000) 
#define KSEG0_BASE  0x80000000
#define KSEG1_BASE  0xA0000000

#define PHYS_to_K0(addr)    (KSEG0_BASE | addr)
#define PHYS_to_K1(addr)    (KSEG1_BASE | addr)

#if 0
#define K0_to_PHYS(val)     (val & 0x7fffffff)
#else
#define K0_to_PHYS(val)     (val & 0x1fffffff)
#endif
#define K1_to_PHYS(val)     (val & 0x1fffffff)

#define K0_SEG
#ifdef K0_SEG
#define KSEG    KSEG0_BASE
#define PHYS_TO_VIRT(val)   PHYS_to_K0(val)
#define VIRT_TO_PHYS(val)   K0_to_PHYS(val)
#else
#define KSEG    KSEG1_BASE
#define PHYS_TO_VIRT(val)   PHYS_TO_K1(val)
#define VIRT_TO_PHYS(val)   K1_to_PHYS(val)
#endif /* K0_SEG */

/* pdu size = cell_cnt * MAX_CELL_PAYLOAD */
#define AAL_PDU_SIZE(a)   ((a << 5) + (a << 4))

#ifndef ERROR
#define	ERROR	-1
#endif /* !ERROR */
#ifndef OK
#define	OK	0
#endif /* !OK */
#ifndef TRUE
#define	TRUE	1
#endif /* !TRUE */
#ifndef FALSE
#define	FALSE	0
#endif /* !FALSE */
#endif /* !__SYS_SS_DEF_H__ */

