/*
 * se_error.h
 *
 * rc32365 Security Engine returned errors 
 * 
 * Creator: cyoung
 * Date: 06/30/2003
 */
#ifndef __SE_ERROR_H__
#define __SE_ERROR_H__

/* 
 * SE Error Code
 */
typedef enum {
	SE_OK				= 0x00000000,
	SE_INVALID_CONTEXT_ID		= 0x00000001,
	SE_INVALID_CONTEXT_SIZE		= 0x00000002,
	SE_INVALID_INPUT_COUNT		= 0x00000004,
	SE_CMD_NOT_MATCHED		= 0x00000008,
	SE_INVALID_RETURN_CONTEXT_DATA	= 0x00000010,
	SE_INVALID_RETURN_IV_DATA	= 0x00000020,
	SE_INVALID_RETURN_COMMAND	= 0x00000040,
	SE_DATA_CXT_ERR			= 0x00000080,
	SE_DATA_ERR			= 0x00000100,
	SE_DATA_EME_ERR			= 0x00000200,
	SE_DATA_EBE_ERR			= 0x00000400,
	SE_DATA_HME_ERR			= 0x00000800,
	SE_DATA_HTM_ERR			= 0x00001000,
	SE_DATA_PME_ERR			= 0x00002000,
	SE_DATA_PE_ERR			= 0x00004000,
	SE_DATA_NHE_ERR			= 0x00008000,
	SE_DATA_AHM_ERR			= 0x00010000,
	SE_SESES_MIDS_ERR		= 0x00020000,
	SE_SESES_RME_ERR		= 0x00040000,
	SE_SESES_DME_ERR		= 0x00080000,
	SE_SESES_CDE_ERR		= 0x00100000,
	SE_CMD_CXT_ERR			= 0x00200000,
	SE_CMD_PROC_ERR			= 0x00400000,
	SE_RESET_ERR			= 0x00800000,
	SE_DESC_FULL			= 0x01000000,
	SE_INVALID_CXT_CMD		= 0x02000000,
	SE_ERR				= 0x80000000
} SE_RET_CODE; 

#endif
