#include <linux/types.h>
#include <asm/bootinfo.h>

extern unsigned long mips_machtype;

#define AP70_PROT_ADDR 0xb8010008
#define AP70_PROT_DATA 0x8
#define AP60_PROT_ADDR 0xB8400000
#define AP60_PROT_DATA 0x04000000

extern void
unlock_ap60_70_flash()
{
	volatile __u32 val ;

        switch (mips_chip) {
        case MACH_ATHEROS_AR2313:
        case MACH_ATHEROS_AR5312:
		val = *(volatile __u32 *)AP60_PROT_ADDR ;
		val &= ~(AP60_PROT_DATA) ;
		*(volatile __u32 *)AP60_PROT_ADDR = val ;
                break;
        case MACH_ATHEROS_AR2315:
                /* no locking, serial FLASH */
                break;
        case MACH_IDT_RC32434:
		val = *(volatile __u32 *)AP70_PROT_ADDR ;
		val &= ~(AP70_PROT_DATA) ;
		*(volatile __u32 *)AP70_PROT_ADDR = val ;
                break;
        default:
		printk("%s: unsupported mips_chip=0x%x\n",
		       __FUNCTION__, mips_chip) ;
        }
}

extern void
lock_ap60_70_flash()
{
	volatile __u32 val ;

        switch (mips_chip) {
        case MACH_ATHEROS_AR2313:
        case MACH_ATHEROS_AR5312:
		val = *(volatile __u32 *)AP60_PROT_ADDR ;
		val |= (AP60_PROT_DATA) ;
		*(volatile __u32 *)AP60_PROT_ADDR = val ;
                break;
        case MACH_ATHEROS_AR2315:
                /* no locking, serial FLASH */
                break;
        case MACH_IDT_RC32434:
		val = *(volatile __u32 *)AP70_PROT_ADDR ;
		val |= (AP70_PROT_DATA) ;
		*(volatile __u32 *)AP70_PROT_ADDR = val ;
                break;
        default:
		printk("%s: unsupported mips_chip=0x%x\n",
		       __FUNCTION__, mips_chip) ;
        }
}
