/*****************************************************************************
 * 
 *  USB Slave Support Software 
 *  Linux Version
 *
 *  Developed by: 
 *  Jungo Software Technologies - Residential Gateway Software Division
 *  www.jungo.com/openrg
 *  info@jungo.com
 *  
 *  
 *  Jungo Software Technologies (Jungo) and Integarated Device Technology (IDT) 
 *  jointly own all rights in the USB Slave Support Software images and source 
 *  code. 
 *  You may not, without express written permission from either Jungo or IDT,
 *  a. Distribute, sell, reproduce or copy the source code in any way.
 *  b. Rent or lease the USB Slave Support Software or otherwise transfer or 
 *  assign the right to use the USB Slave Support Software.
 *
 *
 *  
 ****************************************************************************/


#ifndef _USB_DEVICE_CLASS_DEFS_H_
#define _USB_DEVICE_CLASS_DEFS_H_
#include <asm/types.h>

/* This file: contain definitions that are common to all USB device classes */

#define MAX_STR_LEN 100

/* Configuration descriptor general data */
#define BUS_POWERED_ATTRIB 0x80
#define REMOTE_WAKEUP_ATTRIB 0x20
#define SELF_POWERED_ATTRIB 0x40

/* General descriptors sizes */ 
#define SIZEOF_DEV_DESC 0x12
#define SIZEOF_CFG_DESC 0x09
#define SIZEOF_IF_DESC 0x09
#define SIZEOF_EP_DESC 0x07

/* Descriptors types */
typedef enum {
    DEVICE_DESC = 0x01,
    CONFIGURATION_DESC = 0x02, 
    STRING_DESC = 0x03,
    INTERFACE_DESC = 0x04,
    ENDPOINT_DESC = 0x05,
    COMMUNICATION_CLASS = 0x24,
} descriptor_type;

typedef struct {
    __u8 length;
    __u8 type;
    __u8 str[MAX_STR_LEN];
} string_desc_t;

#endif

