#include <linux/stddef.h>
#include <linux/kernel.h>
#include <asm/types.h>

#include "usb_slave_common.h"

void usb_slave_dump_buffer(__u8 *buff, int size)
{
    int line, i;
    
    printk("dumping buffer\n");
    for (line = 0; line < size; line += 16)
    {
	printk("%8.8x: ", line);
	for (i = 0; i < 16; i++)
	{
	    if (line + i < size)
	    {
		if (i == 8)
		    printk("- ");
		printk("%2.2x ", 0xff & buff[line + i]);
	    }
	    else
	    {
		if (i == 8)
		    printk("  ");
		printk("   ");
	    }
	}
	printk("  ");
	for (i = 0; (i < 16) && (line + i < size); i++)
	{
	    int c = buff[line + i];
	    if ((c < 0x20) || (c > 0x7f))
		c = '.';
	    printk("%c", c);
	}
	printk("\n");
    }
}

