/*
 *
 * BRIEF MODULE DESCRIPTION
 *	Definitions for IDT 79EB365 evaluation board.
 *
 * Copyright 2000,2001 MontaVista Software Inc.
 * Author: MontaVista Software, Inc.
 *         	stevel@mvista.com or source@mvista.com
 *
 *  This program is free software; you can redistribute  it and/or modify it
 *  under  the terms of  the GNU General  Public License as published by the
 *  Free Software Foundation;  either version 2 of the  License, or (at your
 *  option) any later version.
 *
 *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
 *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
 *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
 *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  You should have received a copy of the  GNU General Public License along
 *  with this program; if not, write  to the Free Software Foundation, Inc.,
 *  675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef _79EB365_H_
#define _79EB365_H_

#define IDT_BUS_FREQ       75 // MHz
#define IDT_CLOCK_MULT     2

/* FLASH (device 1) */
#define FLASH_BASE         0x08000000
#define FLASH_SIZE         0x00800000

/* LCD 4-digit display (device 2) */
#define LCD_DIGIT0         0x0C000003
#define LCD_DIGIT1         0x0C000002
#define LCD_DIGIT2         0x0C000001
#define LCD_DIGIT3         0x0C000000

/* RTC (DS1553) (device 2) */
#define RTC_BASE           0x0c800000
/* NVRAM */
#define NVRAM_BASE         RTC_BASE
#define NVRAM_ENVSIZE_OFF  4
#define NVRAM_ENVSTART_OFF 32

/* Interrupts routed on 79EB365 board */
#define RC32365_PCI_INTA_IRQ (GROUP4_IRQ_BASE +  8)
#define RC32365_PCI_INTB_IRQ (GROUP4_IRQ_BASE +  9)
#define RC32365_PCI_INTC_IRQ (GROUP4_IRQ_BASE + 10)
#define RC32365_PCI_INTD_IRQ (GROUP4_IRQ_BASE + 11)

#define RAM_SIZE	   (32 * 1024 * 1024)

#include <asm/rc32300/rc32365.h>

#endif /* _79EB365_H_ */
