/* pcicedar.h
 *
 * This file is subject to the terms and conditions of the GNU General Public
 * License.  See the file "COPYING" in the main directory of this archive
 * for more details.
 */
#ifndef _PCICEDAR_H
#define _PCICEDAR_H


#define PCI_MSG_VirtualAddress	0xB806C010
#define rc32365_pci ((volatile PCI_t) PCI0_VirtualAddress)
#define rc32365_pci_msg ((volatile PCIM_t) PCI_MSG_VirtualAddress)

#define PCIM_SHFT		0x6
#define PCIM_BIT_LEN		0x7
#define PCIM_H_EA		0x3
#define PCIM_H_IA_FIX		0x4
#define PCIM_H_IA_RR		0x5
#if 0
#define PCI_ADDR_START		0x13000000
#endif

#define PCI_ADDR_START		0x50000000

#define CPUTOPCI_MEM_WIN	0x02000000
#define CPUTOPCI_IO_WIN		0x00100000
#define PCILBA_SIZE_SHFT	2
#define PCILBA_SIZE_MASK	0x1F
#define SIZE_256MB		0x1C
#define SIZE_128MB		0x1B
#define SIZE_64MB               0x1A
#define SIZE_32MB		0x19
#define SIZE_16MB               0x18
#define SIZE_4MB		0x16
#define SIZE_2MB		0x15
#define SIZE_1MB		0x14
#define CEDAR_CONFIG0_ADDR	0x80000000
#define CEDAR_CONFIG1_ADDR	0x80000004
#define CEDAR_CONFIG2_ADDR	0x80000008
#define CEDAR_CONFIG3_ADDR	0x8000000C
#define CEDAR_CONFIG4_ADDR	0x80000010
#define CEDAR_CONFIG5_ADDR	0x80000014
#define CEDAR_CONFIG6_ADDR	0x80000018
#define CEDAR_CONFIG7_ADDR	0x8000001C
#define CEDAR_CONFIG8_ADDR	0x80000020
#define CEDAR_CONFIG9_ADDR	0x80000024
#define CEDAR_CONFIG10_ADDR	0x80000028
#define CEDAR_CONFIG11_ADDR	0x8000002C
#define CEDAR_CONFIG12_ADDR	0x80000030
#define CEDAR_CONFIG13_ADDR	0x80000034
#define CEDAR_CONFIG14_ADDR	0x80000038
#define CEDAR_CONFIG15_ADDR	0x8000003C
#define CEDAR_CONFIG16_ADDR	0x80000040
#define CEDAR_CONFIG17_ADDR	0x80000044
#define CEDAR_CONFIG18_ADDR	0x80000048
#define CEDAR_CONFIG19_ADDR	0x8000004C
#define CEDAR_CONFIG20_ADDR	0x80000050
#define CEDAR_CONFIG21_ADDR	0x80000054
#define CEDAR_CONFIG22_ADDR	0x80000058
#define CEDAR_CONFIG23_ADDR	0x8000005C
#define CEDAR_CONFIG24_ADDR	0x80000060
#define CEDAR_CONFIG25_ADDR	0x80000064
#define CEDAR_CMD 	       (PCFG04_command_ioena_m  | \
				PCFG04_command_memena_m | \
				PCFG04_command_bmena_m  | \
				PCFG04_command_mwinv_m  | \
				PCFG04_command_parena_m | \
				PCFG04_command_serrena_m )

#define CEDAR_STAT	       (PCFG04_status_mdpe_m | \
				PCFG04_status_sta_m  | \
				PCFG04_status_rta_m  | \
				PCFG04_status_rma_m  | \
				PCFG04_status_sse_m  | \
				PCFG04_status_pe_m)

#define CEDAR_CNFG1	      ((CEDAR_STAT << 16) | \
                                CEDAR_CMD)

#define CEDAR_REVID		0
#define CEDAR_CLASS_CODE	0
#define CEDAR_CNFG2	      ((CEDAR_CLASS_CODE << 8) | \
				CEDAR_REVID)

#define CEDAR_CACHE_LINE_SIZE	4
#define CEDAR_MASTER_LAT	0x3c
#define CEDAR_HEADER_TYPE	0
#define CEDAR_BIST		0

#define CEDAR_CNFG3           ((CEDAR_BIST        << 24) | \
		               (CEDAR_HEADER_TYPE << 16) | \
		               (CEDAR_MASTER_LAT  <<  8) | \
		                CEDAR_CACHE_LINE_SIZE)

#define CEDAR_BAR0	        0x00000008 /* 128 MB Memory */
#define CEDAR_BAR1	        0x18800001 /* 1 MB IO */
#define CEDAR_BAR2	        0x18000001 /* 2 MB IO window for Cedar
				              internal Registers */
#define CEDAR_BAR3	        0x48000008 /* Spare 128 MB Memory */

#define CEDAR_CNFG4	        CEDAR_BAR0
#define CEDAR_CNFG5             CEDAR_BAR1
#define CEDAR_CNFG6 	        CEDAR_BAR2
#define CEDAR_CNFG7	        CEDAR_BAR3

#define CEDAR_SUBSYS_VENDOR_ID  0
#define CEDAR_SUBSYSTEM_ID	0
#define CEDAR_CNFG8		0
#define CEDAR_CNFG9		0
#define CEDAR_CNFG10		0
#define CEDAR_CNFG11 	      ((CEDAR_SUBSYS_VENDOR_ID << 16) | \
			        CEDAR_SUBSYSTEM_ID)
#define CEDAR_INT_LINE		1
#define CEDAR_INT_PIN		1
#define CEDAR_MIN_GNT		8
#define CEDAR_MAX_LAT		0x38
#define CEDAR_CNFG12		0
#define CEDAR_CNFG13 		0
#define CEDAR_CNFG14		0
#define CEDAR_CNFG15	      ((CEDAR_MAX_LAT << 24) | \
			       (CEDAR_MIN_GNT << 16) | \
			       (CEDAR_INT_PIN <<  8) | \
			        CEDAR_INT_LINE)
#define	CEDAR_RETRY_LIMIT	0x80
#define CEDAR_TRDY_LIMIT	0x80
#define CEDAR_CNFG16          ((CEDAR_RETRY_LIMIT << 8) | \
			        CEDAR_TRDY_LIMIT)
#define PCI_PBAxC_R		0x0
#define PCI_PBAxC_RL		0x1
#define PCI_PBAxC_RM		0x2
#define SIZE_SHFT		2
#ifdef __MIPSEB__
#define CEDAR_PBA0C	       (PCIPBAC_mrl_m | \
			      ((PCI_PBAxC_RM & 0x3) << PCIPBAC_mr_b) | \
			        PCIPBAC_pp_m | \
				PCIPBAC_sb_m | \
			       (SIZE_128MB << SIZE_SHFT) | \
			        PCIPBAC_p_m)
#else
#define CEDAR_PBA0C	       (PCIPBAC_mrl_m | \
			      ((PCI_PBAxC_RM & 0x3) << PCIPBAC_mr_b) | \
			        PCIPBAC_pp_m | \
			       (SIZE_128MB << SIZE_SHFT) | \
			        PCIPBAC_p_m)
#endif
#define CEDAR_CNFG17	        CEDAR_PBA0C
#define CEDAR_PBA0M	        0x0
#define CEDAR_CNFG18	        CEDAR_PBA0M

#ifdef __MIPSEB__
#define CEDAR_PBA1C	      ((SIZE_1MB << SIZE_SHFT) | \
				PCIPBAC_sb_m | \
			        PCIPBAC_msi_m)
#else
#define CEDAR_PBA1C	      ((SIZE_1MB << SIZE_SHFT) | \
			        PCIPBAC_msi_m)
#endif
#define CEDAR_CNFG19	        CEDAR_PBA1C
#define CEDAR_PBA1M	        0x0
#define CEDAR_CNFG20	        CEDAR_PBA1M

#ifdef __MIPSEB__
#define CEDAR_PBA2C	      ((SIZE_2MB << SIZE_SHFT) |  \
				PCIPBAC_sb_m | \
			        PCIPBAC_msi_m)
#else
#define CEDAR_PBA2C	      ((SIZE_2MB << SIZE_SHFT) |  \
			        PCIPBAC_msi_m)
#endif

#define CEDAR_CNFG21	        CEDAR_PBA2C
#define CEDAR_PBA2M	        0x18000000
#define CEDAR_CNFG22	        CEDAR_PBA2M

#ifdef __MIPSEB__
#define CEDAR_PBA3C	        PCIPBAC_sb_m
#else
#define CEDAR_PBA3C	        0 
#endif

#define CEDAR_CNFG23	        CEDAR_PBA3C
#define CEDAR_PBA3M	        0
#define CEDAR_CNFG24	        CEDAR_PBA3M

#define	PCITC_DTIMER_VAL	8
#define PCITC_RTIMER_VAL	0x10

#endif /* _PCICEDAR_H */
