/*
 *  Copyright (C) 1998	Dan Malek <dmalek@jlc.net>
 *  Copyright (C) 1999	Magnus Damm <kieraypc01.p.y.kie.era.ericsson.se>
 *  Copyright (C) 2000,2001,2002 Wolfgang Denk <wd@denx.de>
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#include <config.h>
#include <mpc824x.h>
#include "version.h"

#define _LINUX_CONFIG_H 1	/* avoid reading Linux autoconf.h file	*/

#include <ppc_asm.tmpl>
#include <ppc_defs.h>

#include <asm/cache.h>
#include <asm/mmu.h>

#if CFG_BANK1_ENABLE
#define CFG_MEM_BAT2L	(CFG_MAX_RAM_SIZE | BATL_PP_10 | BATL_MEMCOHERENCE)
#define CFG_MEM_BAT2U	(CFG_MAX_RAM_SIZE | BATU_BL_256M | BATU_VS | BATU_VP)
        
#define CFG_FPGA_BAT2L	(0x70000000 | BATL_PP_10 | BATL_CACHEINHIBIT)
#define CFG_FPGA_BAT2U	(0x70000000 | BATU_BL_128K | BATU_VS | BATU_VP)

       	/* reconfigure BAT 1
	 */
        .text
        .align 2
        .globl  set_bat2_mem
set_bat2_mem:
	lis	r4, CFG_MEM_BAT2L@h
	ori	r4, r4, CFG_MEM_BAT2L@l
	lis	r3, CFG_MEM_BAT2U@h
	ori	r3, r3, CFG_MEM_BAT2U@l
	mtspr	IBAT2L, r4
	mtspr	IBAT2U, r3
	isync
        
	lis	r4, CFG_MEM_BAT2L@h
	ori	r4, r4, CFG_MEM_BAT2L@l
	lis	r3, CFG_MEM_BAT2U@h
	ori	r3, r3, CFG_MEM_BAT2U@l
	mtspr	DBAT2L, r4
	mtspr	DBAT2U, r3
	isync

	bclr    20,0


        .text
        .align 2
        .globl  set_bat2_fpga
set_bat2_fpga:
	lis	r4, CFG_FPGA_BAT2L@h
	ori	r4, r4, CFG_FPGA_BAT2L@l
	lis	r3, CFG_FPGA_BAT2U@h
	ori	r3, r3, CFG_FPGA_BAT2U@l
	mtspr	IBAT2L, r4
	mtspr	IBAT2U, r3
	isync
        
	lis	r4, CFG_FPGA_BAT2L@h
	ori	r4, r4, CFG_FPGA_BAT2L@l
	lis	r3, CFG_FPGA_BAT2U@h
	ori	r3, r3, CFG_FPGA_BAT2U@l
	mtspr	DBAT2L, r4
	mtspr	DBAT2U, r3
	isync

	bclr    20,0
#endif
