/*
 * MSwitch Functions
 */
#ifndef	_CMD_CABERNET_H
#define _CMD_CABERNET_H

#if (CONFIG_COMMANDS & CFG_CMD_CABERNET)

#undef CMD_TBL_ETHER
#define CMD_TBL_ETHER	MK_CMD_TBL_ENTRY(				\
	"ether",        3,	6,	1,	do_cabernet_ether,	\
	"ether   - Ethernet sub-system\n",	                	\
	"device-name [len|incr] [cnt] [vlan] [rcv]\n"          	        \
        "    - send and receive ethernet frames\n"	                \
),
#define CMD_TBL_CAB	MK_CMD_TBL_ENTRY(			        \
	"cab",	        3,	5,	1,	do_cabernet_cab,	\
	"cab    - Cabernet FPGA sub-system\n",                		\
	"read  offset [cnt [times]]\n"         	                	\
	"cab write offset data [times]\n"             	                \
	"cab init\n"                                          	        \
        "    - read/write Cabernet FPGA register(s)\n"	                \
),
#define CMD_TBL_ROBO	MK_CMD_TBL_ENTRY(				\
	"robo",	        2,	7,	1,	do_cabernet_robo,       \
	"robo     - RobotSwitch sub-system\n",                		\
	"read page addr length [times]\n"           	                \
	"robo write page addr length data [times]\n"        	        \
	"robo init  [fbm2|bridge]\n"                           	        \
	"robo stats [port|clear]\n"                   	                \
        "    - read/write/init Robo register(s) or display stats\n"     \
),
#define CMD_TBL_SOE	MK_CMD_TBL_ENTRY(				\
	"soe",	        3,	12,	1,	do_cabernet_soe,	\
	"soe   - Cabernet FPGA SOE sub-system\n",			\
	"connect eport iport|loop|cr [string]\n"                        \
        "    - connect to external serial device\n"	                \
),
#undef CMD_TBL_POE
#define CMD_TBL_POE	MK_CMD_TBL_ENTRY(				\
	"poe",	        3,       7,     1,	do_cabernet_poe,	\
	"poe     - POE sub-system\n",	                                \
	"init\n"       	                	                        \
	"poe up port [ms]\n"          	                	        \
	"poe down port\n"          	                	        \
	"poe present port resistor|capacitor\n"                	        \
	"poe sample port voltage|current\n"                             \
	"poe calibrate port\n"                                          \
	"poe registers\n"                                               \
        "    - init POE or ramp up/down or detect/sample POE port\n"	\
),
#undef CMD_TBL_UARTB
#define CMD_TBL_UARTB	MK_CMD_TBL_ENTRY(				\
	"uartb",	5,	7,	1,	do_cabernet_uartb,	\
	"uartb   - uartb connect\n",					\
	"[string]\n"                                            	\
	"    - connect uarta to uartb or send string\n"                 \
),
#undef CMD_TBL_PHY
#define CMD_TBL_PHY	MK_CMD_TBL_ENTRY(				\
	"phy",	        3,	6,	1,	do_cabernet_phy,	\
	"phy     - Cabernet PHY sub-system\n",	                	\
	"read  device [register] [cnt [times]]\n"             	        \
	"phy write device register data [times]\n"            	        \
	"phy link\n"                                    	        \
        "    - read/write PHY register(s) or display link status\n"     \
),
#undef CMD_TBL_UPGRADE
#define CMD_TBL_UPGRADE	MK_CMD_TBL_ENTRY(				\
	"upgrade",       2,	3,	1,	do_cabernet_upgrade,	\
	"upgrade - upgrade compact FLASH partition\n",	       	        \
	"init|([device:]partition filename)\n"                          \
        "    - init or TFTP file into compact FLASH partition\n"        \
),
#undef CMD_TBL_BOOTF
#define CMD_TBL_BOOTF	MK_CMD_TBL_ENTRY(				\
	"bootf",        5,	2,	1,	do_cabernet_bootf,	\
	"bootf   - boot from an ELF image in FLASH\n",          	\
	"[[device:]partition]\n"                       	                \
        "    - Boot ELF file from FLASH image (0/1)\n"                  \
),
#undef CMD_TBL_PART
#define CMD_TBL_PART	MK_CMD_TBL_ENTRY(				\
	"part",        4,	2,	1,	do_cabernet_part,	\
	"part    - Partition compact FLASH device\n",                   \
	"[device]\n"                                 	                \
        "    - Partition compact FLASH device into 2 images and 1 FFS\n"\
),
#undef CMD_TBL_FORMAT
#define CMD_TBL_FORMAT	MK_CMD_TBL_ENTRY(				\
	"format",        4,	3,	1,	do_cabernet_format,	\
	"format  - Format compact FLASH device\n",                      \
	"[device][:partition] [verify]\n"                               \
        "    - Format compact FLASH device\n"                           \
),
#undef CMD_TBL_FPGA
#define CMD_TBL_FPGA	MK_CMD_TBL_ENTRY(				\
	"fpga",          2,	3,	1,	do_cabernet_fpga,	\
	"fpga    - FPGA sub-system\n",                                  \
	"program filename\n"         	                                \
        "    - Program FPGA\n"                                          \
),

int do_cabernet_ether  (cmd_tbl_t *, bd_t *, int flag, int argc, char *argv[]);
int do_cabernet_cab    (cmd_tbl_t *, bd_t *, int flag, int argc, char *argv[]);
int do_cabernet_robo   (cmd_tbl_t *, bd_t *, int flag, int argc, char *argv[]);
int do_cabernet_soe    (cmd_tbl_t *, bd_t *, int flag, int argc, char *argv[]);
int do_cabernet_poe    (cmd_tbl_t *, bd_t *, int flag, int argc, char *argv[]);
int do_cabernet_uartb  (cmd_tbl_t *, bd_t *, int flag, int argc, char *argv[]);
int do_cabernet_phy    (cmd_tbl_t *, bd_t *, int flag, int argc, char *argv[]);
int do_cabernet_upgrade(cmd_tbl_t *, bd_t *, int flag, int argc, char *argv[]);
int do_cabernet_bootf  (cmd_tbl_t *, bd_t *, int flag, int argc, char *argv[]);
int do_cabernet_part   (cmd_tbl_t *, bd_t *, int flag, int argc, char *argv[]);
int do_cabernet_format (cmd_tbl_t *, bd_t *, int flag, int argc, char *argv[]);
int do_cabernet_fpga   (cmd_tbl_t *, bd_t *, int flag, int argc, char *argv[]);

#else	/* ! CFG_CMD_CABERNET */

#ifndef CMD_TBL_ETHER
#define CMD_TBL_ETHER
#endif
#define CMD_TBL_CAB
#define CMD_TBL_ROBO
#define CMD_TBL_SOE
#ifndef CMD_TBL_POE
#define CMD_TBL_POE
#endif
#ifndef CMD_TBL_UARTB
#define CMD_TBL_UARTB
#endif
#ifndef CMD_TBL_PHY
#define CMD_TBL_PHY
#endif
#ifndef CMD_TBL_UPGRADE
#define CMD_TBL_UPGRADE
#endif
#ifndef CMD_TBL_BOOTF
#define CMD_TBL_BOOTF
#endif
#ifndef CMD_TBL_PART
#define CMD_TBL_PART
#endif
#ifndef CMD_TBL_FORMAT
#define CMD_TBL_FORMAT
#endif
#ifndef CMD_TBL_FPGA
#define CMD_TBL_FPGA
#endif

#endif	/* CFG_CMD_CABERNET */

#endif /* _CMD_CABERNET_H */
