/*
 * MSwitch Functions
 */
#ifndef	_CMD_MALBEC_H
#define _CMD_MALBEC_H

#if (CONFIG_COMMANDS & CFG_CMD_MALBEC)

#undef CMD_TBL_ETHER
#define CMD_TBL_ETHER	MK_CMD_TBL_ENTRY(				\
	"ether",        3,	6,	1,	do_malbec_ether,	\
	"ether   - Ethernet sub-system\n",	                	\
	"device-name [len|incr] [cnt] [vlan] [rcv]\n"          	        \
        "    - send and receive ethernet frames\n"	                \
),
#undef CMD_TBL_UARTB
#define CMD_TBL_UARTB	MK_CMD_TBL_ENTRY(				\
	"uartb",	5,	7,	1,	do_malbec_uartb,	\
	"uartb   - uartb connect\n",					\
	"[string]\n"                                            	\
	"    - connect uarta to uartb or send string\n"                 \
),
#undef CMD_TBL_UPGRADE
#define CMD_TBL_UPGRADE	MK_CMD_TBL_ENTRY(				\
	"upgrade",       2,	3,	1,	do_malbec_upgrade,	\
	"upgrade - upgrade compact FLASH partition\n",	       	        \
	"init|([device:]partition filename)\n"                          \
        "    - init or TFTP file into compact FLASH partition\n"        \
),
#undef CMD_TBL_BOOTF
#define CMD_TBL_BOOTF	MK_CMD_TBL_ENTRY(				\
	"bootf",        5,	2,	1,	do_malbec_bootf,	\
	"bootf   - boot from an ELF image in FLASH\n",          	\
	"[[device:]partition]\n"                       	                \
        "    - Boot ELF file from FLASH image (0/1)\n"                  \
),
#undef CMD_TBL_PART
#define CMD_TBL_PART	MK_CMD_TBL_ENTRY(				\
	"part",        4,	2,	1,	do_malbec_part,	\
	"part    - Partition compact FLASH device\n",                   \
	"[device]\n"                                 	                \
        "    - Partition compact FLASH device into 2 images and 1 FFS\n"\
),
#undef CMD_TBL_FORMAT
#define CMD_TBL_FORMAT	MK_CMD_TBL_ENTRY(				\
	"format",        4,	3,	1,	do_malbec_format,	\
	"format  - Format compact FLASH device\n",                      \
	"[device][:partition] [verify]\n"                               \
        "    - Format compact FLASH device\n"                           \
),

int do_malbec_ether  (cmd_tbl_t *, bd_t *, int flag, int argc, char *argv[]);
int do_malbec_uartb  (cmd_tbl_t *, bd_t *, int flag, int argc, char *argv[]);
int do_malbec_upgrade(cmd_tbl_t *, bd_t *, int flag, int argc, char *argv[]);
int do_malbec_bootf  (cmd_tbl_t *, bd_t *, int flag, int argc, char *argv[]);
int do_malbec_part   (cmd_tbl_t *, bd_t *, int flag, int argc, char *argv[]);
int do_malbec_format (cmd_tbl_t *, bd_t *, int flag, int argc, char *argv[]);

#else	/* ! CFG_CMD_MALBEC */

#ifndef CMD_TBL_ETHER
#define CMD_TBL_ETHER
#endif
#ifndef CMD_TBL_UARTB
#define CMD_TBL_UARTB
#endif
#ifndef CMD_TBL_UPGRADE
#define CMD_TBL_UPGRADE
#endif
#ifndef CMD_TBL_BOOTF
#define CMD_TBL_BOOTF
#endif
#ifndef CMD_TBL_PART
#define CMD_TBL_PART
#endif
#ifndef CMD_TBL_FORMAT
#define CMD_TBL_FORMAT
#endif

#endif	/* CFG_CMD_MALBEC */

#endif /* _CMD_MALBEC_H */
