/*
 * Nebbiolo Functions
 */
#ifndef	_CMD_NEBBIOLO_H
#define _CMD_NEBBIOLO_H

#if (CONFIG_COMMANDS & CFG_CMD_NEBBIOLO)

#define CMD_TBL_ETHER	MK_CMD_TBL_ENTRY(				\
	"ether",        3,	5,	1,	do_nebbiolo_ether,	\
	"ether   - Ethernet sub-system\n",	                	\
	"device-name [len|incr] [cnt] [rcv]\n"                	        \
        "    - send and receive ethernet frames\n"	                \
),
#define CMD_TBL_SCCI	MK_CMD_TBL_ENTRY(				\
	"scci",	        2,	5,	1,	do_nebbiolo_scci,	\
	"scci    - SCCI sub-system\n",	                		\
	"read  offset [cnt [times]]\n"         	                	\
	"scci write offset data [times]\n"             	                \
	"scci init\n"                                          	        \
        "    - read/write SCCI register(s)\n"	                        \
),
#define CMD_TBL_LCCI	MK_CMD_TBL_ENTRY(				\
	"lcci",	        2,	6,	1,	do_nebbiolo_lcci,	\
	"lcci    - LCCI sub-system\n",	                		\
	"read  linecard offset [cnt [times]]\n"        	                \
	"lcci write linecard offset data [times]\n"           	        \
	"lcci init  linecard [fab-mask]\n"                     	        \
        "    - read/write/init line card\n"                             \
),
#define CMD_TBL_CXE	MK_CMD_TBL_ENTRY(				\
	"cxe",	        2,	7,	1,	do_nebbiolo_cxe,	\
	"cxe     - CXE sub-system\n",	                		\
	"read  linecard bank offset [cnt [times]]\n"           	        \
	"cxe write linecard bank offset data [times]\n"        	        \
	"cxe init  linecard [fbm2|bridge]\n"                           	\
	"cxe init  linecard\n"                           	        \
	"cxe stats linecard [port]\n"                       	        \
	"cxe queue linecard\n"                       	                \
	"cxe tcam  linecard\n"                           	        \
        "    - read/write/init CXE register(s) or display stats/tcam\n" \
),
#define CMD_TBL_IEEPRO
#define CMD_TBL_LI2C	MK_CMD_TBL_ENTRY(				\
	"li2c",	        2,	7,	1,	do_nebbiolo_li2c,	\
	"li2c    - LCCI I2C sub-system\n",	                	\
	"read  linecard device register [cnt [times]]\n"               	\
	"li2c write linecard device register data [times]\n"           	\
        "    - read/write I2C register(s)\n"	                        \
),
#define CMD_TBL_LUART	MK_CMD_TBL_ENTRY(				\
	"luart",	2,	12,	1,	do_nebbiolo_luart,	\
	"luart   - LCCI UART sub-system\n",				\
	"read    linecard device register [cnt [times]]\n"            	\
	"luart write   linecard device register data [times]\n"        	\
	"luart connect linecard eport iport|loop|cr [string]\n"         \
        "    - read/write LCCI UART register(s) or connect\n"	        \
),
#define CMD_TBL_POE	MK_CMD_TBL_ENTRY(				\
	"poe",	        3, CFG_MAXARGS, 1,	do_nebbiolo_poe,	\
	"poe     - POE sub-system\n",	                	        \
	"send    linecard msg\n"                	                \
	"poe program linecard filename\n"                               \
        "    - send msg to POE device\n"	                        \
),
#define CMD_TBL_GBIC	MK_CMD_TBL_ENTRY(				\
	"gbic",	        3,	7,	1,	do_nebbiolo_gbic,	\
	"gbic    - GBIC sub-system\n",					\
	"read linecard device register [cnt [times]]\n"                 \
	"gbic dump linecard device [times]\n"                         	\
        "    - GBIC EEPROM display\n"	                                \
),
#define CMD_TBL_UARTB	MK_CMD_TBL_ENTRY(				\
	"uartb",	5,	2,	1,	do_nebbiolo_uartb,	\
	"uartb   - uartb connect\n",					\
	"[string]\n"                                            	\
	"    - connect uarta to uartb or send string\n"                 \
),
#define CMD_TBL_PHY	MK_CMD_TBL_ENTRY(				\
	"phy",	        3,	7,	1,	do_nebbiolo_phy,	\
	"phy     - CXE PHY sub-system\n",	                	\
	"read  linecard device [register] [cnt [times]]\n"             	\
	"phy write linecard device register data [times]\n"            	\
	"phy link  linecard\n"                                    	\
        "    - read/write PHY register(s) or display link status\n"     \
),
#define CMD_TBL_UPGRADE	MK_CMD_TBL_ENTRY(				\
	"upgrade",       2,	3,	1,	do_nebbiolo_upgrade,	\
	"upgrade - upgrade compact FLASH partition\n",	       	        \
	"[device:]partition filename\n"                                 \
        "    - TFTP file into compact FLASH partition\n"                \
),
#define CMD_TBL_BOOTF	MK_CMD_TBL_ENTRY(				\
	"bootf",        5,	2,	1,	do_nebbiolo_bootf,	\
	"bootf   - boot from an ELF image in FLASH\n",          	\
	"[[device:]partition]\n"                       	                \
        "    - Boot ELF file from FLASH image (0/1)\n"                  \
),
#define CMD_TBL_PART	MK_CMD_TBL_ENTRY(				\
	"part",        4,	2,	1,	do_nebbiolo_part,	\
	"part    - Partition compact FLASH device\n",                   \
	"[device]\n"                                 	                \
        "    - Partition compact FLASH device into 2 images and 1 FFS\n"\
),
#define CMD_TBL_FORMAT	MK_CMD_TBL_ENTRY(				\
	"format",        4,	2,	1,	do_nebbiolo_format,	\
	"format  - Format compact FLASH device\n",                      \
	"[device][:partition]\n"                                        \
        "    - Format compact FLASH device\n"                           \
),
#define CMD_TBL_FPGA	MK_CMD_TBL_ENTRY(				\
	"fpga",        2,	4,	1,	do_nebbiolo_fpga,	\
	"fpga    - FPGA sub-system\n",                                  \
	"program [linecard|crypto] filename\n"         	                \
	"fpga id linecard\n"                  	                        \
        "    - Program FPGA on SC/LC or read LC FPGA ID\n"              \
),

int do_nebbiolo_ether(cmd_tbl_t *, bd_t *bd, int flag, int argc, char *argv[]);
int do_nebbiolo_scci (cmd_tbl_t *, bd_t *bd, int flag, int argc, char *argv[]);
int do_nebbiolo_lcci (cmd_tbl_t *, bd_t *bd, int flag, int argc, char *argv[]);
int do_nebbiolo_cxe  (cmd_tbl_t *, bd_t *bd, int flag, int argc, char *argv[]);
int do_nebbiolo_li2c (cmd_tbl_t *, bd_t *bd, int flag, int argc, char *argv[]);
int do_nebbiolo_luart(cmd_tbl_t *, bd_t *bd, int flag, int argc, char *argv[]);
int do_nebbiolo_poe  (cmd_tbl_t *, bd_t *bd, int flag, int argc, char *argv[]);
int do_nebbiolo_gbic (cmd_tbl_t *, bd_t *bd, int flag, int argc, char *argv[]);
int do_nebbiolo_uartb(cmd_tbl_t *, bd_t *bd, int flag, int argc, char *argv[]);
int do_nebbiolo_phy  (cmd_tbl_t *, bd_t *bd, int flag, int argc, char *argv[]);
int do_nebbiolo_upgrade(cmd_tbl_t *, bd_t *bd, int flag, int argc, char *argv[]);
int do_nebbiolo_bootf(cmd_tbl_t *, bd_t *bd, int flag, int argc, char *argv[]);
int do_nebbiolo_part (cmd_tbl_t *, bd_t *bd, int flag, int argc, char *argv[]);
int do_nebbiolo_format(cmd_tbl_t *, bd_t *bd, int flag, int argc, char *argv[]);
int do_nebbiolo_fpga (cmd_tbl_t *, bd_t *bd, int flag, int argc, char *argv[]);

#else	/* ! CFG_CMD_NEBBIOLO */

#define CMD_TBL_ETHER
#define CMD_TBL_SCCI
#define CMD_TBL_LCCI
#define CMD_TBL_CXE
#define CMD_TBL_LI2C
#define CMD_TBL_LUART
#define CMD_TBL_POE
#define CMD_TBL_GBIC
#define CMD_TBL_UARTB
#define CMD_TBL_PHY
#define CMD_TBL_IEEPRO
#define CMD_TBL_UPGRADE
#define CMD_TBL_BOOTF
#define CMD_TBL_PART
#define CMD_TBL_FORMAT
#define CMD_TBL_FPGA

#endif	/* CFG_CMD_NEBBIOLO */

#endif /* _CMD_NEBBIOLO_H */
