/*
 * MSwitch Functions
 */
#ifndef	_CMD_SYRAH_H
#define _CMD_SYRAH_H

#if (CONFIG_COMMANDS & CFG_CMD_SYRAH)

#undef CMD_TBL_ETHER
#define CMD_TBL_ETHER	MK_CMD_TBL_ENTRY(				\
	"ether",        3,	6,	1,	do_syrah_ether,	        \
	"ether   - Ethernet sub-system\n",	                	\
	"device-name [len|incr] [cnt] [vlan] [rcv]\n"                	\
        "    - send and receive ethernet frames\n"	                \
),
#define CMD_TBL_SYRAH	MK_CMD_TBL_ENTRY(				\
	"syrah",	2,	5,	1,	do_syrah_syrah,	        \
	"syrah    - Syrah FPGA sub-system\n",	                	\
	"read  offset [cnt [times]]\n"         	                	\
	"syrah write offset data [times]\n"             	        \
	"syrah init\n"                                          	\
        "    - read/write SYRAH register(s)\n"	                        \
),
#undef CMD_TBL_CXE
#define CMD_TBL_CXE	MK_CMD_TBL_ENTRY(				\
	"cxe",	        2,	6,	1,	do_syrah_cxe,	        \
	"cxe     - CXE sub-system\n",	                		\
	"read  bank offset [cnt [times]]\n"           	                \
	"cxe write bank offset data [times]\n"        	                \
	"cxe init  [fbm2|bridge]\n"                           	        \
	"cxe init\n"                           	                        \
	"cxe stats [port]\n"                       	                \
	"cxe queue\n"                       	                        \
	"cxe tcam\n"                           	                        \
        "    - read/write/init CXE register(s) or display stats/tcam\n" \
),
#undef CMD_TBL_SOE
#define CMD_TBL_SOE	MK_CMD_TBL_ENTRY(				\
	"soe",	        3,	12,	1,	do_syrah_soe,	        \
	"soe   - Syrah FPGA SOE sub-system\n",			        \
	"connect eport iport|loop|cr [string]\n"                        \
        "    - connect to external serial device\n"	                \
),
#undef CMD_TBL_POE
#define CMD_TBL_POE	MK_CMD_TBL_ENTRY(				\
	"poe",	        3,       7,     1,	do_syrah_poe,	        \
	"poe     - POE sub-system\n",	                                \
	"init\n"       	                	                        \
	"poe up port [ramps] [ms gap]\n"                 	        \
	"poe down port\n"          	                	        \
	"poe present port resistor|capacitor\n"                	        \
	"poe sample port voltage|current\n"                             \
	"poe calibrate port\n"                                          \
        "    - init POE or ramp up/down or detect/sample POE port\n"	\
),
#undef CMD_TBL_GBIC
#define CMD_TBL_GBIC	MK_CMD_TBL_ENTRY(				\
	"gbic",	        3,	6,	1,	do_syrah_gbic,	        \
	"gbic    - GBIC sub-system\n",					\
	"read device register [cnt [times]]\n"                          \
	"gbic dump device [times]\n"                         	        \
        "    - GBIC EEPROM display\n"	                                \
),
#undef CMD_TBL_UARTB
#define CMD_TBL_UARTB	MK_CMD_TBL_ENTRY(				\
	"uartb",	5,	7,	1,	do_syrah_uartb,	        \
	"uartb   - uartb connect\n",					\
	"[string]\n"                                            	\
	"    - connect uarta to uartb or sending string\n"              \
),
#undef CMD_TBL_PHY
#define CMD_TBL_PHY	MK_CMD_TBL_ENTRY(				\
	"phy",	        3,	6,	1,	do_syrah_phy,	        \
	"phy     - CXE PHY sub-system\n",	                	\
	"read  device [register] [cnt [times]]\n"             	        \
	"phy write device register data [times]\n"            	        \
	"phy link\n"                                    	        \
        "    - read/write PHY register(s) or display link status\n"     \
),
#undef CMD_TBL_UPGRADE
#define CMD_TBL_UPGRADE	MK_CMD_TBL_ENTRY(				\
	"upgrade",       2,	3,	1,	do_syrah_upgrade,	\
	"upgrade - upgrade compact FLASH partition\n",	       	        \
	"init|([device:]partition filename)\n"                          \
        "    - TFTP file into compact FLASH partition\n"                \
),
#undef CMD_TBL_BOOTF
#define CMD_TBL_BOOTF	MK_CMD_TBL_ENTRY(				\
	"bootf",        5,	2,	1,	do_syrah_bootf,	        \
	"bootf   - boot from an ELF image in FLASH\n",          	\
	"[[device:]partition]\n"                       	                \
        "    - Boot ELF file from FLASH image (0/1)\n"                  \
),
#undef CMD_TBL_PART
#define CMD_TBL_PART	MK_CMD_TBL_ENTRY(				\
	"part",        4,	2,	1,	do_syrah_part,	        \
	"part    - Partition compact FLASH device\n",                   \
	"[device]\n"                                 	                \
        "    - Partition compact FLASH device into 2 images and 1 FFS\n"\
),
#undef CMD_TBL_FORMAT
#define CMD_TBL_FORMAT	MK_CMD_TBL_ENTRY(				\
	"format",        4,	3,	1,	do_syrah_format,	\
	"format  - Format compact FLASH device\n",                      \
	"[device][:partition] [verify]\n"                               \
        "    - Format compact FLASH device\n"                           \
),
#undef CMD_TBL_FPGA
#define CMD_TBL_FPGA	MK_CMD_TBL_ENTRY(				\
	"fpga",        2,	3,	1,	do_syrah_fpga,	        \
	"fpga    - FPGA sub-system\n",                                  \
	"program filename\n"         	                                \
        "    - Program FPGA on SC/LC or read LC FPGA ID\n"              \
),

int do_syrah_ether(cmd_tbl_t *, bd_t *bd, int flag, int argc, char *argv[]);
int do_syrah_syrah (cmd_tbl_t *, bd_t *bd, int flag, int argc, char *argv[]);
int do_syrah_cxe  (cmd_tbl_t *, bd_t *bd, int flag, int argc, char *argv[]);
int do_syrah_soe  (cmd_tbl_t *, bd_t *bd, int flag, int argc, char *argv[]);
int do_syrah_poe  (cmd_tbl_t *, bd_t *bd, int flag, int argc, char *argv[]);
int do_syrah_gbic  (cmd_tbl_t *, bd_t *bd, int flag, int argc, char *argv[]);
int do_syrah_uartb(cmd_tbl_t *, bd_t *bd, int flag, int argc, char *argv[]);
int do_syrah_phy  (cmd_tbl_t *, bd_t *bd, int flag, int argc, char *argv[]);
int do_syrah_upgrade(cmd_tbl_t *, bd_t *bd, int flag, int argc, char *argv[]);
int do_syrah_bootf(cmd_tbl_t *, bd_t *bd, int flag, int argc, char *argv[]);
int do_syrah_part (cmd_tbl_t *, bd_t *bd, int flag, int argc, char *argv[]);
int do_syrah_format(cmd_tbl_t *, bd_t *bd, int flag, int argc, char *argv[]);
int do_syrah_fpga (cmd_tbl_t *, bd_t *bd, int flag, int argc, char *argv[]);

#else	/* ! CFG_CMD_SYRAH */

#ifndef CMD_TBL_ETHER
#define CMD_TBL_ETHER
#endif
#define CMD_TBL_SYRAH
#ifndef CMD_TBL_CXE
#define CMD_TBL_CXE
#endif
#ifndef CMD_TBL_SOE
#define CMD_TBL_SOE
#endif
#ifndef CMD_TBL_POE
#define CMD_TBL_POE
#endif
#ifndef CMD_TBL_GBIC
#define CMD_TBL_GBIC
#endif
#ifndef CMD_TBL_UARTB
#define CMD_TBL_UARTB
#endif
#ifndef CMD_TBL_PHY
#define CMD_TBL_PHY
#endif
#ifndef CMD_TBL_UPGRADE
#define CMD_TBL_UPGRADE
#endif
#ifndef CMD_TBL_BOOTF
#define CMD_TBL_BOOTF
#endif
#ifndef CMD_TBL_PART
#define CMD_TBL_PART
#endif
#ifndef CMD_TBL_FORMAT
#define CMD_TBL_FORMAT
#endif
#ifndef CMD_TBL_FPGA
#define CMD_TBL_FPGA
#endif

#endif	/* CFG_CMD_SYRAH */

#endif /* _CMD_SYRAH_H */
