/*
 * (C) Copyright 2001, 2002
 * Wolfgang Denk, DENX Software Engineering, wd@denx.de.
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

/* ------------------------------------------------------------------------- */

/*
 * board/config.h - configuration options, board specific
 */

#ifndef __CONFIG_H
#define __CONFIG_H

/*
 * High Level Configuration Options
 * (easy to change)
 */

#define	PPCBOOT_VERSION	        "APBoot 1.2.3"

#define CONFIG_MPC824X		1
#define CONFIG_MPC8245		1
#define CONFIG_ASAP 		1

#define CONFIG_CONS_INDEX	1
#define CONFIG_BAUDRATE		9600
#define CONFIG_WATCHDOG

#define CONFIG_BOARD_PRE_INIT

#define CONFIG_COMMANDS  	(CONFIG_CMD_DFL | \
		                 CFG_CMD_ELF    | \
                                 CFG_CMD_DHCP   | \
                                 CFG_CMD_ADP    | \
                                 CFG_CMD_NET )

#define CONFIG_BOOTP_MASK       (CONFIG_BOOTP_DNS | \
                                 CONFIG_BOOTP_SUBNETMASK | \
                                 CONFIG_BOOTP_DOMAINNAME | \
                                 CONFIG_BOOTP_VENDORSPEC | \
                                 CONFIG_BOOTP_VENDORCLASS | \
                                 CONFIG_BOOTP_GATEWAY)

#define CONFIG_BOOTP_VENDOR     "ArubaAP"

#define CONFIG_BOOTCOMMAND      "tftpboot"
#define CONFIG_BOOTDELAY        2
#define CONFIG_BOOT_RETRY_TIME  120
#define CONFIG_RESET_TO_RETRY
#define CONFIG_AUTOSTART        "yes"
#define CONFIG_SERVERNAME       "aruba-master"
#define CONFIG_BOOTFILE         "sap.bin"
#define CONFIG_LAST_STAGE_INIT

/* this must be included AFTER the definition of CONFIG_COMMANDS (if any)	*/
#include <cmd_confdefs.h>

/*
 * Miscellaneous configurable options
 */
#define CFG_LONGHELP	        1   		/* undef to save memory		*/
#define CFG_PROMPT		"apboot> "	/* Monitor Command Prompt	*/
#define CFG_CBSIZE		256	    	/* Console I/O Buffer Size	*/
#define CFG_CONSOLE_INFO_QUIET

/* Print Buffer Size
 */
#define CFG_PBSIZE      (CFG_CBSIZE+sizeof(CFG_PROMPT)+16)	/* Print Buffer Size	*/
#define CFG_MAXARGS		16		/* max number of command args	*/
#define CFG_BARGSIZE	CFG_CBSIZE	/* Boot Argument Buffer Size	*/
#define CFG_LOAD_ADDR	0x00100000	/* default load address		*/

#define CFG_HZ			1000		/* decrementer freq: 1 ms ticks */

/*-----------------------------------------------------------------------
 * PCI stuff
 *-----------------------------------------------------------------------
 */
#define CONFIG_PCI			/* include pci support		*/

#define PCI_BASE_IOADDR	    0xfe000000      /* matches BAT3 */     
#define PCI_BASE_MEMADDR    0xf0000000


#define CONFIG_NET_MULTI			/* Multi ethernet cards support */
#define CONFIG_TULIP
#undef CONFIG_EEPRO100


/*-----------------------------------------------------------------------
 * Start addresses for the final memory configuration
 * (Set up by the startup code)
 * Please note that CFG_SDRAM_BASE _must_ start at 0
 */
#define CFG_DRAM_TEST
#define CFG_SDRAM_BASE		0x00000000
#define CFG_MAX_RAM_SIZE	0x01000000

#define CFG_RESET_ADDRESS	0xFFF00110

#undef	CFG_RAMBOOT
#define CFG_MONITOR_LEN		0x00040000
#define CFG_MONITOR_BASE	TEXT_BASE

#define CFG_INIT_DATA_SIZE	128
#define CFG_INIT_RAM_ADDR   0x40000000
#define CFG_INIT_RAM_END    0x1000
#define CFG_INIT_DATA_OFFSET    (CFG_INIT_RAM_END - CFG_INIT_DATA_SIZE)

#define CFG_FLASH_BASE		0xFFC00000     /* SMC was ff800000 */

#define CFG_MALLOC_LEN		(256 << 10)	/* Reserve 256 kB for malloc()	*/

#define CFG_MEMTEST_START	0x00010000	/* memtest works on		*/
#define CFG_MEMTEST_END		(bd->bi_memsize - 0x100000)

#define CFG_EUMB_ADDR		0xFC000000      /* match linux */

#define CFG_BAUDRATE_TABLE	{ 9600, 19200, 38400, 57600, 115200 }
#define CFG_FLASH_BANKS		{ CFG_FLASH_BASE }

/*-----------------------------------------------------------------------
 * Definitions for initial stack pointer and data area (in DPRAM)
 */

/*
 * Low Level Configuration Settings
 * (address mappings, register initial values, etc.)
 * You should know what you are doing if you make changes here.
 */

#define CONFIG_SYS_CLK_FREQ  33333333	/* external frequency to pll */
#define CONFIG_BUS_CLK_FREQ 100000000	/* memory bus speed */        

#define CFG_ROMNAL		0xf	/* rom/flash next access time	*/
#define CFG_ROMFAL		11	/* rom/flash access time	*/
#define CFG_REFINT	    430	/* cycles between CBR refresh cycles */

/* the following are for SDRAM only*/
#define CFG_BSTOPRE	    121	/* Burst To Precharge, open page  */
#define CFG_REFREC		8	/* Refresh to activate interval	  */
#define CFG_RDLAT		4	/* data latency from read command */
#define CFG_PRETOACT	3	/* Precharge to activate interval */
#define CFG_ACTTOPRE	5	/* Activate to Precharge interval */
#define CFG_ACTORW		3	/* Activate to R/W		  */
#define CFG_SDMODE_CAS_LAT	3	/* SDMODE CAS latency		  */
#define CFG_SDMODE_BURSTLEN 2
#define CFG_SDMODE_WRAP		0	/* SDMODE wrap type		  */

#define CFG_REGISTERD_TYPE_BUFFER   1
#define CFG_REGDIMM                 0


/* memory bank settings*/
/*
 * only bits 20-29 are actually used from these vales to set the
 * start/end address the upper two bits will be 0, and the lower 20
 * bits will be set to 0x00000 for a start address, or 0xfffff for an
 * end address
 */
#define CFG_BANK0_START		0x00000000
#define CFG_BANK0_END		(CFG_MAX_RAM_SIZE - 1)
#define CFG_BANK0_ENABLE	1
#define CFG_BANK0_ROW           0x0 /* 11/12 x N x 4 */
#define CFG_BANK1_START		0x3ff00000
#define CFG_BANK1_END		0x3fffffff
#define CFG_BANK1_ENABLE	0
#define CFG_BANK2_START		0x3ff00000
#define CFG_BANK2_END		0x3fffffff
#define CFG_BANK2_ENABLE	0
#define CFG_BANK3_START		0x3ff00000
#define CFG_BANK3_END		0x3fffffff
#define CFG_BANK3_ENABLE	0
#define CFG_BANK4_START		0x00000000
#define CFG_BANK4_END		0x00000000
#define CFG_BANK4_ENABLE	0
#define CFG_BANK5_START		0x00000000
#define CFG_BANK5_END		0x00000000
#define CFG_BANK5_ENABLE	0
#define CFG_BANK6_START		0x00000000
#define CFG_BANK6_END		0x00000000
#define CFG_BANK6_ENABLE	0
#define CFG_BANK7_START		0x00000000
#define CFG_BANK7_END		0x00000000
#define CFG_BANK7_ENABLE	0

/*
 * Memory bank enable bitmask, specifying which of the banks defined above
 are actually present. MSB is for bank #7, LSB is for bank #0.
 */
#define CFG_BANK_ENABLE		0x01

#define CFG_ODCR		    0x95	/* configures line driver impedances,	*/
#define CFG_PGMAX		    0x32	/* how long the 8245 retains a page	*/
#define CFG_DBUS_SIZE2      0       /* set MCCR4 DBUS_SIZE2 bit */

#define CFG_IBAT0L       0x00000032
#define CFG_IBAT0U       0x000007FF /* 1ff used for 16MB */
                   
#define CFG_IBAT1L       0xF000002A
#define CFG_IBAT1U       0xF0001FFF

/* CPLD and FPGD memory */
#define CFG_IBAT2L	 (0x70000000 | BATL_PP_10 | BATL_CACHEINHIBIT)
#define CFG_IBAT2U	 (0x70000000 | BATU_BL_256M| BATU_VS | BATU_VP)

#define CFG_IBAT3L       (CFG_INIT_RAM_ADDR | BATL_PP_10 | BATL_MEMCOHERENCE)
#define CFG_IBAT3U       (CFG_INIT_RAM_ADDR | BATU_BL_128K | BATU_VS | BATU_VP)


#define CFG_DBAT0L	CFG_IBAT0L
#define CFG_DBAT0U	CFG_IBAT0U
#define CFG_DBAT1L	CFG_IBAT1L
#define CFG_DBAT1U	CFG_IBAT1U
#define CFG_DBAT2L	CFG_IBAT2L
#define CFG_DBAT2U	CFG_IBAT2U
#define CFG_DBAT3L	CFG_IBAT3L
#define CFG_DBAT3U	CFG_IBAT3U

/* Extended ROM Configuration Registers for CPLD and FPGA */
/* ERCR1&3 are used to address CS2 (chip select) and ERCR2&4 for CS3 */
#define CFG_EXTROM      1

#define CFG_ERCR1       0x81ff0007
#define CFG_ERCR2       0x81ff0007

#define CFG_ERCR3       0x00000001      /* the 1 = 8KB */
#define CFG_ERCR4       0x00010001

/*
 * For booting Linux, the board info and command line data
 * have to be in the first 8 MB of memory, since this is
 * the maximum mapped by the Linux kernel during initialization.
 */
#define CFG_BOOTMAPSZ		(8 << 20)	/* Initial Memory map for Linux */

/*-----------------------------------------------------------------------
 * FLASH organization
 */
#define CFG_MAX_FLASH_BANKS	1	/* max number of memory banks		*/
#define CFG_MAX_FLASH_SECT	64	/* max number of sectors on one chip	*/
#define CFG_DIRECT_FLASH_TFTP   1       /* Allow TFTP to program FLASH          */
#define CFG_FLASH_ERASE_TOUT	1000	/* Timeout for Flash Erase (in ms)	*/
#define CFG_FLASH_WRITE_TOUT	500	/* Timeout for Flash Write (in ms)	*/

/* Warining: environment is not EMBEDDED in the ppcboot code.
 * It's stored in NVRAM separately.
 */
#define CFG_ENV_IS_IN_FLASH	1
#define CFG_ENV_ADDR            CFG_FLASH_BASE
#define CFG_ENV_OFFSET		0x00000000      /* just below ppcboot */
#define CFG_ENV_SIZE		0x00020000	/* Total Size of Environment Sector */
#define CONFIG_ENV_OVERWRITE

/*-----------------------------------------------------------------------
 * Cache Configuration
 */
#define CFG_CACHELINE_SIZE	32	/* For MPC8240 CPU		*/
#if (CONFIG_COMMANDS & CFG_CMD_KGDB)
#  define CFG_CACHELINE_SHIFT	5	/* log base 2 of the above value */
#endif

/*
 * Internal Definitions
 *
 * Boot Flags
 */
#define BOOTFLAG_COLD		0x01	/* Normal Power-On: Boot from FLASH	*/
#define BOOTFLAG_WARM		0x02	/* Software reboot			*/

                        
/* 
            flash should look like the following
            ALL IMAGES HAVE TO BE OF BINARY FORMAT
            1 flash block size = 128KB
            
          +--------------------+
          |                    |  Image1 Frag1, max size=12 Blks
          |                    |                        
          |                    |
          |                    |
          +--------------------+
          |                    |  Image2 Frag1, max size=12 Blks
          |                    |
          +--------------------+
          |////////////////////| <!! Initial manufacuring info (to be copied out)
          +--------------------+
          |                    |  PPCBOOT, max size= 2 Blks inc room to grow
          |                    |
          +--------------------+
          |                    | SCRATCH PAD Used to unlock flash when stuck
          +--------------------+
          |                    |  Image1 Frag2, max size= 2 Blks
          +--------------------+
          |                    |  Image2 Frag2, max size= 2 Blks
          +--------------------+
          |                    |  Configuration area, max size = 1 Blk
          +--------------------+
                                  ------------------------------------
                                   Total blks = 32 Blks = 4 MBytes

          
*/
#define FLASH_START               0xffc00000    /* 0xFFFFFFFF - 4MBs */
#define FLASH_SIZE               (4*1024*1024)  /* 4MB */
#define FLASH_BLOCK_SIZE         (128*1024)     /* 128KB */
#define OLD_MANUFAC_DATA_LOC      0xffee0000
#define BOOTLOADER_LOC            0xfff00000    /* (start + 24 Blks) */
#define BOOTLOADER_RES_SIZE      (2*FLASH_BLOCK_SIZE) /*256KB reserved for bootcode*/
#define SCRATCH_PAD_LOC          (BOOTLOADER_LOC + (BOOTLOADER_RES_SIZE))
#define SCRATCH_PAD_SIZE         (FLASH_BLOCK_SIZE)   /*128KB for scratch pads*/

#define FIRST_FRAG_SIZE          (12*FLASH_BLOCK_SIZE) /*1.5MB*/
#define SECND_FRAG_SIZE          (2*FLASH_BLOCK_SIZE)  /*256KB*/

#define IMG_1_FRAG_1_LOC          FLASH_START
#define IMG_2_FRAG_1_LOC         ((IMG_1_FRAG_1_LOC)+(FIRST_FRAG_SIZE))
#define IMG_1_FRAG_2_LOC         ((SCRATCH_PAD_LOC)+(SCRATCH_PAD_SIZE))
#define IMG_2_FRAG_2_LOC         ((IMG_1_FRAG_2_LOC)+(SECND_FRAG_SIZE))

#define FLASH_CONFIG_SECTION     (IMG_2_FRAG_2_LOC+SECND_FRAG_SIZE)

#define GOOD_IMG  0x5f
#define BAD_IMG   0xf5

#define __PPCBOOT__

#endif	/* __CONFIG_H */
