#ifndef __IF_PAPI_H__
#define __IF_PAPI_H__

#include <util/sibyte_types.h>
#include <papi/aruba.h>
#include <papi/MHApi.h>
#include <msgHandler/msgHandler.h>
#include <sys/syslog.h>
#include <syslog/syslogutil.h>
#include <syslog/arubalog.h>
#include <util/sibyte_msg.h>
#include <util/util.h>
#include <dispatcher/dispatcher.h>

#define FRAME_ETYPE_TAG   0x8100

#define PPPOE_INTF_NAME "eth1"

#define FRAME_MACCMP(MAC1, MAC2) \
        ((((uint16_t *)(MAC1))[0] ^ ((uint16_t *)(MAC2))[0]) | \
         (((uint16_t *)(MAC1))[1] ^ ((uint16_t *)(MAC2))[1]) | \
         (((uint16_t *)(MAC1))[2] ^ ((uint16_t *)(MAC2))[2]))

#define PPPOE_PAPI_TIMEOUT               4000
#define PPPOE_PAPI_RETRIES               5
#define PPPOE_PAPI_MESSAGE_LEN           1024
#define PPPOE_PAPI_NUM_OUTSTANDING_MSGS  10

#define PPPOE_LCP_ECHO_INTERVAL          60000 // 60 secs
#define PPPOE_LCP_MAX_ECHO_FAILURES      5

#define IPCP_CONFREQ        1    /* Configuration Request */
#define IPCP_CONFACK        2    /* Configuration Ack */
#define IPCP_TERMREQ        5    /* Termination Request */
#define IPCP_TERMACK        6    /* Termination Ack */

#define LCP_TERMREQ         5    /* Termination Request */
#define LCP_TERMACK         6    /* Termination Ack */
#define LCP_ECHOREQ         9    /* Echo Request */
#define LCP_ECHOREP         10   /* Echo Reply */

extern int  pppoe_papi_init(void);
extern void pppoe_papi_close(void);

#endif /* __IF_PAPI_H__ */
