#ifndef SYSLOGMISC
#define SYSLOGMISC

struct code {
        char       *c_name;
        int        c_val;
};

typedef struct debugInfo_s {
        char*       dName; // Keyword used in CLI debug command.
        int         dVal;  // An ID of the debug command. Used in the debugLog command. 
        char*       desc;  // This is used as the help string.
}debugInfo_t;

typedef struct facInfo_s{
        char*        facName; //Keyword in the CLI commands.
        int          facVal;  // A unique Facility ID.
        int          service; // PAPI Service number for the application
        char*        desc;    // Help string used in the CLI.
        debugInfo_t* dInfo;   // Debug Info it present.
}facInfo_t;

extern struct code lglvlNames[];
extern facInfo_t   arubaFacilities[];
extern debugInfo_t wmsDebugInfo[];
#ifdef ARUBA_ENABLE_CERTMGR
extern debugInfo_t certDebugInfo[];
#endif
extern debugInfo_t fpcliDebugInfo[];
#ifndef NEW_MOBILITY
extern debugInfo_t mmDebugInfo[];
extern debugInfo_t masDebugInfo[];
extern debugInfo_t mobDebugInfo[];
#else
extern debugInfo_t mipDebugInfo[];
#endif
extern debugInfo_t vpdnDebugInfo[];
extern debugInfo_t ikeDebugInfo[];
extern debugInfo_t authDebugInfo[];
extern debugInfo_t userdbDebugInfo[];
extern debugInfo_t licenseDebugInfo[];
extern debugInfo_t stmDebugInfo[];
extern debugInfo_t sapmDebugInfo[];
extern debugInfo_t fpappsDebugInfo[];
extern debugInfo_t platformDebugInfo[];
extern debugInfo_t userDebugInfo[];
extern debugInfo_t intuserDebugInfo[];
extern debugInfo_t aaaDebugInfo[];
extern debugInfo_t snmpDebugInfo[];
extern debugInfo_t dhcpdDebugInfo[];
extern debugInfo_t nannyDebugInfo[];
extern debugInfo_t publisherDebugInfo[];
extern debugInfo_t esiDebugInfo[];
extern debugInfo_t adsDebugInfo[];
extern debugInfo_t pimDebugInfo[];
extern debugInfo_t arubafilterDebugInfo[];
extern debugInfo_t pppoedDebugInfo[];

#define ARUBA_LOG_FACILITY_START        24  /* The Maximum defined for the standard
                                             * SYSYLOG is 23
                                             */
#define LOG_IKE         ((ARUBA_LOG_FACILITY_START + 0) << 3)
#define LOG_L2TP        ((ARUBA_LOG_FACILITY_START + 1) << 3)
#define LOG_PPTP        ((ARUBA_LOG_FACILITY_START + 2) << 3)
#define LOG_STM         ((ARUBA_LOG_FACILITY_START + 3) << 3)
#define LOG_WMS         ((ARUBA_LOG_FACILITY_START + 4) << 3)
#define LOG_PLATFORM    ((ARUBA_LOG_FACILITY_START + 5) << 3)
#define LOG_NANNY       ((ARUBA_LOG_FACILITY_START + 6) << 3)
#undef LOG_ARUBA_AUTH /* hack to clean up warnings */
#define LOG_ARUBA_AUTH  ((ARUBA_LOG_FACILITY_START + 7) << 3)
#define LOG_USERDB      ((ARUBA_LOG_FACILITY_START + 8) << 3)
#define LOG_SAPM        ((ARUBA_LOG_FACILITY_START + 9) << 3)
#define LOG_FPAPPS      ((ARUBA_LOG_FACILITY_START + 10) << 3)
#define LOG_SUSER       ((ARUBA_LOG_FACILITY_START + 11) << 3)
#define LOG_INTUSER     ((ARUBA_LOG_FACILITY_START + 12) << 3)
#define LOG_AAA         ((ARUBA_LOG_FACILITY_START + 13) << 3)
#define LOG_TRAFFIC     ((ARUBA_LOG_FACILITY_START + 14) << 3)
#define LOG_DHCPD       ((ARUBA_LOG_FACILITY_START + 15) << 3)
#define LOG_PUBLISHER   ((ARUBA_LOG_FACILITY_START + 16) << 3)
#ifndef NEW_MOBILITY
#define LOG_MMGR        ((ARUBA_LOG_FACILITY_START + 17) << 3)
#define LOG_MOB         ((ARUBA_LOG_FACILITY_START + 18) << 3)
#define LOG_MAS         ((ARUBA_LOG_FACILITY_START + 19) << 3)
#define LOG_ESI         ((ARUBA_LOG_FACILITY_START + 20) << 3)
#define LOG_PIM         ((ARUBA_LOG_FACILITY_START + 21) << 3)
#define LOG_SNMP        ((ARUBA_LOG_FACILITY_START + 22) << 3)
#define LOG_ADS         ((ARUBA_LOG_FACILITY_START + 23) << 3)
#define LOG_ARUBAFILTER ((ARUBA_LOG_FACILITY_START + 24) << 3)
#define LOG_LICENSEMGR  ((ARUBA_LOG_FACILITY_START + 25) << 3)
#define LOG_FGT         ((ARUBA_LOG_FACILITY_START + 26) << 3)
#define LOG_HTTPD       ((ARUBA_LOG_FACILITY_START + 27) << 3)
#define LOG_PPPOED      ((ARUBA_LOG_FACILITY_START + 28) << 3)
#else
#define LOG_MIP         ((ARUBA_LOG_FACILITY_START + 17) << 3)
#define LOG_ESI         ((ARUBA_LOG_FACILITY_START + 18) << 3)
#define LOG_PIM         ((ARUBA_LOG_FACILITY_START + 19) << 3)
#define LOG_SNMP         ((ARUBA_LOG_FACILITY_START + 20) << 3)
#define LOG_ADS         ((ARUBA_LOG_FACILITY_START + 21) << 3)
#define LOG_ARUBAFILTER ((ARUBA_LOG_FACILITY_START + 22) << 3)
#define LOG_LICENSEMGR  ((ARUBA_LOG_FACILITY_START + 23) << 3)
#define LOG_FGT         ((ARUBA_LOG_FACILITY_START + 24) << 3)
#define LOG_HTTPD       ((ARUBA_LOG_FACILITY_START + 25) << 3)
#define LOG_PPPOED      ((ARUBA_LOG_FACILITY_START + 26) << 3)
#endif

#ifndef NEW_MOBILITY
#define LOG_NARUBAFACILITIES        29
#else
#define LOG_NARUBAFACILITIES        27
#endif

// Certmgr can't be re-enabled now.
#if 0
#ifdef ARUBA_ENABLE_CERTMGR
#define LOG_CERT     ((ARUBA_LOG_FACILITY_START + 11) << 3)
#endif
/* This is 20 instead of 21 because CERTMGR is commmented out */
#ifdef ARUBA_ENABLE_CERTMGR
#define LOG_NARUBAFACILITIES        23
#else
#define LOG_NARUBAFACILITIES        22
#endif
#endif



/* Debug ID's for FPCLI */
#define DEBUG_FPCLI              1
#define DEBUG_FPCLI_EMWEB        2

/* Debug ID's for FPAPPS */
#define DEBUG_FPAPPS_NIM         1
#define DEBUG_FPAPPS_LAG         2
#define DEBUG_FPAPPS_VRRP        3
#define DEBUG_FPAPPS_DOT1D       4
#define DEBUG_FPAPPS_DOT1Q       5

#define DEBUG_PLATFORM_ALL       1
#define DEBUG_USER_ALL           1
#define DEBUG_INTUSER_ALL        1
#define DEBUG_AAA_ALL            1
#define DEBUG_SNMP_ALL           1
#define DEBUG_NANNY_ALL          1
#define DEBUG_PUBLISHER_ALL      1
#define DEBUG_PPPOE_ALL          1

/* Debug ID's for Mobility */
#define DEBUG_DHCP      1
#define DEBUG_DATAPATH  2
#define DEBUG_MESSAGES  3
#define DEBUG_STATES    4
#define DEBUG_TIMERS    5
#define DEBUG_API       6
#define DEBUG_INFO      7
#define DEBUG_FLAG      8
#define DEBUG_USERS     9
#define DEBUG_PACKETS   10
#define DEBUG_CONFIG    11
#define DEBUG_REG       12
#define DEBUG_QUERIES   13
#define DEBUG_CACHE     14

/* Debug ID's for VPDN - L2TP and PPTP */
#define DEBUG_VPDN_PACKETS     1
#define DEBUG_PPP_PACKETS      2

/* Debug ID's for VPDN - L2TP and PPTP */
#define DEBUG_ISAKMP_PACKETS      1
#define DEBUG_IPSEC_PACKETS       2

/* Debug ID's for DHCPD */
#define DEBUG_DHCPD_PKTS     1
#define DEBUG_DHCPD_RELAY    2

/* debug ID's for Auth */
#define DEBUG_AUTH_ACL                1
#define DEBUG_AUTH_AAL                2
#define DEBUG_AUTH_MOB                3
#define DEBUG_AUTH_MSG                4
#define DEBUG_AUTH_CFG                5
#define DEBUG_AUTH_USER               6
#define DEBUG_AUTH_DOT1X_SM           7
#define DEBUG_AUTH_DOT1X_PKTTRACE     8
#define DEBUG_AUTH_DOT1X_SAPM_MSG     9
#define DEBUG_AUTH_DOT1X_EAPOL        10
#define DEBUG_AUTH_DOT1X_RADIUS       11
#define DEBUG_AUTH_DOT1X_SAP_MGT      12
#define DEBUG_AUTH_DOT1X_KEY_MGT      13
#define DEBUG_AUTH_DOT1X_CFG          14
#define DEBUG_AUTH_KRB_PACKETS        15
#define DEBUG_AUTH_SNMP               16
#define DEBUG_AUTH_RADIUS             17
#define DEBUG_AUTH_TACACS             18
#define DEBUG_AUTH_DHCP               19

/* debug id for stm */
#define DEBUG_STM_ALL              1

/* debug id for esi */
#define DEBUG_ESI_ALL              1

/* debug id for ads */
#define DEBUG_ADS_ALL              1

/* debug id for pim */
#define DEBUG_PIM_ALL              1

/* debug id for userdb */
#define DEBUG_USERDB_ALL           1

/* debug id for license */
#define DEBUG_LICENSEMGR_ALL       1

/* debug id for wms */
#define DEBUG_WMS_ALL              1

#ifdef ARUBA_ENABLE_CERTMGR
/* debug id for cert */
#define DEBUG_CERT_ALL             1
#endif

/* debug id for SAPM */
#define DEBUG_SAPM_ALL             1

/* debug id for dbsync */
#define DEBUG_DBSYNC_ALL           1

/* debug id for MIP */
#define DEBUG_MIP_HA_PROTOCOL         1
#define DEBUG_MIP_FA_PROTOCOL         2
#define DEBUG_MIP_STATES              3
#define DEBUG_MIP_SECURITY            4
#define DEBUG_MIP_MESSAGES            5
#define DEBUG_MIP_CONFIG              6
#define DEBUG_MIP_PROXY               7
#define DEBUG_MIP_RRV_PROTOCOL        8
#define DEBUG_MIP_PROXY_DHCP          9
#define DEBUG_MIP_DATAPATH            10

/* debug id for Aruba Filter */
#define DEBUG_ARUBAFILTER_ALL           1

/* debug id for apache */
#define DEBUG_HTTPD _ALL           1

extern void makeFacNameList();
extern char* convertCase(char* data);
#endif /* SYSLOGMISC */
